// Created by Giseldah

// Floating point numbers bring errors into the calculation, both inside the Lotro-client and in this function collection. This is why a 100% match with the stats in Lotro is impossible.
// Anyway, to compensate for some errors, we use a calculation deviation correction value. This makes for instance 24.49999999 round to 25, as it's assumed that 24.5 was intended as outcome of a formula.
var DblCalcDev = 0.00000001;

function CalcStat(SName, SLvl, SParam)
{
	var SN = SName.trim().toUpperCase();

	var L = SLvl;
	var N = 1;
	var C = "";

	if (typeof SParam !== "undefined") {
		if (typeof SParam === "number" )
			N = SParam;
		else
			C = SParam;
	}

	if (SN < "MINSTRELCDFATETOCRITHIT") {
		if (SN < "CRFFATE") {
			if (SN < "BURGLARCDFATETORESIST") {
				if (SN < "BEORNINGCDVITALITYTORESIST") {
					if (SN < "BATPROMRNGDMGP") {
						if (SN < "ARMPROG") {
							if (SN < "ADJTRAITPROGMAIN") {
								if (SN < "ADJITEMPROGMORREG") {
									if (SN < "ADJITEMPROGFOODRESIST") {
										if (SN == "-VERSION") {
											return "1.3.2f";
										} else {
											return 0;
										}
									} else if (SN > "ADJITEMPROGFOODRESIST") {
										if (SN > "ADJITEMPROGMAIN") {
											if (SN == "ADJITEMPROGMORALE") {
												if (L-DblCalcDev <= 350) {
													return 1;
												} else if (L-DblCalcDev <= 399) {
													return LinFmod(1,CalcStat("ItemProg",350,N),0.8*CalcStat("ItemProg",399,N),350,399,L)/CalcStat("ItemProg",L,N);
												} else if (L-DblCalcDev <= 400) {
													return LinFmod(1,0.8*CalcStat("ItemProg",399,N),(22/35)*CalcStat("ItemProg",400,N),399,400,L)/CalcStat("ItemProg",L,N);
												} else if (L-DblCalcDev <= 449) {
													return LinFmod(1,(22/35)*CalcStat("ItemProg",400,N),(20/35)*CalcStat("ItemProg",449,N),400,449,L)/CalcStat("ItemProg",L,N);
												} else if (L-DblCalcDev <= 450) {
													return LinFmod(1,(20/35)*CalcStat("ItemProg",449,N),(99/189)*CalcStat("ItemProg",450,N),449,450,L)/CalcStat("ItemProg",L,N);
												} else if (L-DblCalcDev <= 499) {
													return LinFmod(1,(99/189)*CalcStat("ItemProg",450,N),(20/35)*CalcStat("ItemProg",499,N),450,499,L)/CalcStat("ItemProg",L,N);
												} else {
													return 20/35;
												}
											} else {
												return 0;
											}
										} else if (SN == "ADJITEMPROGMAIN") {
											if (L-DblCalcDev <= 79) {
												return LinFmod(1,CalcStat("ItemProg",1,N),0.8*CalcStat("ItemProg",79,N),1,79,L)/CalcStat("ItemProg",L,N);
											} else if (L-DblCalcDev <= 200) {
												return 0.8;
											} else if (L-DblCalcDev <= 225) {
												return LinFmod(1,0.8*CalcStat("ItemProg",200,N),CalcStat("ItemProg",225,N),200,225,L)/CalcStat("ItemProg",L,N);
											} else if (L-DblCalcDev <= 400) {
												return 1;
											} else if (L-DblCalcDev <= 449) {
												return LinFmod(1,CalcStat("ItemProg",400,N),0.9*CalcStat("ItemProg",449,N),400,449,L)/CalcStat("ItemProg",L,N);
											} else {
												return 0.9;
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 400) {
											return 1;
										} else if (L-DblCalcDev <= 449) {
											return LinFmod(1,CalcStat("ItemProg",400,N),0.9*CalcStat("ItemProg",449,N),400,449,L)/CalcStat("ItemProg",L,N);
										} else {
											return 0.9;
										}
									}
								} else if (SN > "ADJITEMPROGMORREG") {
									if (SN < "ADJITEMPROGPOWREG") {
										if (SN == "ADJITEMPROGPOWER") {
											if (L-DblCalcDev <= 349) {
												return 1;
											} else if (L-DblCalcDev <= 350) {
												return LinFmod(1,CalcStat("ItemProg",349,N),(120/110)*CalcStat("ItemProg",350,N),349,350,L)/CalcStat("ItemProg",L,N);
											} else if (L-DblCalcDev <= 399) {
												return LinFmod(1,(120/110)*CalcStat("ItemProg",350,N),0.8*CalcStat("ItemProg",399,N),350,399,L)/CalcStat("ItemProg",L,N);
											} else if (L-DblCalcDev <= 400) {
												return LinFmod(1,0.8*CalcStat("ItemProg",399,N),(22/35)*CalcStat("ItemProg",400,N),399,400,L)/CalcStat("ItemProg",L,N);
											} else if (L-DblCalcDev <= 449) {
												return LinFmod(1,(22/35)*CalcStat("ItemProg",400,N),(63/189)*CalcStat("ItemProg",449,N),400,449,L)/CalcStat("ItemProg",L,N);
											} else if (L-DblCalcDev <= 450) {
												return LinFmod(1,(63/189)*CalcStat("ItemProg",449,N),(55/189)*CalcStat("ItemProg",450,N),449,450,L)/CalcStat("ItemProg",L,N);
											} else if (L-DblCalcDev <= 499) {
												return LinFmod(1,(55/189)*CalcStat("ItemProg",450,N),(23/126)*CalcStat("ItemProg",499,N),450,499,L)/CalcStat("ItemProg",L,N);
											} else {
												return 23/126;
											}
										} else {
											return 0;
										}
									} else if (SN > "ADJITEMPROGPOWREG") {
										if (SN > "ADJITEMPROGRATINGS") {
											if (SN == "ADJITEMPROGVITALITY") {
												if (L-DblCalcDev <= 349) {
													return 1;
												} else if (L-DblCalcDev <= 350) {
													return LinFmod(1,CalcStat("ItemProg",349,N),(95/99)*CalcStat("ItemProg",350,N),349,350,L)/CalcStat("ItemProg",L,N);
												} else if (L-DblCalcDev <= 399) {
													return LinFmod(1,(95/99)*CalcStat("ItemProg",350,N),(38/45)*CalcStat("ItemProg",399,N),350,399,L)/CalcStat("ItemProg",L,N);
												} else if (L-DblCalcDev <= 400) {
													return LinFmod(1,(38/45)*CalcStat("ItemProg",399,N),(76/105)*CalcStat("ItemProg",400,N),399,400,L)/CalcStat("ItemProg",L,N);
												} else if (L-DblCalcDev <= 449) {
													return LinFmod(1,(76/105)*CalcStat("ItemProg",400,N),(38/63)*CalcStat("ItemProg",449,N),400,449,L)/CalcStat("ItemProg",L,N);
												} else {
													return 38/63;
												}
											} else {
												return 0;
											}
										} else if (SN == "ADJITEMPROGRATINGS") {
											if (L-DblCalcDev <= 79) {
												return LinFmod(1,CalcStat("ItemProg",1,N),0.8*CalcStat("ItemProg",79,N),1,79,L)/CalcStat("ItemProg",L,N);
											} else if (L-DblCalcDev <= 200) {
												return 0.8;
											} else if (L-DblCalcDev <= 225) {
												return LinFmod(1,0.8*CalcStat("ItemProg",200,N),CalcStat("ItemProg",225,N),200,225,L)/CalcStat("ItemProg",L,N);
											} else if (L-DblCalcDev <= 400) {
												return 1;
											} else if (L-DblCalcDev <= 449) {
												return LinFmod(1,CalcStat("ItemProg",400,N),0.9*CalcStat("ItemProg",449,N),400,449,L)/CalcStat("ItemProg",L,N);
											} else {
												return 0.9;
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 349) {
											return 1;
										} else if (L-DblCalcDev <= 350) {
											return LinFmod(1,CalcStat("ItemProg",349,N),(120/110)*CalcStat("ItemProg",350,N),349,350,L)/CalcStat("ItemProg",L,N);
										} else if (L-DblCalcDev <= 399) {
											return LinFmod(1,(120/110)*CalcStat("ItemProg",350,N),0.8*CalcStat("ItemProg",399,N),350,399,L)/CalcStat("ItemProg",L,N);
										} else if (L-DblCalcDev <= 400) {
											return LinFmod(1,0.8*CalcStat("ItemProg",399,N),(22/35)*CalcStat("ItemProg",400,N),399,400,L)/CalcStat("ItemProg",L,N);
										} else if (L-DblCalcDev <= 449) {
											return LinFmod(1,(22/35)*CalcStat("ItemProg",400,N),(63/189)*CalcStat("ItemProg",449,N),400,449,L)/CalcStat("ItemProg",L,N);
										} else if (L-DblCalcDev <= 450) {
											return LinFmod(1,(63/189)*CalcStat("ItemProg",449,N),(55/189)*CalcStat("ItemProg",450,N),449,450,L)/CalcStat("ItemProg",L,N);
										} else if (L-DblCalcDev <= 499) {
											return LinFmod(1,(55/189)*CalcStat("ItemProg",450,N),(23/126)*CalcStat("ItemProg",499,N),450,499,L)/CalcStat("ItemProg",L,N);
										} else {
											return 23/126;
										}
									}
								} else {
									if (L-DblCalcDev <= 79) {
										return LinFmod(1,CalcStat("ItemProg",1,N),1.04*CalcStat("ItemProg",79,N),1,79,L)/CalcStat("ItemProg",L,N);
									} else if (L-DblCalcDev <= 80) {
										return LinFmod(1,1.04*CalcStat("ItemProg",79,N),CalcStat("ItemProg",80,N),79,80,L)/CalcStat("ItemProg",L,N);
									} else if (L-DblCalcDev <= 349) {
										return 1;
									} else if (L-DblCalcDev <= 350) {
										return LinFmod(1,CalcStat("ItemProg",349,N),(95/99)*CalcStat("ItemProg",350,N),349,350,L)/CalcStat("ItemProg",L,N);
									} else if (L-DblCalcDev <= 399) {
										return LinFmod(1,(95/99)*CalcStat("ItemProg",350,N),(38/45)*CalcStat("ItemProg",399,N),350,399,L)/CalcStat("ItemProg",L,N);
									} else if (L-DblCalcDev <= 400) {
										return LinFmod(1,(38/45)*CalcStat("ItemProg",399,N),(76/105)*CalcStat("ItemProg",400,N),399,400,L)/CalcStat("ItemProg",L,N);
									} else if (L-DblCalcDev <= 449) {
										return LinFmod(1,(76/105)*CalcStat("ItemProg",400,N),(38/63)*CalcStat("ItemProg",449,N),400,449,L)/CalcStat("ItemProg",L,N);
									} else {
										return 38/63;
									}
								}
							} else if (SN > "ADJTRAITPROGMAIN") {
								if (SN < "ARMCATMP") {
									if (SN < "ADJTRAITPROGVITALITY") {
										if (SN == "ADJTRAITPROGRATINGS") {
											if (L-DblCalcDev <= 105) {
												return LinFmod(1,CalcStat("TraitProg",1,N),0.8*CalcStat("TraitProg",105,N),1,105,L)/CalcStat("TraitProg",L,N);
											} else if (L-DblCalcDev <= 106) {
												return LinFmod(1,0.8*CalcStat("TraitProg",105,N),CalcStat("TraitProg",106,N),105,106,L)/CalcStat("TraitProg",L,N);
											} else if (L-DblCalcDev <= 121) {
												return 1;
											} else if (L-DblCalcDev <= 130) {
												return LinFmod(1,CalcStat("TraitProg",121,N),0.9*CalcStat("TraitProg",130,N),121,130,L)/CalcStat("TraitProg",L,N);
											} else {
												return 0.9;
											}
										} else {
											return 0;
										}
									} else if (SN > "ADJTRAITPROGVITALITY") {
										if (SN > "AGILITY") {
											if (SN == "AGILITYT") {
												return CalcStat("MainT",L,N);
											} else {
												return 0;
											}
										} else if (SN == "AGILITY") {
											return CalcStat("Main",L,N);
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 115) {
											return 1;
										} else if (L-DblCalcDev <= 120) {
											return LinFmod(1,CalcStat("TraitVitalityProg",115,N),0.8*CalcStat("TraitVitalityProg",120,N),115,120,L)/CalcStat("TraitVitalityProg",L,N);
										} else if (L-DblCalcDev <= 121) {
											return LinFmod(1,0.8*CalcStat("TraitVitalityProg",120,N),(24/35)*CalcStat("TraitVitalityProg",121,N),120,121,L)/CalcStat("TraitVitalityProg",L,N);
										} else if (L-DblCalcDev <= 130) {
											return LinFmod(1,(24/35)*CalcStat("TraitVitalityProg",121,N),(38/63)*CalcStat("TraitVitalityProg",130,N),121,130,L)/CalcStat("TraitVitalityProg",L,N);
										} else {
											return 38/63;
										}
									}
								} else if (SN > "ARMCATMP") {
									if (SN < "ARMOURLOW") {
										if (SN == "ARMOUR") {
											return FloorDbl(CalcStat("ArmourRaw",L,C));
										} else {
											return 0;
										}
									} else if (SN > "ARMOURLOW") {
										if (SN > "ARMOURLOWRAW") {
											if (SN == "ARMOURRAW") {
												return CalcStat("ArmTypeMP",ArmCodeIndex(C,2))*CalcStat("ArmQtyMP",ArmCodeIndex(C,3),ArmCodeIndex(C,2))*CalcStat("ArmCatMP",ArmCodeIndex(C,1))*CalcStat("ArmProgMP",ArmCodeIndex(C,1),L);
											} else {
												return 0;
											}
										} else if (SN == "ARMOURLOWRAW") {
											return CalcStat("ArmTypeMP",ArmCodeIndex(C,2))*CalcStat("ArmQtyLowMP",ArmCodeIndex(C,2))*CalcStat("ArmCatMP",ArmCodeIndex(C,1))*CalcStat("ArmProgMP",ArmCodeIndex(C,1),L);
										} else {
											return 0;
										}
									} else {
										return FloorDbl(CalcStat("ArmourLowRaw",L,C));
									}
								} else {
									if (L-DblCalcDev <= 0) {
										return 0;
									} else if (L-DblCalcDev <= 1) {
										return 14877/12350;
									} else if (L-DblCalcDev <= 2) {
										return 12415/12350;
									} else {
										return 9880/12350;
									}
								}
							} else {
								if (L-DblCalcDev <= 105) {
									return LinFmod(1,CalcStat("TraitProg",1,N),0.8*CalcStat("TraitProg",105,N),1,105,L)/CalcStat("TraitProg",L,N);
								} else if (L-DblCalcDev <= 106) {
									return LinFmod(1,0.8*CalcStat("TraitProg",105,N),CalcStat("TraitProg",106,N),105,106,L)/CalcStat("TraitProg",L,N);
								} else if (L-DblCalcDev <= 121) {
									return 1;
								} else if (L-DblCalcDev <= 130) {
									return LinFmod(1,CalcStat("TraitProg",121,N),0.9*CalcStat("TraitProg",130,N),121,130,L)/CalcStat("TraitProg",L,N);
								} else {
									return 0.9;
								}
							}
						} else if (SN > "ARMPROG") {
							if (SN < "AUDACITYMELDMGP") {
								if (SN < "ARMQTYLOWMP") {
									if (SN < "ARMQTYCOMMMP") {
										if (SN == "ARMPROGMP") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else if (L-DblCalcDev <= 1) {
												return CalcStat("ArmProg",N,CalcStat("ProgBMitHeavy",L));
											} else if (L-DblCalcDev <= 2) {
												return CalcStat("ArmProg",N,CalcStat("ProgBMitMedium",L));
											} else {
												return CalcStat("ArmProg",N,CalcStat("ProgBMitLight",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "ARMQTYCOMMMP") {
										if (SN > "ARMQTYINCOMPMP") {
											if (SN == "ARMQTYLEGENDMP") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return DataTableValue([100,100,100,100,100,100.2,100,100],L);
												}
											} else {
												return 0;
											}
										} else if (SN == "ARMQTYINCOMPMP") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return DataTableValue([280/3,280/3,95,95,94,94.8,95,95],L);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return DataTableValue([220/3,220/3,80,80,76,80.4,80,70],L);
										}
									}
								} else if (SN > "ARMQTYLOWMP") {
									if (SN < "ARMQTYRAREMP") {
										if (SN == "ARMQTYMP") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else if (L-DblCalcDev <= 1) {
												return CalcStat("ArmQtyCommMP",N);
											} else if (L-DblCalcDev <= 2) {
												return CalcStat("ArmQtyUncomMP",N);
											} else if (L-DblCalcDev <= 3) {
												return CalcStat("ArmQtyRareMP",N);
											} else if (L-DblCalcDev <= 4) {
												return CalcStat("ArmQtyIncompMP",N);
											} else {
												return CalcStat("ArmQtyLegendMP",N);
											}
										} else {
											return 0;
										}
									} else if (SN > "ARMQTYRAREMP") {
										if (SN > "ARMQTYUNCOMMP") {
											if (SN == "ARMTYPEMP") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return DataTableValue([9,9,18.75,30,15,25,12,37.5],L);
												}
											} else {
												return 0;
											}
										} else if (SN == "ARMQTYUNCOMMP") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return DataTableValue([220/3,220/3,85,85,82,85.2,85,75],L);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return DataTableValue([260/3,260/3,90,90,88,90,90,80],L);
										}
									}
								} else {
									if (L-DblCalcDev <= 0) {
										return 0;
									} else {
										return DataTableValue([50,50,50,50,50,49.8,50,50],L);
									}
								}
							} else if (SN > "AUDACITYMELDMGP") {
								if (SN < "AUDACITYTACREDP") {
									if (SN < "AUDACITYRNGDMGP") {
										if (SN == "AUDACITYMELREDP") {
											return -0.3;
										} else {
											return 0;
										}
									} else if (SN > "AUDACITYRNGDMGP") {
										if (SN > "AUDACITYRNGREDP") {
											if (SN == "AUDACITYTACDMGP") {
												if (L-DblCalcDev <= 120) {
													return 0.01*L;
												} else {
													return CalcStat("AudacityTacDmgP",L-FloorDbl((L-1)/5)*5+115);
												}
											} else {
												return 0;
											}
										} else if (SN == "AUDACITYRNGREDP") {
											return -0.3;
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 120) {
											return 0.01*L;
										} else {
											return CalcStat("AudacityRngDmgP",L-FloorDbl((L-1)/5)*5+115);
										}
									}
								} else if (SN > "AUDACITYTACREDP") {
									if (SN < "BATPROMMELDMGP") {
										if (SN > "AWARDLVLTOILVL") {
											if (SN == "BALANCEOFMANAVOID") {
												if (L-DblCalcDev <= 105) {
													return RoundDbl(8.08*L);
												} else if (L-DblCalcDev <= 115) {
													return RoundDbl(LinFmod(CalcStat("BalanceOfManAvoid",105),2,4,106,115,L,-1));
												} else if (L-DblCalcDev <= 116) {
													return RoundDbl(ExpFmod(CalcStat("BalanceOfManAvoid",115),116,20,L));
												} else if (L-DblCalcDev <= 120) {
													return RoundDbl(ExpFmod(CalcStat("BalanceOfManAvoid",116),117,5.5015,L));
												} else if (L-DblCalcDev <= 121) {
													return RoundDbl(ExpFmod(CalcStat("BalanceOfManAvoid",120),121,20,L));
												} else if (L-DblCalcDev <= 125) {
													return RoundDbl(ExpFmod(CalcStat("BalanceOfManAvoid",121),122,5.5015,L));
												} else if (L-DblCalcDev <= 126) {
													return RoundDbl(ExpFmod(CalcStat("BalanceOfManAvoid",125),126,20,L));
												} else {
													return RoundDbl(ExpFmod(CalcStat("BalanceOfManAvoid",126),127,5.5015,L));
												}
											} else {
												return 0;
											}
										} else if (SN == "AWARDLVLTOILVL") {
											if (L-DblCalcDev <= 4) {
												return 1;
											} else if (L-DblCalcDev <= 50) {
												return L-4;
											} else if (L-DblCalcDev <= 54) {
												return 51;
											} else if (L-DblCalcDev <= 75) {
												return L-4;
											} else if (L-DblCalcDev <= 94) {
												return 5*L-304;
											} else if (L-DblCalcDev <= 95) {
												return 173;
											} else if (L-DblCalcDev <= 100) {
												return 5*L-304;
											} else if (L-DblCalcDev <= 101) {
												return 197;
											} else if (L-DblCalcDev <= 104) {
												return 4*L-206;
											} else if (L-DblCalcDev <= 105) {
												return 218;
											} else if (L-DblCalcDev <= 115) {
												return RoundDbl(2.88*L-16.8);
											} else if (L-DblCalcDev <= 120) {
												return 5*L-245;
											} else if (L-DblCalcDev <= 121) {
												return 385;
											} else {
												return RoundDbl((14/15)*L+4081/15);
											}
										} else {
											return 0;
										}
									} else if (SN > "BATPROMMELDMGP") {
										if (SN > "BATPROMMORALEP") {
											if (SN == "BATPROMPOWERP") {
												if (L-DblCalcDev <= 8) {
													return RoundDbl(0.012*L-0.006,2);
												} else {
													return RoundDbl(0.015*L-0.0275,2);
												}
											} else {
												return 0;
											}
										} else if (SN == "BATPROMMORALEP") {
											if (L-DblCalcDev <= 8) {
												return RoundDbl(0.012*L-0.006,2);
											} else {
												return RoundDbl(0.015*L-0.0275,2);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 8) {
											return RoundDbl(0.009*L-0.0035,2);
										} else {
											return RoundDbl(0.0115*L-0.0275,2);
										}
									}
								} else {
									return -0.3;
								}
							} else {
								if (L-DblCalcDev <= 120) {
									return 0.01*L;
								} else {
									return CalcStat("AudacityMelDmgP",L-FloorDbl((L-1)/5)*5+115);
								}
							}
						} else {
							if (L-DblCalcDev <= 400) {
								return CalcStat("ItemProg",L,N)/CalcStat("StdProg",75,N);
							} else if (L-DblCalcDev <= 449) {
								return LinFmod(1,CalcStat("ItemProg",400,N)/CalcStat("StdProg",75,N),0.9*(CalcStat("ItemProg",449,N)/CalcStat("StdProg",75,N)),400,449,L);
							} else {
								return 0.9*(CalcStat("ItemProg",L,N)/CalcStat("StdProg",75,N));
							}
						}
					} else if (SN > "BATPROMRNGDMGP") {
						if (SN < "BEORNINGCDBASENCPR") {
							if (SN < "BEORNINGCDARMOURTOPHYMIT") {
								if (SN < "BEOFERALPRESFATE") {
									if (SN < "BATTLELOREMAS") {
										if (SN == "BATPROMTACDMGP") {
											if (L-DblCalcDev <= 8) {
												return RoundDbl(0.009*L-0.0035,2);
											} else {
												return RoundDbl(0.0115*L-0.0275,2);
											}
										} else {
											return 0;
										}
									} else if (SN > "BATTLELOREMAS") {
										if (SN > "BATTLELOREPHYMAS") {
											if (SN == "BATTLELORETACMAS") {
												return CalcStat("BattleLoreMas",L);
											} else {
												return 0;
											}
										} else if (SN == "BATTLELOREPHYMAS") {
											return CalcStat("BattleLoreMas",L);
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 105) {
											return CalcStat("RatMastery",L,2.5);
										} else if (L-DblCalcDev <= 119) {
											return CalcStat("RatMasteryT",L,1.2);
										} else if (L-DblCalcDev <= 120) {
											return CalcStat("RatMasteryT",L,1.6);
										} else if (L-DblCalcDev <= 129) {
											return CalcStat("RatMasteryT",L,1.2);
										} else {
											return CalcStat("RatMasteryT",L,1.6);
										}
									}
								} else if (SN > "BEOFERALPRESFATE") {
									if (SN < "BEORNINGCDAGILITYTOEVADE") {
										if (SN == "BEORNINGCDAGILITYTOCRITHIT") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "BEORNINGCDAGILITYTOEVADE") {
										if (SN > "BEORNINGCDAGILITYTOPHYMAS") {
											if (SN == "BEORNINGCDARMOURTOOFMIT") {
												return 0.2;
											} else {
												return 0;
											}
										} else if (SN == "BEORNINGCDAGILITYTOPHYMAS") {
											return 2;
										} else {
											return 0;
										}
									} else {
										return 2;
									}
								} else {
									return CalcStat("CptCoVMain",L);
								}
							} else if (SN > "BEORNINGCDARMOURTOPHYMIT") {
								if (SN < "BEORNINGCDBASEICMR") {
									if (SN < "BEORNINGCDARMOURTYPE") {
										if (SN == "BEORNINGCDARMOURTOTACMIT") {
											return 0.2;
										} else {
											return 0;
										}
									} else if (SN > "BEORNINGCDARMOURTYPE") {
										if (SN > "BEORNINGCDBASEAGILITY") {
											if (SN == "BEORNINGCDBASEFATE") {
												return CalcStat("ClassBaseMainJ",L);
											} else {
												return 0;
											}
										} else if (SN == "BEORNINGCDBASEAGILITY") {
											return CalcStat("ClassBaseMainA",L);
										} else {
											return 0;
										}
									} else {
										return 3;
									}
								} else if (SN > "BEORNINGCDBASEICMR") {
									if (SN < "BEORNINGCDBASEMIGHT") {
										if (SN == "BEORNINGCDBASEICPR") {
											return 0;
										} else {
											return 0;
										}
									} else if (SN > "BEORNINGCDBASEMIGHT") {
										if (SN > "BEORNINGCDBASEMORALE") {
											if (SN == "BEORNINGCDBASENCMR") {
												return CalcStat("ClassBaseNCMRM",L);
											} else {
												return 0;
											}
										} else if (SN == "BEORNINGCDBASEMORALE") {
											return CalcStat("ClassBaseMoraleMb",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseMainH",L);
									}
								} else {
									return CalcStat("ClassBaseICMRM",L);
								}
							} else {
								return 1;
							}
						} else if (SN > "BEORNINGCDBASENCPR") {
							if (SN < "BEORNINGCDMIGHTTOBLOCK") {
								if (SN < "BEORNINGCDFATETOCRITHIT") {
									if (SN < "BEORNINGCDBASEVITALITY") {
										if (SN == "BEORNINGCDBASEPOWER") {
											return 0;
										} else {
											return 0;
										}
									} else if (SN > "BEORNINGCDBASEVITALITY") {
										if (SN > "BEORNINGCDBASEWILL") {
											if (SN == "BEORNINGCDCANBLOCK") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "BEORNINGCDBASEWILL") {
											return CalcStat("ClassBaseMainF",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseMainC",L);
									}
								} else if (SN > "BEORNINGCDFATETOCRITHIT") {
									if (SN < "BEORNINGCDFATETOICMR") {
										if (SN == "BEORNINGCDFATETOFINESSE") {
											return 0.5;
										} else {
											return 0;
										}
									} else if (SN > "BEORNINGCDFATETOICMR") {
										if (SN > "BEORNINGCDFATETORESIST") {
											if (SN == "BEORNINGCDFATETOTACMIT") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "BEORNINGCDFATETORESIST") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 3;
									}
								} else {
									return 2.5;
								}
							} else if (SN > "BEORNINGCDMIGHTTOBLOCK") {
								if (SN < "BEORNINGCDMIGHTTOPHYMAS") {
									if (SN < "BEORNINGCDMIGHTTOEVADE") {
										if (SN == "BEORNINGCDMIGHTTOCRITHIT") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "BEORNINGCDMIGHTTOEVADE") {
										if (SN > "BEORNINGCDMIGHTTOOUTHEAL") {
											if (SN == "BEORNINGCDMIGHTTOPARRY") {
												return 3;
											} else {
												return 0;
											}
										} else if (SN == "BEORNINGCDMIGHTTOOUTHEAL") {
											return 2.5;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else if (SN > "BEORNINGCDMIGHTTOPHYMAS") {
									if (SN < "BEORNINGCDTACMASTOOUTHEAL") {
										if (SN > "BEORNINGCDMIGHTTOTACMAS") {
											if (SN == "BEORNINGCDPHYMITTOOFMIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "BEORNINGCDMIGHTTOTACMAS") {
											return 2.5;
										} else {
											return 0;
										}
									} else if (SN > "BEORNINGCDTACMASTOOUTHEAL") {
										if (SN > "BEORNINGCDVITALITYTOMORALE") {
											if (SN == "BEORNINGCDVITALITYTONCMR") {
												return 7.2;
											} else {
												return 0;
											}
										} else if (SN == "BEORNINGCDVITALITYTOMORALE") {
											return 5;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									return 2.5;
								}
							} else {
								return 2;
							}
						} else {
							return 0;
						}
					} else {
						if (L-DblCalcDev <= 8) {
							return RoundDbl(0.009*L-0.0035,2);
						} else {
							return RoundDbl(0.0115*L-0.0275,2);
						}
					}
				} else if (SN > "BEORNINGCDVITALITYTORESIST") {
					if (SN < "BRGFOOTPADSTEALTH") {
						if (SN < "BLOCKPRATPCAPR") {
							if (SN < "BEORNINGRDTRAITMIGHT") {
								if (SN < "BEORNINGCDWILLTOTACMIT") {
									if (SN < "BEORNINGCDWILLTOOUTHEAL") {
										if (SN == "BEORNINGCDWILLTOEVADE") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "BEORNINGCDWILLTOOUTHEAL") {
										if (SN > "BEORNINGCDWILLTORESIST") {
											if (SN == "BEORNINGCDWILLTOTACMAS") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "BEORNINGCDWILLTORESIST") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 2;
									}
								} else if (SN > "BEORNINGCDWILLTOTACMIT") {
									if (SN < "BEORNINGRDPSVONENAME") {
										if (SN == "BEORNINGRDPSVONEFATE") {
											return CalcStat("RacialMain",L);
										} else {
											return 0;
										}
									} else if (SN > "BEORNINGRDPSVONENAME") {
										if (SN > "BEORNINGRDPSVTWONAME") {
											if (SN == "BEORNINGRDTRAITFATE") {
												return -7;
											} else {
												return 0;
											}
										} else if (SN == "BEORNINGRDPSVTWONAME") {
											return "";
										} else {
											return 0;
										}
									} else {
										return "Emissary";
									}
								} else {
									return 1;
								}
							} else if (SN > "BEORNINGRDTRAITMIGHT") {
								if (SN < "BLOCKPRATP") {
									if (SN < "BLOCK") {
										if (SN == "BEORNINGRDTRAITVITALITY") {
											return 15;
										} else {
											return 0;
										}
									} else if (SN > "BLOCK") {
										if (SN > "BLOCKPBONUS") {
											if (SN == "BLOCKPPRAT") {
												return CalcStat("BPEPPRat",L,N);
											} else {
												return 0;
											}
										} else if (SN == "BLOCKPBONUS") {
											return CalcStat("BPEPBonus",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("RatDefence",L,N);
									}
								} else if (SN > "BLOCKPRATP") {
									if (SN < "BLOCKPRATPB") {
										if (SN == "BLOCKPRATPA") {
											return CalcStat("BPEPRatPA",L);
										} else {
											return 0;
										}
									} else if (SN > "BLOCKPRATPB") {
										if (SN > "BLOCKPRATPC") {
											if (SN == "BLOCKPRATPCAP") {
												return CalcStat("BPEPRatPCap",L);
											} else {
												return 0;
											}
										} else if (SN == "BLOCKPRATPC") {
											return CalcStat("BPEPRatPC",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("BPEPRatPB",L);
									}
								} else {
									return CalcStat("BPEPRatP",L,N);
								}
							} else {
								return 15;
							}
						} else if (SN > "BLOCKPRATPCAPR") {
							if (SN < "BRATHIGH") {
								if (SN < "BPEPRATPA") {
									if (SN < "BPEPBONUS") {
										if (SN == "BLOCKT") {
											return CalcStat("RatDefenceT",L,N);
										} else {
											return 0;
										}
									} else if (SN > "BPEPBONUS") {
										if (SN > "BPEPPRAT") {
											if (SN == "BPEPRATP") {
												return CalcPercAB(CalcStat("BPEPRatPA",L),CalcStat("BPEPRatPB",L),CalcStat("BPEPRatPCap",L),N);
											} else {
												return 0;
											}
										} else if (SN == "BPEPPRAT") {
											return CalcRatAB(CalcStat("BPEPRatPA",L),CalcStat("BPEPRatPB",L),CalcStat("BPEPRatPCapR",L),N);
										} else {
											return 0;
										}
									} else {
										return 0;
									}
								} else if (SN > "BPEPRATPA") {
									if (SN < "BPEPRATPC") {
										if (SN == "BPEPRATPB") {
											return CalcStat("BratLow",L);
										} else {
											return 0;
										}
									} else if (SN > "BPEPRATPC") {
										if (SN > "BPEPRATPCAP") {
											if (SN == "BPEPRATPCAPR") {
												return CalcStat("BPEPRatPB",L)*CalcStat("BPEPRatPC",L);
											} else {
												return 0;
											}
										} else if (SN == "BPEPRATPCAP") {
											return 13;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									return 26;
								}
							} else if (SN > "BRATHIGH") {
								if (SN < "BRATMITLIGHT") {
									if (SN < "BRATMASTERY") {
										if (SN == "BRATLOW") {
											return CalcStat("BratProg",L,CalcStat("ProgBLow",L));
										} else {
											return 0;
										}
									} else if (SN > "BRATMASTERY") {
										if (SN > "BRATMEDIUM") {
											if (SN == "BRATMITHEAVY") {
												return CalcStat("BratProg",L,CalcStat("ProgBMitHeavy",L));
											} else {
												return 0;
											}
										} else if (SN == "BRATMEDIUM") {
											return CalcStat("BratProg",L,CalcStat("ProgBMedium",L));
										} else {
											return 0;
										}
									} else {
										return CalcStat("BratProg",L,CalcStat("ProgBMastery",L));
									}
								} else if (SN > "BRATMITLIGHT") {
									if (SN < "BRGDEFTSTRIKESBASE") {
										if (SN > "BRATMITMEDIUM") {
											if (SN == "BRATPROG") {
												if (L-DblCalcDev <= 75) {
													return LinFmod(RoundDbl(N),1,75,1,75,L);
												} else if (L-DblCalcDev <= 76) {
													return LinFmod(1,RoundDbl(N)*75,CalcStat("StdProg",76,N),75,76,L);
												} else if (L-DblCalcDev <= 100) {
													return LinFmod(1,CalcStat("StdProg",76,N),CalcStat("StdProg",100,N),75,100,L,-1);
												} else if (L-DblCalcDev <= 101) {
													return CalcStat("StdProg",L,N);
												} else if (L-DblCalcDev <= 105) {
													return LinFmod(1,CalcStat("StdProg",101,N),CalcStat("StdProg",105,N),100,105,L,-1);
												} else if (L-DblCalcDev <= 106) {
													return CalcStat("StdProg",L,N);
												} else if (L-DblCalcDev <= 115) {
													return LinFmod(1,CalcStat("StdProg",106,N),CalcStat("StdProg",115,N),106,115,L,-1);
												} else if (L-DblCalcDev <= 116) {
													return CalcStat("StdProg",L,N);
												} else if (L-DblCalcDev <= 120) {
													return LinFmod(1,CalcStat("StdProg",116,N),CalcStat("StdProg",120,N),116,120,L,-1);
												} else if (L-DblCalcDev <= 121) {
													return CalcStat("StdProg",L,N);
												} else if (L-DblCalcDev <= 130) {
													return LinFmod(1,CalcStat("StdProg",121,N),CalcStat("StdProg",130,N),121,130,L,-1);
												} else if (L-DblCalcDev <= 131) {
													return CalcStat("StdProg",L,N);
												} else {
													return LinFmod(1,CalcStat("StdProg",131,N),CalcStat("StdProg",140,N),131,140,L,-1);
												}
											} else {
												return 0;
											}
										} else if (SN == "BRATMITMEDIUM") {
											return CalcStat("BratProg",L,CalcStat("ProgBMitMedium",L));
										} else {
											return 0;
										}
									} else if (SN > "BRGDEFTSTRIKESBASE") {
										if (SN > "BRGDEFTSTRIKESCHOICE") {
											if (SN == "BRGDEFTSTRIKESMELCRITP") {
												return CalcStat("BrgDeftStrikesBase",L,CalcStat("BrgDeftStrikesChoice",N));
											} else {
												return 0;
											}
										} else if (SN == "BRGDEFTSTRIKESCHOICE") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return DataTableValue([1,2,3,4,5],L);
											}
										} else {
											return 0;
										}
									} else {
										return 0.01*N;
									}
								} else {
									return CalcStat("BratProg",L,CalcStat("ProgBMitLight",L));
								}
							} else {
								return CalcStat("BratProg",L,CalcStat("ProgBHigh",L));
							}
						} else {
							return CalcStat("BPEPRatPCapR",L);
						}
					} else if (SN > "BRGFOOTPADSTEALTH") {
						if (SN < "BURGLARCDAGILITYTOPHYMAS") {
							if (SN < "BRGRTDMELDMGP") {
								if (SN < "BRGRTDCRITBASE") {
									if (SN < "BRGHEARTPRCHOICE") {
										if (SN == "BRGHEARTPRBASE") {
											return 0.02*N;
										} else {
											return 0;
										}
									} else if (SN > "BRGHEARTPRCHOICE") {
										if (SN > "BRGHEARTPRMORALEP") {
											if (SN == "BRGLEAFWALKERSTEALTH") {
												return CalcStat("BrgStealth",L,N);
											} else {
												return 0;
											}
										} else if (SN == "BRGHEARTPRMORALEP") {
											return CalcStat("BrgHeartPrBase",L,CalcStat("BrgHeartPrChoice",N));
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else if (L-DblCalcDev <= 5) {
											return DataTableValue([1,2,3,4,5],L);
										} else {
											return 2;
										}
									}
								} else if (SN > "BRGRTDCRITBASE") {
									if (SN < "BRGRTDDMGBASE") {
										if (SN == "BRGRTDCRITCHOICE") {
											if (L-DblCalcDev <= 5) {
												return 0;
											} else if (L-DblCalcDev <= 6) {
												return 1;
											} else {
												return 8;
											}
										} else {
											return 0;
										}
									} else if (SN > "BRGRTDDMGBASE") {
										if (SN > "BRGRTDDMGCHOICE") {
											if (SN == "BRGRTDMELCRITP") {
												return CalcStat("BrgRtDCritBase",L,CalcStat("BrgRtDCritChoice",N));
											} else {
												return 0;
											}
										} else if (SN == "BRGRTDDMGCHOICE") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return DataTableValue([1,2,3,4,5],L);
											}
										} else {
											return 0;
										}
									} else {
										return 0.01*N;
									}
								} else {
									return 0.025*N;
								}
							} else if (SN > "BRGRTDMELDMGP") {
								if (SN < "BRGSTICKMOVECHOICE") {
									if (SN < "BRGSTEALTHBASE") {
										if (SN == "BRGSTEALTH") {
											return CalcStat("BrgStealthBase",L,CalcStat("BrgStealthChoice",N));
										} else {
											return 0;
										}
									} else if (SN > "BRGSTEALTHBASE") {
										if (SN > "BRGSTEALTHCHOICE") {
											if (SN == "BRGSTICKMOVEBASE") {
												return 0.01*N;
											} else {
												return 0;
											}
										} else if (SN == "BRGSTEALTHCHOICE") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return DataTableValue([1,2,3,4,5],L);
											}
										} else {
											return 0;
										}
									} else {
										return N;
									}
								} else if (SN > "BRGSTICKMOVECHOICE") {
									if (SN < "BURGLARCDAGILITYTOCRITHIT") {
										if (SN == "BRGSTICKMOVEEVADEP") {
											return CalcStat("BrgStickMoveBase",L,CalcStat("BrgStickMoveChoice",N));
										} else {
											return 0;
										}
									} else if (SN > "BURGLARCDAGILITYTOCRITHIT") {
										if (SN > "BURGLARCDAGILITYTOEVADE") {
											if (SN == "BURGLARCDAGILITYTOPARRY") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "BURGLARCDAGILITYTOEVADE") {
											return 3;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									if (L-DblCalcDev <= 0) {
										return 0;
									} else {
										return DataTableValue([1,2,3,4,5],L);
									}
								}
							} else {
								return CalcStat("BrgRtDDmgBase",L,CalcStat("BrgRtDDmgChoice",N));
							}
						} else if (SN > "BURGLARCDAGILITYTOPHYMAS") {
							if (SN < "BURGLARCDBASEMORALE") {
								if (SN < "BURGLARCDBASEAGILITY") {
									if (SN < "BURGLARCDARMOURTOPHYMIT") {
										if (SN == "BURGLARCDARMOURTOOFMIT") {
											return 0.2;
										} else {
											return 0;
										}
									} else if (SN > "BURGLARCDARMOURTOPHYMIT") {
										if (SN > "BURGLARCDARMOURTOTACMIT") {
											if (SN == "BURGLARCDARMOURTYPE") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "BURGLARCDARMOURTOTACMIT") {
											return 0.2;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else if (SN > "BURGLARCDBASEAGILITY") {
									if (SN < "BURGLARCDBASEICMR") {
										if (SN == "BURGLARCDBASEFATE") {
											return CalcStat("ClassBaseMainC",L);
										} else {
											return 0;
										}
									} else if (SN > "BURGLARCDBASEICMR") {
										if (SN > "BURGLARCDBASEICPR") {
											if (SN == "BURGLARCDBASEMIGHT") {
												return CalcStat("ClassBaseMainH",L);
											} else {
												return 0;
											}
										} else if (SN == "BURGLARCDBASEICPR") {
											return CalcStat("ClassBaseICPR",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseICMRL",L);
									}
								} else {
									return CalcStat("ClassBaseMainJ",L);
								}
							} else if (SN > "BURGLARCDBASEMORALE") {
								if (SN < "BURGLARCDBASEWILL") {
									if (SN < "BURGLARCDBASENCPR") {
										if (SN == "BURGLARCDBASENCMR") {
											return CalcStat("ClassBaseNCMRL",L);
										} else {
											return 0;
										}
									} else if (SN > "BURGLARCDBASENCPR") {
										if (SN > "BURGLARCDBASEPOWER") {
											if (SN == "BURGLARCDBASEVITALITY") {
												return CalcStat("ClassBaseMainA",L);
											} else {
												return 0;
											}
										} else if (SN == "BURGLARCDBASEPOWER") {
											if (L-DblCalcDev <= 120) {
												return CalcStat("ClassBasePowerL",L);
											} else {
												return CalcStat("ClassBasePowerL",120);
											}
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseNCPR",L);
									}
								} else if (SN > "BURGLARCDBASEWILL") {
									if (SN < "BURGLARCDFATETOICMR") {
										if (SN > "BURGLARCDFATETOCRITHIT") {
											if (SN == "BURGLARCDFATETOFINESSE") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "BURGLARCDFATETOCRITHIT") {
											return 2.5;
										} else {
											return 0;
										}
									} else if (SN > "BURGLARCDFATETOICMR") {
										if (SN > "BURGLARCDFATETOICPR") {
											if (SN == "BURGLARCDFATETONCPR") {
												return 24;
											} else {
												return 0;
											}
										} else if (SN == "BURGLARCDFATETOICPR") {
											return 1.71;
										} else {
											return 0;
										}
									} else {
										return 1.5;
									}
								} else {
									return CalcStat("ClassBaseMainF",L);
								}
							} else {
								if (L-DblCalcDev <= 120) {
									return CalcStat("ClassBaseMoraleMa",L);
								} else {
									return CalcStat("ClassBaseMoraleMa",120);
								}
							}
						} else {
							return 3;
						}
					} else {
						return CalcStat("BrgStealth",L,N);
					}
				} else {
					return 1;
				}
			} else if (SN > "BURGLARCDFATETORESIST") {
				if (SN < "CHAMPIONCDMIGHTTOPHYMAS") {
					if (SN < "CAPTAINCDMIGHTTOOUTHEAL") {
						if (SN < "CAPTAINCDARMOURTYPE") {
							if (SN < "BURGLARCDWILLTOOUTHEAL") {
								if (SN < "BURGLARCDPHYMITTOOFMIT") {
									if (SN < "BURGLARCDHASPOWER") {
										if (SN == "BURGLARCDFATETOTACMIT") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "BURGLARCDHASPOWER") {
										if (SN > "BURGLARCDMIGHTTOBLOCK") {
											if (SN == "BURGLARCDMIGHTTOPARRY") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "BURGLARCDMIGHTTOBLOCK") {
											return 3;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else if (SN > "BURGLARCDPHYMITTOOFMIT") {
									if (SN < "BURGLARCDVITALITYTOMORALE") {
										if (SN == "BURGLARCDTACMASTOOUTHEAL") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "BURGLARCDVITALITYTOMORALE") {
										if (SN > "BURGLARCDVITALITYTONCMR") {
											if (SN == "BURGLARCDVITALITYTORESIST") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "BURGLARCDVITALITYTONCMR") {
											return 7.2;
										} else {
											return 0;
										}
									} else {
										return 4.5;
									}
								} else {
									return 1;
								}
							} else if (SN > "BURGLARCDWILLTOOUTHEAL") {
								if (SN < "CAPTAINCDAGILITYTOEVADE") {
									if (SN < "BURGLARCDWILLTOTACMAS") {
										if (SN == "BURGLARCDWILLTORESIST") {
											return 2;
										} else {
											return 0;
										}
									} else if (SN > "BURGLARCDWILLTOTACMAS") {
										if (SN > "BURGLARCDWILLTOTACMIT") {
											if (SN == "CAPTAINCDAGILITYTOCRITHIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "BURGLARCDWILLTOTACMIT") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else if (SN > "CAPTAINCDAGILITYTOEVADE") {
									if (SN < "CAPTAINCDARMOURTOOFMIT") {
										if (SN == "CAPTAINCDAGILITYTOPARRY") {
											return 2;
										} else {
											return 0;
										}
									} else if (SN > "CAPTAINCDARMOURTOOFMIT") {
										if (SN > "CAPTAINCDARMOURTOPHYMIT") {
											if (SN == "CAPTAINCDARMOURTOTACMIT") {
												return 0.2;
											} else {
												return 0;
											}
										} else if (SN == "CAPTAINCDARMOURTOPHYMIT") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 0.2;
									}
								} else {
									return 3;
								}
							} else {
								return 1;
							}
						} else if (SN > "CAPTAINCDARMOURTYPE") {
							if (SN < "CAPTAINCDBASEVITALITY") {
								if (SN < "CAPTAINCDBASEMIGHT") {
									if (SN < "CAPTAINCDBASEFATE") {
										if (SN == "CAPTAINCDBASEAGILITY") {
											return CalcStat("ClassBaseMainA",L);
										} else {
											return 0;
										}
									} else if (SN > "CAPTAINCDBASEFATE") {
										if (SN > "CAPTAINCDBASEICMR") {
											if (SN == "CAPTAINCDBASEICPR") {
												return CalcStat("ClassBaseICPR",L);
											} else {
												return 0;
											}
										} else if (SN == "CAPTAINCDBASEICMR") {
											return CalcStat("ClassBaseICMRM",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseMainJ",L);
									}
								} else if (SN > "CAPTAINCDBASEMIGHT") {
									if (SN < "CAPTAINCDBASENCMR") {
										if (SN == "CAPTAINCDBASEMORALE") {
											if (L-DblCalcDev <= 120) {
												return CalcStat("ClassBaseMoraleMb",L);
											} else {
												return CalcStat("ClassBaseMoraleMb",120);
											}
										} else {
											return 0;
										}
									} else if (SN > "CAPTAINCDBASENCMR") {
										if (SN > "CAPTAINCDBASENCPR") {
											if (SN == "CAPTAINCDBASEPOWER") {
												if (L-DblCalcDev <= 120) {
													return CalcStat("ClassBasePowerL",L);
												} else {
													return CalcStat("ClassBasePowerL",120);
												}
											} else {
												return 0;
											}
										} else if (SN == "CAPTAINCDBASENCPR") {
											return CalcStat("ClassBaseNCPR",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseNCMRM",L);
									}
								} else {
									return CalcStat("ClassBaseMainH",L);
								}
							} else if (SN > "CAPTAINCDBASEVITALITY") {
								if (SN < "CAPTAINCDFATETOICMR") {
									if (SN < "CAPTAINCDCANBLOCK") {
										if (SN == "CAPTAINCDBASEWILL") {
											return CalcStat("ClassBaseMainF",L);
										} else {
											return 0;
										}
									} else if (SN > "CAPTAINCDCANBLOCK") {
										if (SN > "CAPTAINCDFATETOCRITHIT") {
											if (SN == "CAPTAINCDFATETOFINESSE") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "CAPTAINCDFATETOCRITHIT") {
											return 2.5;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else if (SN > "CAPTAINCDFATETOICMR") {
									if (SN < "CAPTAINCDFATETOTACMIT") {
										if (SN > "CAPTAINCDFATETOICPR") {
											if (SN == "CAPTAINCDFATETONCPR") {
												return 24;
											} else {
												return 0;
											}
										} else if (SN == "CAPTAINCDFATETOICPR") {
											return 1.71;
										} else {
											return 0;
										}
									} else if (SN > "CAPTAINCDFATETOTACMIT") {
										if (SN > "CAPTAINCDHASPOWER") {
											if (SN == "CAPTAINCDMIGHTTOBLOCK") {
												return 3;
											} else {
												return 0;
											}
										} else if (SN == "CAPTAINCDHASPOWER") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									return 1.5;
								}
							} else {
								return CalcStat("ClassBaseMainC",L);
							}
						} else {
							return 3;
						}
					} else if (SN > "CAPTAINCDMIGHTTOOUTHEAL") {
						if (SN < "CHAMPIONCDBASEICMR") {
							if (SN < "CAPTAINCDWILLTOTACMIT") {
								if (SN < "CAPTAINCDTACMASTOOUTHEAL") {
									if (SN < "CAPTAINCDMIGHTTOPHYMAS") {
										if (SN == "CAPTAINCDMIGHTTOPARRY") {
											return 2;
										} else {
											return 0;
										}
									} else if (SN > "CAPTAINCDMIGHTTOPHYMAS") {
										if (SN > "CAPTAINCDMIGHTTOTACMAS") {
											if (SN == "CAPTAINCDPHYMITTOOFMIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "CAPTAINCDMIGHTTOTACMAS") {
											return 2.5;
										} else {
											return 0;
										}
									} else {
										return 2.5;
									}
								} else if (SN > "CAPTAINCDTACMASTOOUTHEAL") {
									if (SN < "CAPTAINCDVITALITYTONCMR") {
										if (SN == "CAPTAINCDVITALITYTOMORALE") {
											return 4.5;
										} else {
											return 0;
										}
									} else if (SN > "CAPTAINCDVITALITYTONCMR") {
										if (SN > "CAPTAINCDVITALITYTORESIST") {
											if (SN == "CAPTAINCDWILLTORESIST") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "CAPTAINCDVITALITYTORESIST") {
											return 2;
										} else {
											return 0;
										}
									} else {
										return 7.2;
									}
								} else {
									return 1;
								}
							} else if (SN > "CAPTAINCDWILLTOTACMIT") {
								if (SN < "CHAMPIONCDARMOURTOPHYMIT") {
									if (SN < "CHAMPIONCDAGILITYTOEVADE") {
										if (SN == "CHAMPIONCDAGILITYTOCRITHIT") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "CHAMPIONCDAGILITYTOEVADE") {
										if (SN > "CHAMPIONCDAGILITYTOPARRY") {
											if (SN == "CHAMPIONCDARMOURTOOFMIT") {
												return 0.2;
											} else {
												return 0;
											}
										} else if (SN == "CHAMPIONCDAGILITYTOPARRY") {
											return 2;
										} else {
											return 0;
										}
									} else {
										return 3;
									}
								} else if (SN > "CHAMPIONCDARMOURTOPHYMIT") {
									if (SN < "CHAMPIONCDARMOURTYPE") {
										if (SN == "CHAMPIONCDARMOURTOTACMIT") {
											return 0.2;
										} else {
											return 0;
										}
									} else if (SN > "CHAMPIONCDARMOURTYPE") {
										if (SN > "CHAMPIONCDBASEAGILITY") {
											if (SN == "CHAMPIONCDBASEFATE") {
												return CalcStat("ClassBaseMainG",L);
											} else {
												return 0;
											}
										} else if (SN == "CHAMPIONCDBASEAGILITY") {
											return CalcStat("ClassBaseMainH",L);
										} else {
											return 0;
										}
									} else {
										return 3;
									}
								} else {
									return 1;
								}
							} else {
								return 1;
							}
						} else if (SN > "CHAMPIONCDBASEICMR") {
							if (SN < "CHAMPIONCDFATETOCRITHIT") {
								if (SN < "CHAMPIONCDBASENCPR") {
									if (SN < "CHAMPIONCDBASEMIGHT") {
										if (SN == "CHAMPIONCDBASEICPR") {
											return CalcStat("ClassBaseICPR",L);
										} else {
											return 0;
										}
									} else if (SN > "CHAMPIONCDBASEMIGHT") {
										if (SN > "CHAMPIONCDBASEMORALE") {
											if (SN == "CHAMPIONCDBASENCMR") {
												return CalcStat("ClassBaseNCMRH",L);
											} else {
												return 0;
											}
										} else if (SN == "CHAMPIONCDBASEMORALE") {
											if (L-DblCalcDev <= 120) {
												return CalcStat("ClassBaseMoraleHa",L);
											} else {
												return CalcStat("ClassBaseMoraleHa",120);
											}
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseMainJ",L);
									}
								} else if (SN > "CHAMPIONCDBASENCPR") {
									if (SN < "CHAMPIONCDBASEVITALITY") {
										if (SN == "CHAMPIONCDBASEPOWER") {
											if (L-DblCalcDev <= 120) {
												return CalcStat("ClassBasePowerL",L);
											} else {
												return CalcStat("ClassBasePowerL",120);
											}
										} else {
											return 0;
										}
									} else if (SN > "CHAMPIONCDBASEVITALITY") {
										if (SN > "CHAMPIONCDBASEWILL") {
											if (SN == "CHAMPIONCDCANBLOCK") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "CHAMPIONCDBASEWILL") {
											return CalcStat("ClassBaseMainB",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseMainC",L);
									}
								} else {
									return CalcStat("ClassBaseNCPR",L);
								}
							} else if (SN > "CHAMPIONCDFATETOCRITHIT") {
								if (SN < "CHAMPIONCDFATETORESIST") {
									if (SN < "CHAMPIONCDFATETOICMR") {
										if (SN == "CHAMPIONCDFATETOFINESSE") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "CHAMPIONCDFATETOICMR") {
										if (SN > "CHAMPIONCDFATETOICPR") {
											if (SN == "CHAMPIONCDFATETONCPR") {
												return 24;
											} else {
												return 0;
											}
										} else if (SN == "CHAMPIONCDFATETOICPR") {
											return 1.71;
										} else {
											return 0;
										}
									} else {
										return 1.5;
									}
								} else if (SN > "CHAMPIONCDFATETORESIST") {
									if (SN < "CHAMPIONCDMIGHTTOCRITHIT") {
										if (SN > "CHAMPIONCDFATETOTACMIT") {
											if (SN == "CHAMPIONCDHASPOWER") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "CHAMPIONCDFATETOTACMIT") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "CHAMPIONCDMIGHTTOCRITHIT") {
										if (SN > "CHAMPIONCDMIGHTTOEVADE") {
											if (SN == "CHAMPIONCDMIGHTTOPARRY") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "CHAMPIONCDMIGHTTOEVADE") {
											return 2;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									return 1;
								}
							} else {
								return 2.5;
							}
						} else {
							return CalcStat("ClassBaseICMRH",L);
						}
					} else {
						return 2.5;
					}
				} else if (SN > "CHAMPIONCDMIGHTTOPHYMAS") {
					if (SN < "CLASSBASEMORALEL") {
						if (SN < "CHISELRAWFINESSEH") {
							if (SN < "CHAMPIONCDWILLTOTACMAS") {
								if (SN < "CHAMPIONCDVITALITYTOMORALE") {
									if (SN < "CHAMPIONCDPHYMITTOOFMIT") {
										if (SN == "CHAMPIONCDMIGHTTOPHYMIT") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "CHAMPIONCDPHYMITTOOFMIT") {
										if (SN > "CHAMPIONCDTACMASTOOUTHEAL") {
											if (SN == "CHAMPIONCDVITALITYTOBLOCK") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "CHAMPIONCDTACMASTOOUTHEAL") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else if (SN > "CHAMPIONCDVITALITYTOMORALE") {
									if (SN < "CHAMPIONCDVITALITYTORESIST") {
										if (SN == "CHAMPIONCDVITALITYTONCMR") {
											return 7.2;
										} else {
											return 0;
										}
									} else if (SN > "CHAMPIONCDVITALITYTORESIST") {
										if (SN > "CHAMPIONCDWILLTOOUTHEAL") {
											if (SN == "CHAMPIONCDWILLTORESIST") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "CHAMPIONCDWILLTOOUTHEAL") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									return 4.5;
								}
							} else if (SN > "CHAMPIONCDWILLTOTACMAS") {
								if (SN < "CHISELFINESSEL") {
									if (SN < "CHISELCRITHITH") {
										if (SN == "CHAMPIONCDWILLTOTACMIT") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "CHISELCRITHITH") {
										if (SN > "CHISELCRITHITL") {
											if (SN == "CHISELFINESSEH") {
												return RoundDbl(CalcStat("ChiselRawFinesseH",L));
											} else {
												return 0;
											}
										} else if (SN == "CHISELCRITHITL") {
											return RoundDbl(CalcStat("ChiselRawCritHitL",L));
										} else {
											return 0;
										}
									} else {
										return RoundDbl(CalcStat("ChiselRawCritHitH",L));
									}
								} else if (SN > "CHISELFINESSEL") {
									if (SN < "CHISELICPRL") {
										if (SN == "CHISELICPRH") {
											if (L-DblCalcDev <= 8) {
												return 0;
											} else if (L-DblCalcDev <= 31) {
												return 60;
											} else if (L-DblCalcDev <= 55) {
												return 120;
											} else if (L-DblCalcDev <= 79) {
												return 180;
											} else if (L-DblCalcDev <= 104) {
												return 240;
											} else {
												return 300;
											}
										} else {
											return 0;
										}
									} else if (SN > "CHISELICPRL") {
										if (SN > "CHISELRAWCRITHITH") {
											if (SN == "CHISELRAWCRITHITL") {
												if (L-DblCalcDev <= 105) {
													return 4*CalcStat("ChiselRawLow",L);
												} else if (L-DblCalcDev <= 115) {
													return LinFmod(RoundDbl(CalcStat("ChiselRawCritHitL",105)),2,4,106,115,L,-1);
												} else if (L-DblCalcDev <= 116) {
													return ExpFmod(CalcStat("ChiselRawCritHitL",115),116,20,L);
												} else if (L-DblCalcDev <= 120) {
													return ExpFmod(CalcStat("ChiselRawCritHitL",116),117,5.5024,L);
												} else if (L-DblCalcDev <= 121) {
													return ExpFmod(CalcStat("ChiselRawCritHitL",120),121,20,L);
												} else if (L-DblCalcDev <= 125) {
													return ExpFmod(CalcStat("ChiselRawCritHitL",121),122,5.499,L);
												} else if (L-DblCalcDev <= 126) {
													return ExpFmod(CalcStat("ChiselRawCritHitL",125),126,20,L);
												} else if (L-DblCalcDev <= 130) {
													return ExpFmod(CalcStat("ChiselRawCritHitL",126),127,5.5,L);
												} else {
													return CalcStat("ChiselRawCritHitL",130);
												}
											} else {
												return 0;
											}
										} else if (SN == "CHISELRAWCRITHITH") {
											if (L-DblCalcDev <= 105) {
												return 6*CalcStat("ChiselRawLow",L);
											} else if (L-DblCalcDev <= 115) {
												return LinFmod(RoundDbl(CalcStat("ChiselRawCritHitH",105)),2,4,106,115,L,-1);
											} else if (L-DblCalcDev <= 116) {
												return ExpFmod(CalcStat("ChiselRawCritHitH",115),116,20,L);
											} else if (L-DblCalcDev <= 120) {
												return ExpFmod(CalcStat("ChiselRawCritHitH",116),117,5.501,L);
											} else if (L-DblCalcDev <= 121) {
												return ExpFmod(CalcStat("ChiselRawCritHitH",120),121,20,L);
											} else if (L-DblCalcDev <= 125) {
												return ExpFmod(CalcStat("ChiselRawCritHitH",121),122,5.501,L);
											} else if (L-DblCalcDev <= 126) {
												return ExpFmod(CalcStat("ChiselRawCritHitH",125),126,20,L);
											} else if (L-DblCalcDev <= 130) {
												return ExpFmod(CalcStat("ChiselRawCritHitH",126),127,5.501,L);
											} else {
												return CalcStat("ChiselRawCritHitH",130);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 10) {
											return 0;
										} else if (L-DblCalcDev <= 40) {
											return 60;
										} else if (L-DblCalcDev <= 70) {
											return 120;
										} else if (L-DblCalcDev <= 100) {
											return 180;
										} else {
											return 240;
										}
									}
								} else {
									return RoundDbl(CalcStat("ChiselRawFinesseL",L));
								}
							} else {
								return 1;
							}
						} else if (SN > "CHISELRAWFINESSEH") {
							if (SN < "CLASSBASEMAIND") {
								if (SN < "CLASSBASEICMRM") {
									if (SN < "CHISELRAWLOW") {
										if (SN == "CHISELRAWFINESSEL") {
											if (L-DblCalcDev <= 105) {
												return CalcStat("ChiselRawLow",L);
											} else if (L-DblCalcDev <= 115) {
												return LinFmod(RoundDbl(CalcStat("ChiselRawFinesseL",105)),2,4,106,115,L,-1);
											} else if (L-DblCalcDev <= 116) {
												return ExpFmod(CalcStat("ChiselRawFinesseL",115),116,20,L);
											} else if (L-DblCalcDev <= 120) {
												return ExpFmod(CalcStat("ChiselRawFinesseL",116),117,5.4955,L);
											} else if (L-DblCalcDev <= 121) {
												return ExpFmod(CalcStat("ChiselRawFinesseL",120),121,20,L);
											} else if (L-DblCalcDev <= 125) {
												return ExpFmod(CalcStat("ChiselRawFinesseL",121),122,5.4955,L);
											} else if (L-DblCalcDev <= 126) {
												return ExpFmod(CalcStat("ChiselRawFinesseL",125),126,20,L);
											} else if (L-DblCalcDev <= 130) {
												return ExpFmod(CalcStat("ChiselRawFinesseL",126),127,5.4955,L);
											} else {
												return CalcStat("ChiselRawFinesseL",130);
											}
										} else {
											return 0;
										}
									} else if (SN > "CHISELRAWLOW") {
										if (SN > "CLASSBASEICMRH") {
											if (SN == "CLASSBASEICMRL") {
												if (L-DblCalcDev <= 50) {
													return (L/(L+22.5))*(392/3)+1331/141;
												} else if (L-DblCalcDev <= 120) {
													return 0.6*L+69.615;
												} else {
													return 150;
												}
											} else {
												return 0;
											}
										} else if (SN == "CLASSBASEICMRH") {
											if (L-DblCalcDev <= 50) {
												return (L/(L+22.5))*(500/3)+1820/141;
											} else if (L-DblCalcDev <= 120) {
												return 0.75*L+90.625;
											} else {
												return 150;
											}
										} else {
											return 0;
										}
									} else {
										return 4.04*L*N;
									}
								} else if (SN > "CLASSBASEICMRM") {
									if (SN < "CLASSBASEMAINA") {
										if (SN == "CLASSBASEICPR") {
											return 240;
										} else {
											return 0;
										}
									} else if (SN > "CLASSBASEMAINA") {
										if (SN > "CLASSBASEMAINB") {
											if (SN == "CLASSBASEMAINC") {
												if (L-DblCalcDev <= 50) {
													return L+9;
												} else {
													return 59;
												}
											} else {
												return 0;
											}
										} else if (SN == "CLASSBASEMAINB") {
											if (L-DblCalcDev <= 50) {
												return L+7;
											} else {
												return 58;
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 50) {
											return L+7;
										} else {
											return 57;
										}
									}
								} else {
									if (L-DblCalcDev <= 50) {
										return (L/(L+22.5))*149.5+1500/141;
									} else if (L-DblCalcDev <= 120) {
										return (2/3)*L+242/3;
									} else {
										return 150;
									}
								}
							} else if (SN > "CLASSBASEMAIND") {
								if (SN < "CLASSBASEMAINI") {
									if (SN < "CLASSBASEMAINF") {
										if (SN == "CLASSBASEMAINE") {
											if (L-DblCalcDev <= 50) {
												return L+10;
											} else {
												return 60;
											}
										} else {
											return 0;
										}
									} else if (SN > "CLASSBASEMAINF") {
										if (SN > "CLASSBASEMAING") {
											if (SN == "CLASSBASEMAINH") {
												if (L-DblCalcDev <= 50) {
													return RoundDbl(1.4*L+12.6);
												} else {
													return 83;
												}
											} else {
												return 0;
											}
										} else if (SN == "CLASSBASEMAING") {
											if (L-DblCalcDev <= 50) {
												return RoundDbl(1.4*L+9.6);
											} else {
												return 81;
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 50) {
											return RoundDbl(1.4*L+9.6);
										} else {
											return 80;
										}
									}
								} else if (SN > "CLASSBASEMAINI") {
									if (SN < "CLASSBASEMAINL") {
										if (SN > "CLASSBASEMAINJ") {
											if (SN == "CLASSBASEMAINK") {
												if (L-DblCalcDev <= 29) {
													return 2*L+12;
												} else if (L-DblCalcDev <= 50) {
													return RoundDbl(1.05*L+39.65);
												} else {
													return 93;
												}
											} else {
												return 0;
											}
										} else if (SN == "CLASSBASEMAINJ") {
											if (L-DblCalcDev <= 29) {
												return 2*L+12;
											} else if (L-DblCalcDev <= 50) {
												return RoundDbl(1.05*L+39.65);
											} else {
												return 92;
											}
										} else {
											return 0;
										}
									} else if (SN > "CLASSBASEMAINL") {
										if (SN > "CLASSBASEMORALEHA") {
											if (SN == "CLASSBASEMORALEHB") {
												if (L-DblCalcDev <= 20) {
													return 39*L+61;
												} else if (L-DblCalcDev <= 65) {
													return 27*L+301;
												} else if (L-DblCalcDev <= 71) {
													return DataTableValue([2089,2129,2176,2230,2290,2357],L-65);
												} else {
													return 81*L-3401;
												}
											} else {
												return 0;
											}
										} else if (SN == "CLASSBASEMORALEHA") {
											if (L-DblCalcDev <= 10) {
												return 39*L+61;
											} else if (L-DblCalcDev <= 20) {
												return 39*L+46;
											} else if (L-DblCalcDev <= 50) {
												return 27*L+286;
											} else if (L-DblCalcDev <= 65) {
												return 27*L+274;
											} else if (L-DblCalcDev <= 71) {
												return DataTableValue([2062,2102,2149,2203,2263,2330],L-65);
											} else {
												return 81*L-3428;
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 50) {
											return 2*L+12;
										} else {
											return 112;
										}
									}
								} else {
									if (L-DblCalcDev <= 50) {
										return RoundDbl(1.4*L+12.6);
									} else {
										return 84;
									}
								}
							} else {
								if (L-DblCalcDev <= 50) {
									return L+9;
								} else {
									return 60;
								}
							}
						} else {
							if (L-DblCalcDev <= 105) {
								return 2*CalcStat("ChiselRawLow",L);
							} else if (L-DblCalcDev <= 115) {
								return LinFmod(RoundDbl(CalcStat("ChiselRawFinesseH",105)),2,4,106,115,L,-1);
							} else if (L-DblCalcDev <= 116) {
								return ExpFmod(CalcStat("ChiselRawFinesseH",115),116,20,L);
							} else if (L-DblCalcDev <= 120) {
								return ExpFmod(CalcStat("ChiselRawFinesseH",116),117,5.4975,L);
							} else if (L-DblCalcDev <= 121) {
								return ExpFmod(CalcStat("ChiselRawFinesseH",120),121,20,L);
							} else if (L-DblCalcDev <= 125) {
								return ExpFmod(CalcStat("ChiselRawFinesseH",121),122,5.4975,L);
							} else if (L-DblCalcDev <= 126) {
								return ExpFmod(CalcStat("ChiselRawFinesseH",125),126,20,L);
							} else if (L-DblCalcDev <= 130) {
								return ExpFmod(CalcStat("ChiselRawFinesseH",126),127,5.504,L);
							} else {
								return CalcStat("ChiselRawFinesseH",130);
							}
						}
					} else if (SN > "CLASSBASEMORALEL") {
						if (SN < "CPTMOTIVATEDMORALEP") {
							if (SN < "CPTBLADECRITDEF") {
								if (SN < "CLASSBASENCMRM") {
									if (SN < "CLASSBASEMORALEMB") {
										if (SN == "CLASSBASEMORALEMA") {
											if (L-DblCalcDev <= 20) {
												return 29*L+46;
											} else if (L-DblCalcDev <= 65) {
												return 22*L+186;
											} else if (L-DblCalcDev <= 71) {
												return DataTableValue([1643,1676,1714,1758,1807,1862],L-65);
											} else {
												return 66*L-2830;
											}
										} else {
											return 0;
										}
									} else if (SN > "CLASSBASEMORALEMB") {
										if (SN > "CLASSBASENCMRH") {
											if (SN == "CLASSBASENCMRL") {
												if (L-DblCalcDev <= 4) {
													return 60;
												} else {
													return 120;
												}
											} else {
												return 0;
											}
										} else if (SN == "CLASSBASENCMRH") {
											if (L-DblCalcDev <= 3) {
												return 120;
											} else if (L-DblCalcDev <= 9) {
												return 180;
											} else if (L-DblCalcDev <= 30) {
												return 240;
											} else {
												return 300;
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 10) {
											return 34*L+51;
										} else if (L-DblCalcDev <= 20) {
											return 34*L+36;
										} else if (L-DblCalcDev <= 65) {
											return 22*L+276;
										} else if (L-DblCalcDev <= 71) {
											return DataTableValue([1733,1766,1804,1848,1897,1952],L-65);
										} else {
											return 66*L-2740;
										}
									}
								} else if (SN > "CLASSBASENCMRM") {
									if (SN < "CLASSBASEPOWERH") {
										if (SN == "CLASSBASENCPR") {
											if (L-DblCalcDev <= 2) {
												return 75;
											} else if (L-DblCalcDev <= 7) {
												return 90;
											} else if (L-DblCalcDev <= 25) {
												return 105;
											} else {
												return 120;
											}
										} else {
											return 0;
										}
									} else if (SN > "CLASSBASEPOWERH") {
										if (SN > "CLASSBASEPOWERL") {
											if (SN == "CLOTHARMOUR") {
												if (L-DblCalcDev <= 50) {
													return L;
												} else {
													return 50;
												}
											} else {
												return 0;
											}
										} else if (SN == "CLASSBASEPOWERL") {
											return 50*L;
										} else {
											return 0;
										}
									} else {
										return 65*L;
									}
								} else {
									if (L-DblCalcDev <= 1) {
										return 60;
									} else if (L-DblCalcDev <= 5) {
										return 120;
									} else if (L-DblCalcDev <= 15) {
										return 180;
									} else {
										return 240;
									}
								}
							} else if (SN > "CPTBLADECRITDEF") {
								if (SN < "CPTCOVPHYMIT") {
									if (SN < "CPTBLADETACMAS") {
										if (SN == "CPTBLADEPHYMAS") {
											return CalcStat("PhyMasT",L,1.2);
										} else {
											return 0;
										}
									} else if (SN > "CPTBLADETACMAS") {
										if (SN > "CPTCOVATTDURP") {
											if (SN == "CPTCOVMAIN") {
												return CalcStat("MainT",L,0.4);
											} else {
												return 0;
											}
										} else if (SN == "CPTCOVATTDURP") {
											return -0.25;
										} else {
											return 0;
										}
									} else {
										return CalcStat("TacMasT",L,0.8);
									}
								} else if (SN > "CPTCOVPHYMIT") {
									if (SN < "CPTDEFENDINGARMOUR") {
										if (SN > "CPTCOVVITALITY") {
											if (SN == "CPTCRITDEF") {
												return CalcStat("CritDef",L,0.6);
											} else {
												return 0;
											}
										} else if (SN == "CPTCOVVITALITY") {
											return CalcStat("VitalityT",L,0.4);
										} else {
											return 0;
										}
									} else if (SN > "CPTDEFENDINGARMOUR") {
										if (SN > "CPTIDOMEMAIN") {
											if (SN == "CPTIDOMEVITALITY") {
												return CalcStat("VitalityT",L,0.4);
											} else {
												return 0;
											}
										} else if (SN == "CPTIDOMEMAIN") {
											return CalcStat("MainT",L,0.4);
										} else {
											return 0;
										}
									} else {
										return RoundDbl((CalcStat("ArmourLowRaw",1,"MB")/CalcStat("TraitProg",1,CalcStat("ProgBMitMedium",L)))*CalcStat("TraitProg",L,CalcStat("ProgBMitMedium",L))*CalcStat("AdjTraitProgRatings",L,CalcStat("ProgBMitMedium",L)));
									}
								} else {
									return CalcStat("PhyMitT",L,2.4);
								}
							} else {
								return CalcStat("CritDefT",L,0.8);
							}
						} else if (SN > "CPTMOTIVATEDMORALEP") {
							if (SN < "CPTSONGTACMAS") {
								if (SN < "CPTSHIELDCRITDEF") {
									if (SN < "CPTRELENTLESSCRITHIT") {
										if (SN == "CPTONGUARDPARRY") {
											return CalcStat("ParryT",L,0.8);
										} else {
											return 0;
										}
									} else if (SN > "CPTRELENTLESSCRITHIT") {
										if (SN > "CPTRELENTLESSPHYMAS") {
											if (SN == "CPTRELENTLESSTACMAS") {
												return CalcStat("TacMasT",L,0.8);
											} else {
												return 0;
											}
										} else if (SN == "CPTRELENTLESSPHYMAS") {
											return CalcStat("PhyMasT",L,0.8);
										} else {
											return 0;
										}
									} else {
										return CalcStat("CritHitT",L,1.4);
									}
								} else if (SN > "CPTSHIELDCRITDEF") {
									if (SN < "CPTSHIELDTACMAS") {
										if (SN == "CPTSHIELDPHYMAS") {
											return CalcStat("PhyMasT",L,0.8);
										} else {
											return 0;
										}
									} else if (SN > "CPTSHIELDTACMAS") {
										if (SN > "CPTSONGCRITDEF") {
											if (SN == "CPTSONGPHYMAS") {
												return CalcStat("PhyMasT",L,0.8);
											} else {
												return 0;
											}
										} else if (SN == "CPTSONGCRITDEF") {
											return CalcStat("CritDefT",L,0.8);
										} else {
											return 0;
										}
									} else {
										return CalcStat("TacMasT",L,0.8);
									}
								} else {
									return CalcStat("CritDefT",L,1.2);
								}
							} else if (SN > "CPTSONGTACMAS") {
								if (SN < "CRFBASICMORALE") {
									if (SN < "CRFBASICAGILITY") {
										if (SN == "CRFAGILITY") {
											if (L-DblCalcDev <= 64) {
												return 0;
											} else {
												return (L-55)*N;
											}
										} else {
											return 0;
										}
									} else if (SN > "CRFBASICAGILITY") {
										if (SN > "CRFBASICFATE") {
											if (SN == "CRFBASICMIGHT") {
												return (L-40)*N;
											} else {
												return 0;
											}
										} else if (SN == "CRFBASICFATE") {
											return (L-40)*N;
										} else {
											return 0;
										}
									} else {
										return (L-40)*N;
									}
								} else if (SN > "CRFBASICMORALE") {
									if (SN < "CRFBASICWILL") {
										if (SN > "CRFBASICPOWER") {
											if (SN == "CRFBASICVITALITY") {
												return (L-40)*N;
											} else {
												return 0;
											}
										} else if (SN == "CRFBASICPOWER") {
											return (5*L-200)*N;
										} else {
											return 0;
										}
									} else if (SN > "CRFBASICWILL") {
										if (SN > "CRFCRITDEF") {
											if (SN == "CRFCRITHIT") {
												return (10*L-210)*N;
											} else {
												return 0;
											}
										} else if (SN == "CRFCRITDEF") {
											return (10*L-210)*N;
										} else {
											return 0;
										}
									} else {
										return (L-40)*N;
									}
								} else {
									return (5*L-200)*N;
								}
							} else {
								return CalcStat("TacMasT",L,1.2);
							}
						} else {
							return 0.1*N;
						}
					} else {
						if (L-DblCalcDev <= 20) {
							return 22*L+53;
						} else if (L-DblCalcDev <= 65) {
							return 15*L+193;
						} else if (L-DblCalcDev <= 71) {
							return DataTableValue([1186,1208,1234,1264,1297,1334],L-65);
						} else {
							return 45*L-1865;
						}
					}
				} else {
					return 3;
				}
			} else {
				return 1;
			}
		} else if (SN > "CRFFATE") {
			if (SN < "HOBBITRDPSVONEMIGHT") {
				if (SN < "FINESSEPRATPB") {
					if (SN < "DEVHITPRATPC") {
						if (SN < "CRITHITPPRAT") {
							if (SN < "CRITDEFPPRAT") {
								if (SN < "CRFTACMIT") {
									if (SN < "CRFPHYMAS") {
										if (SN == "CRFMIGHT") {
											if (L-DblCalcDev <= 64) {
												return 0;
											} else {
												return (L-55)*N;
											}
										} else {
											return 0;
										}
									} else if (SN > "CRFPHYMAS") {
										if (SN > "CRFPHYMIT") {
											if (SN == "CRFTACMAS") {
												return (10*L-210)*N;
											} else {
												return 0;
											}
										} else if (SN == "CRFPHYMIT") {
											return (10*L-210)*N;
										} else {
											return 0;
										}
									} else {
										return (10*L-210)*N;
									}
								} else if (SN > "CRFTACMIT") {
									if (SN < "CRFWILL") {
										if (SN == "CRFVITALITY") {
											if (L-DblCalcDev <= 64) {
												return 0;
											} else {
												return (L-55)*N;
											}
										} else {
											return 0;
										}
									} else if (SN > "CRFWILL") {
										if (SN > "CRITDEF") {
											if (SN == "CRITDEFPBONUS") {
												return 0;
											} else {
												return 0;
											}
										} else if (SN == "CRITDEF") {
											return CalcStat("RatDefence",L,N);
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 64) {
											return 0;
										} else {
											return (L-55)*N;
										}
									}
								} else {
									return (10*L-210)*N;
								}
							} else if (SN > "CRITDEFPPRAT") {
								if (SN < "CRITDEFPRATPCAP") {
									if (SN < "CRITDEFPRATPA") {
										if (SN == "CRITDEFPRATP") {
											return CalcPercAB(CalcStat("CritDefPRatPA",L),CalcStat("CritDefPRatPB",L),CalcStat("CritDefPRatPCap",L),N);
										} else {
											return 0;
										}
									} else if (SN > "CRITDEFPRATPA") {
										if (SN > "CRITDEFPRATPB") {
											if (SN == "CRITDEFPRATPC") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "CRITDEFPRATPB") {
											return CalcStat("BratLow",L);
										} else {
											return 0;
										}
									} else {
										return 160;
									}
								} else if (SN > "CRITDEFPRATPCAP") {
									if (SN < "CRITDEFT") {
										if (SN == "CRITDEFPRATPCAPR") {
											return CalcStat("CritDefPRatPB",L)*CalcStat("CritDefPRatPC",L);
										} else {
											return 0;
										}
									} else if (SN > "CRITDEFT") {
										if (SN > "CRITHIT") {
											if (SN == "CRITHITPBONUS") {
												return 0;
											} else {
												return 0;
											}
										} else if (SN == "CRITHIT") {
											return CalcStat("RatOffence",L,N);
										} else {
											return 0;
										}
									} else {
										return CalcStat("RatDefenceT",L,N);
									}
								} else {
									return 80;
								}
							} else {
								return CalcRatAB(CalcStat("CritDefPRatPA",L),CalcStat("CritDefPRatPB",L),CalcStat("CritDefPRatPCapR",L),N);
							}
						} else if (SN > "CRITHITPPRAT") {
							if (SN < "CRITMAGNPRATP") {
								if (SN < "CRITHITPRATPCAP") {
									if (SN < "CRITHITPRATPA") {
										if (SN == "CRITHITPRATP") {
											return CalcPercAB(CalcStat("CritHitPRatPA",L),CalcStat("CritHitPRatPB",L),CalcStat("CritHitPRatPCap",L),N);
										} else {
											return 0;
										}
									} else if (SN > "CRITHITPRATPA") {
										if (SN > "CRITHITPRATPB") {
											if (SN == "CRITHITPRATPC") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "CRITHITPRATPB") {
											return CalcStat("BratLow",L);
										} else {
											return 0;
										}
									} else {
										return 50;
									}
								} else if (SN > "CRITHITPRATPCAP") {
									if (SN < "CRITHITT") {
										if (SN == "CRITHITPRATPCAPR") {
											return CalcStat("CritHitPRatPB",L)*CalcStat("CritHitPRatPC",L);
										} else {
											return 0;
										}
									} else if (SN > "CRITHITT") {
										if (SN > "CRITMAGNPBONUS") {
											if (SN == "CRITMAGNPPRAT") {
												return CalcRatAB(CalcStat("CritMagnPRatPA",L),CalcStat("CritMagnPRatPB",L),CalcStat("CritMagnPRatPCapR",L),N);
											} else {
												return 0;
											}
										} else if (SN == "CRITMAGNPBONUS") {
											return 0;
										} else {
											return 0;
										}
									} else {
										return CalcStat("RatOffenceT",L,N);
									}
								} else {
									return 25;
								}
							} else if (SN > "CRITMAGNPRATP") {
								if (SN < "CRITMAGNPRATPCAPR") {
									if (SN < "CRITMAGNPRATPB") {
										if (SN == "CRITMAGNPRATPA") {
											if (L-DblCalcDev <= 120) {
												return 200;
											} else if (L-DblCalcDev <= 127) {
												return (-5)*L+750;
											} else {
												return 112.5;
											}
										} else {
											return 0;
										}
									} else if (SN > "CRITMAGNPRATPB") {
										if (SN > "CRITMAGNPRATPC") {
											if (SN == "CRITMAGNPRATPCAP") {
												if (L-DblCalcDev <= 120) {
													return 100;
												} else {
													return 75;
												}
											} else {
												return 0;
											}
										} else if (SN == "CRITMAGNPRATPC") {
											return CalcStat("CritMagnPRatPCap",L)/(CalcStat("CritMagnPRatPA",L)-CalcStat("CritMagnPRatPCap",L));
										} else {
											return 0;
										}
									} else {
										return CalcStat("BratHigh",L);
									}
								} else if (SN > "CRITMAGNPRATPCAPR") {
									if (SN < "DEVHITPRATP") {
										if (SN > "DEVHITPBONUS") {
											if (SN == "DEVHITPPRAT") {
												return CalcRatAB(CalcStat("DevHitPRatPA",L),CalcStat("DevHitPRatPB",L),CalcStat("DevHitPRatPCapR",L),N);
											} else {
												return 0;
											}
										} else if (SN == "DEVHITPBONUS") {
											return 0;
										} else {
											return 0;
										}
									} else if (SN > "DEVHITPRATP") {
										if (SN > "DEVHITPRATPA") {
											if (SN == "DEVHITPRATPB") {
												return CalcStat("BratMedium",L);
											} else {
												return 0;
											}
										} else if (SN == "DEVHITPRATPA") {
											return 20;
										} else {
											return 0;
										}
									} else {
										return CalcPercAB(CalcStat("DevHitPRatPA",L),CalcStat("DevHitPRatPB",L),CalcStat("DevHitPRatPCap",L),N);
									}
								} else {
									return CalcStat("CritMagnPRatPB",L)*CalcStat("CritMagnPRatPC",L);
								}
							} else {
								return CalcPercAB(CalcStat("CritMagnPRatPA",L),CalcStat("CritMagnPRatPB",L),CalcStat("CritMagnPRatPCap",L),N);
							}
						} else {
							return CalcRatAB(CalcStat("CritHitPRatPA",L),CalcStat("CritHitPRatPB",L),CalcStat("CritHitPRatPCapR",L),N);
						}
					} else if (SN > "DEVHITPRATPC") {
						if (SN < "ELFRDTRAITAGILITY") {
							if (SN < "DWARFRDTRAITICMR") {
								if (SN < "DWARFRDPSVONENAME") {
									if (SN < "DEVHITPRATPCAPR") {
										if (SN == "DEVHITPRATPCAP") {
											return 10;
										} else {
											return 0;
										}
									} else if (SN > "DEVHITPRATPCAPR") {
										if (SN > "DWARFENDURVITALITY") {
											if (SN == "DWARFRDPSVONEFATE") {
												return CalcStat("RacialMain",L);
											} else {
												return 0;
											}
										} else if (SN == "DWARFENDURVITALITY") {
											if (L-DblCalcDev <= 105) {
												return RoundDbl(1.2*L*N);
											} else if (L-DblCalcDev <= 106) {
												return RoundDbl(ExpFmod(CalcStat("DwarfEndurVitality",105),106,7,L)*N);
											} else if (L-DblCalcDev <= 114) {
												return RoundDbl(ExpFmod(CalcStat("DwarfEndurVitality",106),107,7.65,L)*N);
											} else if (L-DblCalcDev <= 115) {
												return RoundDbl(ExpFmod(CalcStat("DwarfEndurVitality",114),115,3.9,L)*N);
											} else if (L-DblCalcDev <= 119) {
												return RoundDbl(ExpFmod(CalcStat("DwarfEndurVitality",115),116,25.04,L)*N);
											} else {
												return RoundDbl(ExpFmod(CalcStat("DwarfEndurVitality",119),120,9.1,L)*N);
											}
										} else {
											return 0;
										}
									} else {
										return CalcStat("DevHitPRatPB",L)*CalcStat("DevHitPRatPC",L);
									}
								} else if (SN > "DWARFRDPSVONENAME") {
									if (SN < "DWARFRDPSVTWONAME") {
										if (SN == "DWARFRDPSVTWOBLOCK") {
											return CalcStat("ShieldBrawlerBlock",L);
										} else {
											return 0;
										}
									} else if (SN > "DWARFRDPSVTWONAME") {
										if (SN > "DWARFRDTRAITAGILITY") {
											if (SN == "DWARFRDTRAITFATE") {
												return -7;
											} else {
												return 0;
											}
										} else if (SN == "DWARFRDTRAITAGILITY") {
											return -7;
										} else {
											return 0;
										}
									} else {
										return "Shield Brawler";
									}
								} else {
									return "Fateful Dwarf";
								}
							} else if (SN > "DWARFRDTRAITICMR") {
								if (SN < "DWARFRDTRAITPHYMITP") {
									if (SN < "DWARFRDTRAITMIGHT") {
										if (SN == "DWARFRDTRAITICPR") {
											return 30;
										} else {
											return 0;
										}
									} else if (SN > "DWARFRDTRAITMIGHT") {
										if (SN > "DWARFRDTRAITNCMR") {
											if (SN == "DWARFRDTRAITNCPR") {
												return -30;
											} else {
												return 0;
											}
										} else if (SN == "DWARFRDTRAITNCMR") {
											return -60;
										} else {
											return 0;
										}
									} else {
										return 15;
									}
								} else if (SN > "DWARFRDTRAITPHYMITP") {
									if (SN < "ELFRDPSVONEFATE") {
										if (SN == "DWARFRDTRAITVITALITY") {
											return 10;
										} else {
											return 0;
										}
									} else if (SN > "ELFRDPSVONEFATE") {
										if (SN > "ELFRDPSVONENAME") {
											if (SN == "ELFRDPSVTWONAME") {
												return "";
											} else {
												return 0;
											}
										} else if (SN == "ELFRDPSVONENAME") {
											return "Friend of Man";
										} else {
											return 0;
										}
									} else {
										return CalcStat("RacialMain",L);
									}
								} else {
									return 1;
								}
							} else {
								return 30;
							}
						} else if (SN > "ELFRDTRAITAGILITY") {
							if (SN < "EVADEPRATPC") {
								if (SN < "EVADEPBONUS") {
									if (SN < "ELFRDTRAITMORALE") {
										if (SN == "ELFRDTRAITFATE") {
											return -7;
										} else {
											return 0;
										}
									} else if (SN > "ELFRDTRAITMORALE") {
										if (SN > "ELFRDTRAITNCMR") {
											if (SN == "EVADE") {
												return CalcStat("RatDefence",L,N);
											} else {
												return 0;
											}
										} else if (SN == "ELFRDTRAITNCMR") {
											return -60;
										} else {
											return 0;
										}
									} else {
										return -20;
									}
								} else if (SN > "EVADEPBONUS") {
									if (SN < "EVADEPRATP") {
										if (SN == "EVADEPPRAT") {
											return CalcStat("BPEPPRat",L,N);
										} else {
											return 0;
										}
									} else if (SN > "EVADEPRATP") {
										if (SN > "EVADEPRATPA") {
											if (SN == "EVADEPRATPB") {
												return CalcStat("BPEPRatPB",L);
											} else {
												return 0;
											}
										} else if (SN == "EVADEPRATPA") {
											return CalcStat("BPEPRatPA",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("BPEPRatP",L,N);
									}
								} else {
									return CalcStat("BPEPBonus",L);
								}
							} else if (SN > "EVADEPRATPC") {
								if (SN < "FATET") {
									if (SN < "EVADEPRATPCAPR") {
										if (SN == "EVADEPRATPCAP") {
											return CalcStat("BPEPRatPCap",L);
										} else {
											return 0;
										}
									} else if (SN > "EVADEPRATPCAPR") {
										if (SN > "EVADET") {
											if (SN == "FATE") {
												return CalcStat("Main",L,N);
											} else {
												return 0;
											}
										} else if (SN == "EVADET") {
											return CalcStat("RatDefenceT",L,N);
										} else {
											return 0;
										}
									} else {
										return CalcStat("BPEPRatPCapR",L);
									}
								} else if (SN > "FATET") {
									if (SN < "FINESSEPPRAT") {
										if (SN > "FINESSE") {
											if (SN == "FINESSEPBONUS") {
												return 0;
											} else {
												return 0;
											}
										} else if (SN == "FINESSE") {
											return CalcStat("RatOffence",L,N);
										} else {
											return 0;
										}
									} else if (SN > "FINESSEPPRAT") {
										if (SN > "FINESSEPRATP") {
											if (SN == "FINESSEPRATPA") {
												return 100;
											} else {
												return 0;
											}
										} else if (SN == "FINESSEPRATP") {
											return CalcPercAB(CalcStat("FinessePRatPA",L),CalcStat("FinessePRatPB",L),CalcStat("FinessePRatPCap",L),N);
										} else {
											return 0;
										}
									} else {
										return CalcRatAB(CalcStat("FinessePRatPA",L),CalcStat("FinessePRatPB",L),CalcStat("FinessePRatPCapR",L),N);
									}
								} else {
									return CalcStat("MainT",L,N);
								}
							} else {
								return CalcStat("BPEPRatPC",L);
							}
						} else {
							return 15;
						}
					} else {
						return 1;
					}
				} else if (SN > "FINESSEPRATPB") {
					if (SN < "GUARDIANCDBASEVITALITY") {
						if (SN < "GRDTENDERIZECHOICE") {
							if (SN < "FOODICPRM") {
								if (SN < "FOODICMRH") {
									if (SN < "FINESSEPRATPCAP") {
										if (SN == "FINESSEPRATPC") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "FINESSEPRATPCAP") {
										if (SN > "FINESSEPRATPCAPR") {
											if (SN == "FINESSET") {
												return CalcStat("RatOffenceT",L,N);
											} else {
												return 0;
											}
										} else if (SN == "FINESSEPRATPCAPR") {
											return CalcStat("FinessePRatPB",L)*CalcStat("FinessePRatPC",L);
										} else {
											return 0;
										}
									} else {
										return 50;
									}
								} else if (SN > "FOODICMRH") {
									if (SN < "FOODICMRM") {
										if (SN == "FOODICMRL") {
											if (L-DblCalcDev <= 105) {
												return (FloorDbl((L-4)/6)*(3.5-3.51)*6+L*3.51+5.43)*N;
											} else if (L-DblCalcDev <= 114) {
												return ExpFmod(400.5,106,7.505,L-1)*N;
											} else if (L-DblCalcDev <= 119) {
												return ExpFmod(745.4,115,24.99,L-1)*N;
											} else if (L-DblCalcDev <= 121) {
												return ExpFmod(1986.8,120,20,L-1)*N;
											} else if (L-DblCalcDev <= 125) {
												return ExpFmod(2516,122,5.5,L-1)*N;
											} else if (L-DblCalcDev <= 130) {
												return ExpFmod(3544.85,126,5.5,L-1)*N;
											} else {
												return CalcStat("FoodICMRL",130,N);
											}
										} else {
											return 0;
										}
									} else if (SN > "FOODICMRM") {
										if (SN > "FOODICPRH") {
											if (SN == "FOODICPRL") {
												if (L-DblCalcDev <= 105) {
													return (FloorDbl((L-3)/6)*(2.5-2.5336399999999)*6+L*2.5336399999999+9.831800000001)*N;
												} else if (L-DblCalcDev <= 114) {
													return ExpFmod(292.9,106,7.501,L-1)*N;
												} else if (L-DblCalcDev <= 119) {
													return ExpFmod(544.9,115,25,L-1)*N;
												} else if (L-DblCalcDev <= 121) {
													return ExpFmod(1453,120,20,L-1)*N;
												} else if (L-DblCalcDev <= 125) {
													return ExpFmod(1839.2,122,5.5,L-1)*N;
												} else if (L-DblCalcDev <= 130) {
													return ExpFmod(2591.4,126,5.504,L-1)*N;
												} else {
													return CalcStat("FoodICPRL",130,N);
												}
											} else {
												return 0;
											}
										} else if (SN == "FOODICPRH") {
											if (L-DblCalcDev <= 105) {
												return (5*L+20)*N;
											} else if (L-DblCalcDev <= 114) {
												return ExpFmod(585.6,106,7.5,L-1)*N;
											} else if (L-DblCalcDev <= 119) {
												return ExpFmod(1089.7,115,25,L-1)*N;
											} else if (L-DblCalcDev <= 121) {
												return ExpFmod(2906,120,20,L-1)*N;
											} else if (L-DblCalcDev <= 125) {
												return ExpFmod(3678.5,122,5.5,L-1)*N;
											} else if (L-DblCalcDev <= 130) {
												return ExpFmod(5183,126,5.5,L-1)*N;
											} else {
												return CalcStat("FoodICPRH",130,N);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 105) {
											return (FloorDbl((L-2)/9)*(14/3-4.59)*9+L*4.59+7.75)*N;
										} else if (L-DblCalcDev <= 114) {
											return ExpFmod(535,106,7.483,L-1)*N;
										} else if (L-DblCalcDev <= 119) {
											return ExpFmod(995,115,25,L-1)*N;
										} else if (L-DblCalcDev <= 121) {
											return ExpFmod(2653.2,120,20,L-1)*N;
										} else if (L-DblCalcDev <= 125) {
											return ExpFmod(3358.4,122,5.5,L-1)*N;
										} else if (L-DblCalcDev <= 130) {
											return ExpFmod(4732.4,126,5.5,L-1)*N;
										} else {
											return CalcStat("FoodICMRM",130,N);
										}
									}
								} else {
									if (L-DblCalcDev <= 105) {
										return (7*L+11)*N;
									} else if (L-DblCalcDev <= 114) {
										return ExpFmod(801.55,106,7.5,L-1)*N;
									} else if (L-DblCalcDev <= 119) {
										return ExpFmod(1491.75,115,24.99,L-1)*N;
									} else if (L-DblCalcDev <= 121) {
										return ExpFmod(3977.2,120,20,L-1)*N;
									} else if (L-DblCalcDev <= 125) {
										return ExpFmod(5035.5,122,5.5,L-1)*N;
									} else if (L-DblCalcDev <= 130) {
										return ExpFmod(7095.8,126,5.5,L-1)*N;
									} else {
										return CalcStat("FoodICMRH",130,N);
									}
								}
							} else if (SN > "FOODICPRM") {
								if (SN < "FOODNCPRL") {
									if (SN < "FOODNCMRL") {
										if (SN == "FOODNCMRH") {
											if (L-DblCalcDev <= 50) {
												return (70.2*L+210)*N;
											} else if (L-DblCalcDev <= 52) {
												return CalcStat("FoodNCMRH",50,N);
											} else if (L-DblCalcDev <= 77) {
												return (70.2*L+210-3*70.2)*N;
											} else if (L-DblCalcDev <= 111) {
												return (RoundDbl((L+143)/3)*70.2+210)*N;
											} else {
												return CalcStat("FoodNCMRH",111,N);
											}
										} else {
											return 0;
										}
									} else if (SN > "FOODNCMRL") {
										if (SN > "FOODNCMRM") {
											if (SN == "FOODNCPRH") {
												if (L-DblCalcDev <= 1) {
													return (75*L+300)*N;
												} else if (L-DblCalcDev <= 6) {
													return (75*L+285)*N;
												} else if (L-DblCalcDev <= 24) {
													return (75*L+270)*N;
												} else if (L-DblCalcDev <= 48) {
													return (75*L+255)*N;
												} else if (L-DblCalcDev <= 61) {
													return 3900*N;
												} else if (L-DblCalcDev <= 66) {
													return 3960*N;
												} else if (L-DblCalcDev <= 72) {
													return 4020*N;
												} else {
													return 4080*N;
												}
											} else {
												return 0;
											}
										} else if (SN == "FOODNCMRM") {
											if (L-DblCalcDev <= 50) {
												return (55.8*L+180)*N;
											} else if (L-DblCalcDev <= 52) {
												return CalcStat("FoodNCMRM",50,N);
											} else if (L-DblCalcDev <= 77) {
												return (55.8*L+180-3*55.8)*N;
											} else if (L-DblCalcDev <= 111) {
												return (RoundDbl((L+143)/3)*55.8+180)*N;
											} else {
												return CalcStat("FoodNCMRM",111,N);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 50) {
											return (42*L+108)*N;
										} else if (L-DblCalcDev <= 52) {
											return CalcStat("FoodNCMRL",50,N);
										} else if (L-DblCalcDev <= 77) {
											return (42*L+108-3*42)*N;
										} else if (L-DblCalcDev <= 111) {
											return (RoundDbl((L+143)/3)*42+108)*N;
										} else {
											return CalcStat("FoodNCMRL",111,N);
										}
									}
								} else if (SN > "FOODNCPRL") {
									if (SN < "FOODRESIST") {
										if (SN == "FOODNCPRM") {
											if (L-DblCalcDev <= 1) {
												return (60*L+225)*N;
											} else if (L-DblCalcDev <= 6) {
												return (60*L+210)*N;
											} else if (L-DblCalcDev <= 24) {
												return (60*L+195)*N;
											} else if (L-DblCalcDev <= 48) {
												return (60*L+180)*N;
											} else if (L-DblCalcDev <= 61) {
												return 3120*N;
											} else if (L-DblCalcDev <= 66) {
												return 3180*N;
											} else if (L-DblCalcDev <= 72) {
												return 3240*N;
											} else {
												return 3300*N;
											}
										} else {
											return 0;
										}
									} else if (SN > "FOODRESIST") {
										if (SN > "GRDCRITDEF") {
											if (SN == "GRDPROTECTIONAVOID") {
												if (L-DblCalcDev <= 105) {
													return 12.12*L*N;
												} else if (L-DblCalcDev <= 115) {
													return LinFmod(RoundDbl(CalcStat("GrdProtectionAvoid",105)),2,4,106,115,L,-1)*N;
												} else if (L-DblCalcDev <= 116) {
													return ExpFmod(CalcStat("GrdProtectionAvoid",115),116,20,L)*N;
												} else {
													return ExpFmod(CalcStat("GrdProtectionAvoid",116),117,5.4999,L)*N;
												}
											} else {
												return 0;
											}
										} else if (SN == "GRDCRITDEF") {
											return CalcStat("CritDef",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("PntMPDefence",L)*CalcStat("ItemProg",L,CalcStat("ProgBMedium",L))*CalcStat("AdjItemProgFoodResist",L,CalcStat("ProgBMedium",L))*N;
									}
								} else {
									if (L-DblCalcDev <= 1) {
										return (50*L+175)*N;
									} else if (L-DblCalcDev <= 6) {
										return (50*L+160)*N;
									} else if (L-DblCalcDev <= 24) {
										return (50*L+145)*N;
									} else if (L-DblCalcDev <= 48) {
										return (50*L+130)*N;
									} else if (L-DblCalcDev <= 61) {
										return 2580*N;
									} else if (L-DblCalcDev <= 66) {
										return 2640*N;
									} else if (L-DblCalcDev <= 72) {
										return 2700*N;
									} else {
										return 2760*N;
									}
								}
							} else {
								if (L-DblCalcDev <= 105) {
									return (FloorDbl((L-6)/9)*(10/3-3.28)*9+L*3.28+13.84)*N;
								} else if (L-DblCalcDev <= 114) {
									return ExpFmod(390.65,106,7.51,L-1)*N;
								} else if (L-DblCalcDev <= 119) {
									return ExpFmod(727,115,25,L-1)*N;
								} else if (L-DblCalcDev <= 121) {
									return ExpFmod(1939.1,120,20,L-1)*N;
								} else if (L-DblCalcDev <= 125) {
									return ExpFmod(2455,122,5.5,L-1)*N;
								} else if (L-DblCalcDev <= 130) {
									return ExpFmod(3459.5,126,5.499,L-1)*N;
								} else {
									return CalcStat("FoodICPRM",130,N);
								}
							}
						} else if (SN > "GRDTENDERIZECHOICE") {
							if (SN < "GUARDIANCDARMOURTOTACMIT") {
								if (SN < "GUARDIANCDAGILITYTOCRITHIT") {
									if (SN < "GRDWARDTACTBASE") {
										if (SN == "GRDTENDERIZECRITHIT") {
											return CalcStat("CritHitT",L,CalcStat("GrdTenderizeChoice",N));
										} else {
											return 0;
										}
									} else if (SN > "GRDWARDTACTBASE") {
										if (SN > "GRDWARDTACTCHOICE") {
											if (SN == "GRDWARDTACTTACMIT") {
												if (L-DblCalcDev <= 105) {
													return CalcStat("GrdWardTactBase",L,CalcStat("GrdWardTactChoice",N));
												} else if (L-DblCalcDev <= 115) {
													return LinFmod(RoundDbl(CalcStat("GrdWardTactTacMit",105,N)),2,4,106,115,L,-1);
												} else if (L-DblCalcDev <= 116) {
													return ExpFmod(CalcStat("GrdWardTactTacMit",115,N),116,20,L);
												} else {
													return ExpFmod(CalcStat("GrdWardTactTacMit",116,N),117,5.5,L);
												}
											} else {
												return 0;
											}
										} else if (SN == "GRDWARDTACTCHOICE") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return DataTableValue([5,6,7,8,9],L);
											}
										} else {
											return 0;
										}
									} else {
										return (3.6*L+0.2)*N;
									}
								} else if (SN > "GUARDIANCDAGILITYTOCRITHIT") {
									if (SN < "GUARDIANCDAGILITYTOPARRY") {
										if (SN == "GUARDIANCDAGILITYTOEVADE") {
											return 3;
										} else {
											return 0;
										}
									} else if (SN > "GUARDIANCDAGILITYTOPARRY") {
										if (SN > "GUARDIANCDARMOURTOOFMIT") {
											if (SN == "GUARDIANCDARMOURTOPHYMIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "GUARDIANCDARMOURTOOFMIT") {
											return 0.2;
										} else {
											return 0;
										}
									} else {
										return 2;
									}
								} else {
									return 1;
								}
							} else if (SN > "GUARDIANCDARMOURTOTACMIT") {
								if (SN < "GUARDIANCDBASEICPR") {
									if (SN < "GUARDIANCDBASEAGILITY") {
										if (SN == "GUARDIANCDARMOURTYPE") {
											return 3;
										} else {
											return 0;
										}
									} else if (SN > "GUARDIANCDBASEAGILITY") {
										if (SN > "GUARDIANCDBASEFATE") {
											if (SN == "GUARDIANCDBASEICMR") {
												return CalcStat("ClassBaseICMRH",L);
											} else {
												return 0;
											}
										} else if (SN == "GUARDIANCDBASEFATE") {
											return CalcStat("ClassBaseMainA",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseMainC",L);
									}
								} else if (SN > "GUARDIANCDBASEICPR") {
									if (SN < "GUARDIANCDBASENCMR") {
										if (SN > "GUARDIANCDBASEMIGHT") {
											if (SN == "GUARDIANCDBASEMORALE") {
												if (L-DblCalcDev <= 120) {
													return CalcStat("ClassBaseMoraleHb",L);
												} else {
													return CalcStat("ClassBaseMoraleHb",120);
												}
											} else {
												return 0;
											}
										} else if (SN == "GUARDIANCDBASEMIGHT") {
											return CalcStat("ClassBaseMainH",L);
										} else {
											return 0;
										}
									} else if (SN > "GUARDIANCDBASENCMR") {
										if (SN > "GUARDIANCDBASENCPR") {
											if (SN == "GUARDIANCDBASEPOWER") {
												if (L-DblCalcDev <= 120) {
													return CalcStat("ClassBasePowerL",L);
												} else {
													return CalcStat("ClassBasePowerL",120);
												}
											} else {
												return 0;
											}
										} else if (SN == "GUARDIANCDBASENCPR") {
											return CalcStat("ClassBaseNCPR",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseNCMRH",L);
									}
								} else {
									return CalcStat("ClassBaseICPR",L);
								}
							} else {
								return 0.2;
							}
						} else {
							if (L-DblCalcDev <= 0) {
								return 0;
							} else {
								return DataTableValue([0.2,0.4,0.6,0.8],L);
							}
						}
					} else if (SN > "GUARDIANCDBASEVITALITY") {
						if (SN < "GUARDIANCDWILLTOTACMAS") {
							if (SN < "GUARDIANCDHASPOWER") {
								if (SN < "GUARDIANCDFATETOICMR") {
									if (SN < "GUARDIANCDCANBLOCK") {
										if (SN == "GUARDIANCDBASEWILL") {
											return CalcStat("ClassBaseMainF",L);
										} else {
											return 0;
										}
									} else if (SN > "GUARDIANCDCANBLOCK") {
										if (SN > "GUARDIANCDFATETOCRITHIT") {
											if (SN == "GUARDIANCDFATETOFINESSE") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "GUARDIANCDFATETOCRITHIT") {
											return 2.5;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else if (SN > "GUARDIANCDFATETOICMR") {
									if (SN < "GUARDIANCDFATETONCPR") {
										if (SN == "GUARDIANCDFATETOICPR") {
											return 1.71;
										} else {
											return 0;
										}
									} else if (SN > "GUARDIANCDFATETONCPR") {
										if (SN > "GUARDIANCDFATETORESIST") {
											if (SN == "GUARDIANCDFATETOTACMIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "GUARDIANCDFATETORESIST") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 24;
									}
								} else {
									return 1.5;
								}
							} else if (SN > "GUARDIANCDHASPOWER") {
								if (SN < "GUARDIANCDTACMASTOOUTHEAL") {
									if (SN < "GUARDIANCDMIGHTTOPARRY") {
										if (SN == "GUARDIANCDMIGHTTOBLOCK") {
											return 3;
										} else {
											return 0;
										}
									} else if (SN > "GUARDIANCDMIGHTTOPARRY") {
										if (SN > "GUARDIANCDMIGHTTOPHYMAS") {
											if (SN == "GUARDIANCDPHYMITTOOFMIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "GUARDIANCDMIGHTTOPHYMAS") {
											return 3;
										} else {
											return 0;
										}
									} else {
										return 2;
									}
								} else if (SN > "GUARDIANCDTACMASTOOUTHEAL") {
									if (SN < "GUARDIANCDVITALITYTORESIST") {
										if (SN > "GUARDIANCDVITALITYTOMORALE") {
											if (SN == "GUARDIANCDVITALITYTONCMR") {
												return 7.2;
											} else {
												return 0;
											}
										} else if (SN == "GUARDIANCDVITALITYTOMORALE") {
											return 5;
										} else {
											return 0;
										}
									} else if (SN > "GUARDIANCDVITALITYTORESIST") {
										if (SN > "GUARDIANCDWILLTOOUTHEAL") {
											if (SN == "GUARDIANCDWILLTORESIST") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "GUARDIANCDWILLTOOUTHEAL") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									return 1;
								}
							} else {
								return 1;
							}
						} else if (SN > "GUARDIANCDWILLTOTACMAS") {
							if (SN < "HNTCRITEYECHOICE") {
								if (SN < "HIGHELFRDTRAITFATE") {
									if (SN < "HIGHELFRDPSVONENAME") {
										if (SN == "GUARDIANCDWILLTOTACMIT") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "HIGHELFRDPSVONENAME") {
										if (SN > "HIGHELFRDPSVONEWILL") {
											if (SN == "HIGHELFRDPSVTWONAME") {
												return "";
											} else {
												return 0;
											}
										} else if (SN == "HIGHELFRDPSVONEWILL") {
											return CalcStat("RacialMain",L);
										} else {
											return 0;
										}
									} else {
										return "Those Who Remain";
									}
								} else if (SN > "HIGHELFRDTRAITFATE") {
									if (SN < "HIGHELFRDTRAITNCMR") {
										if (SN == "HIGHELFRDTRAITMORALE") {
											return 20;
										} else {
											return 0;
										}
									} else if (SN > "HIGHELFRDTRAITNCMR") {
										if (SN > "HIGHELFRDTRAITWILL") {
											if (SN == "HNTCRITEYEBASE") {
												return 0.01*N;
											} else {
												return 0;
											}
										} else if (SN == "HIGHELFRDTRAITWILL") {
											return -7;
										} else {
											return 0;
										}
									} else {
										return 60;
									}
								} else {
									return -7;
								}
							} else if (SN > "HNTCRITEYECHOICE") {
								if (SN < "HNTIMPARRRNGDMGP") {
									if (SN < "HNTELUSIVEEVADEP") {
										if (SN == "HNTCRITEYERNGCRITP") {
											return CalcStat("HntCritEyeBase",L,CalcStat("HntCritEyeChoice",N));
										} else {
											return 0;
										}
									} else if (SN > "HNTELUSIVEEVADEP") {
										if (SN > "HNTIMPARRBASE") {
											if (SN == "HNTIMPARRCHOICE") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return DataTableValue([1,2,3,4,5],L);
												}
											} else {
												return 0;
											}
										} else if (SN == "HNTIMPARRBASE") {
											return 0.01*N;
										} else {
											return 0;
										}
									} else {
										return CalcStat("BrgStickMoveEvadeP",L,N);
									}
								} else if (SN > "HNTIMPARRRNGDMGP") {
									if (SN < "HNTSURVGEARMITP") {
										if (SN > "HNTSURVGEARBASE") {
											if (SN == "HNTSURVGEARCHOICE") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return DataTableValue([1,2,3,4,5,8,15],L);
												}
											} else {
												return 0;
											}
										} else if (SN == "HNTSURVGEARBASE") {
											return 0.01*N;
										} else {
											return 0;
										}
									} else if (SN > "HNTSURVGEARMITP") {
										if (SN > "HNTSURVGEARPHYMITP") {
											if (SN == "HNTSURVGEARTACMITP") {
												return CalcStat("HntSurvGearMitP",L,N);
											} else {
												return 0;
											}
										} else if (SN == "HNTSURVGEARPHYMITP") {
											return CalcStat("HntSurvGearMitP",L,N);
										} else {
											return 0;
										}
									} else {
										return CalcStat("HntSurvGearBase",L,CalcStat("HntSurvGearChoice",N));
									}
								} else {
									return CalcStat("HntImpArrBase",L,CalcStat("HntImpArrChoice",N));
								}
							} else {
								if (L-DblCalcDev <= 0) {
									return 0;
								} else {
									return DataTableValue([1,2,3,4,5],L);
								}
							}
						} else {
							return 1;
						}
					} else {
						return CalcStat("ClassBaseMainJ",L);
					}
				} else {
					return CalcStat("BratLow",L);
				}
			} else if (SN > "HOBBITRDPSVONEMIGHT") {
				if (SN < "LOREMASTERCDARMOURTOOFMIT") {
					if (SN < "HUNTERCDVITALITYTOTACMIT") {
						if (SN < "HUNTERCDBASEMORALE") {
							if (SN < "HUNTERCDAGILITYTOPHYMAS") {
								if (SN < "HOBBITRDTRAITVITALITY") {
									if (SN < "HOBBITRDPSVTWONAME") {
										if (SN == "HOBBITRDPSVONENAME") {
											return "Hobbit-stature";
										} else {
											return 0;
										}
									} else if (SN > "HOBBITRDPSVTWONAME") {
										if (SN > "HOBBITRDTRAITMIGHT") {
											if (SN == "HOBBITRDTRAITNCMR") {
												return 60;
											} else {
												return 0;
											}
										} else if (SN == "HOBBITRDTRAITMIGHT") {
											return -7;
										} else {
											return 0;
										}
									} else {
										return "";
									}
								} else if (SN > "HOBBITRDTRAITVITALITY") {
									if (SN < "HUNTERCDAGILITYTOCRITHIT") {
										if (SN == "HOPEMORALEP") {
											if (L-DblCalcDev <= 5) {
												return DataTableValue([-0.99,-0.97,-0.95,-0.9,-0.85,-0.8,-0.65,-0.6,-0.5,-0.4,-0.3,-0.2,-0.15,-0.1,-0.05,0,0.01,0.02,0.03,0.04,0.05],L+16);
											} else {
												return 0.05;
											}
										} else {
											return 0;
										}
									} else if (SN > "HUNTERCDAGILITYTOCRITHIT") {
										if (SN > "HUNTERCDAGILITYTOEVADE") {
											if (SN == "HUNTERCDAGILITYTOPARRY") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "HUNTERCDAGILITYTOEVADE") {
											return 3;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									return 15;
								}
							} else if (SN > "HUNTERCDAGILITYTOPHYMAS") {
								if (SN < "HUNTERCDBASEAGILITY") {
									if (SN < "HUNTERCDARMOURTOPHYMIT") {
										if (SN == "HUNTERCDARMOURTOOFMIT") {
											return 0.2;
										} else {
											return 0;
										}
									} else if (SN > "HUNTERCDARMOURTOPHYMIT") {
										if (SN > "HUNTERCDARMOURTOTACMIT") {
											if (SN == "HUNTERCDARMOURTYPE") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "HUNTERCDARMOURTOTACMIT") {
											return 0.2;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else if (SN > "HUNTERCDBASEAGILITY") {
									if (SN < "HUNTERCDBASEICMR") {
										if (SN == "HUNTERCDBASEFATE") {
											return CalcStat("ClassBaseMainE",L);
										} else {
											return 0;
										}
									} else if (SN > "HUNTERCDBASEICMR") {
										if (SN > "HUNTERCDBASEICPR") {
											if (SN == "HUNTERCDBASEMIGHT") {
												return CalcStat("ClassBaseMainA",L);
											} else {
												return 0;
											}
										} else if (SN == "HUNTERCDBASEICPR") {
											return CalcStat("ClassBaseICPR",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseICMRM",L);
									}
								} else {
									return CalcStat("ClassBaseMainL",L);
								}
							} else {
								return 3;
							}
						} else if (SN > "HUNTERCDBASEMORALE") {
							if (SN < "HUNTERCDFATETONCPR") {
								if (SN < "HUNTERCDBASEWILL") {
									if (SN < "HUNTERCDBASENCPR") {
										if (SN == "HUNTERCDBASENCMR") {
											return CalcStat("ClassBaseNCMRM",L);
										} else {
											return 0;
										}
									} else if (SN > "HUNTERCDBASENCPR") {
										if (SN > "HUNTERCDBASEPOWER") {
											if (SN == "HUNTERCDBASEVITALITY") {
												return CalcStat("ClassBaseMainC",L);
											} else {
												return 0;
											}
										} else if (SN == "HUNTERCDBASEPOWER") {
											if (L-DblCalcDev <= 120) {
												return CalcStat("ClassBasePowerL",L);
											} else {
												return CalcStat("ClassBasePowerL",120);
											}
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseNCPR",L);
									}
								} else if (SN > "HUNTERCDBASEWILL") {
									if (SN < "HUNTERCDFATETOFINESSE") {
										if (SN == "HUNTERCDFATETOCRITHIT") {
											return 2.5;
										} else {
											return 0;
										}
									} else if (SN > "HUNTERCDFATETOFINESSE") {
										if (SN > "HUNTERCDFATETOICMR") {
											if (SN == "HUNTERCDFATETOICPR") {
												return 1.71;
											} else {
												return 0;
											}
										} else if (SN == "HUNTERCDFATETOICMR") {
											return 1.5;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									return CalcStat("ClassBaseMainH",L);
								}
							} else if (SN > "HUNTERCDFATETONCPR") {
								if (SN < "HUNTERCDMIGHTTOPARRY") {
									if (SN < "HUNTERCDFATETOTACMIT") {
										if (SN == "HUNTERCDFATETORESIST") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "HUNTERCDFATETOTACMIT") {
										if (SN > "HUNTERCDHASPOWER") {
											if (SN == "HUNTERCDMIGHTTOBLOCK") {
												return 3;
											} else {
												return 0;
											}
										} else if (SN == "HUNTERCDHASPOWER") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else if (SN > "HUNTERCDMIGHTTOPARRY") {
									if (SN < "HUNTERCDVITALITYTOMORALE") {
										if (SN > "HUNTERCDPHYMITTOOFMIT") {
											if (SN == "HUNTERCDTACMASTOOUTHEAL") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "HUNTERCDPHYMITTOOFMIT") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "HUNTERCDVITALITYTOMORALE") {
										if (SN > "HUNTERCDVITALITYTONCMR") {
											if (SN == "HUNTERCDVITALITYTORESIST") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "HUNTERCDVITALITYTONCMR") {
											return 7.2;
										} else {
											return 0;
										}
									} else {
										return 4;
									}
								} else {
									return 2;
								}
							} else {
								return 24;
							}
						} else {
							if (L-DblCalcDev <= 120) {
								return CalcStat("ClassBaseMoraleMa",L);
							} else {
								return CalcStat("ClassBaseMoraleMa",120);
							}
						}
					} else if (SN > "HUNTERCDVITALITYTOTACMIT") {
						if (SN < "INSTRRAWMORALE") {
							if (SN < "INHEALPPRAT") {
								if (SN < "ICMR") {
									if (SN < "HUNTERCDWILLTORESIST") {
										if (SN == "HUNTERCDWILLTOOUTHEAL") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "HUNTERCDWILLTORESIST") {
										if (SN > "HUNTERCDWILLTOTACMAS") {
											if (SN == "HUNTERCDWILLTOTACMIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "HUNTERCDWILLTOTACMAS") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 2;
									}
								} else if (SN > "ICMR") {
									if (SN < "ILVLTOLVL") {
										if (SN == "ICPR") {
											return CalcStat("PntMPICPR",L)*CalcStat("ItemProg",L,CalcStat("ProgBPowReg",L))*CalcStat("AdjItemProgPowReg",L,CalcStat("ProgBPowReg",L))*N;
										} else {
											return 0;
										}
									} else if (SN > "ILVLTOLVL") {
										if (SN > "INHEAL") {
											if (SN == "INHEALPBONUS") {
												return 0;
											} else {
												return 0;
											}
										} else if (SN == "INHEAL") {
											return CalcStat("RatOffence",L,N);
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 79) {
											return LinFmod(1,1,75,1,79,L)*N;
										} else if (L-DblCalcDev <= 80) {
											return LinFmod(1,75,76,79,80,L)*N;
										} else if (L-DblCalcDev <= 200) {
											return LinFmod(1,76,100,80,200,L)*N;
										} else if (L-DblCalcDev <= 205) {
											return LinFmod(1,100,101,200,205,L)*N;
										} else if (L-DblCalcDev <= 225) {
											return LinFmod(1,101,105,205,225,L)*N;
										} else if (L-DblCalcDev <= 300) {
											return LinFmod(1,105,106,225,300,L)*N;
										} else if (L-DblCalcDev <= 349) {
											return LinFmod(1,106,115,300,349,L)*N;
										} else if (L-DblCalcDev <= 350) {
											return LinFmod(1,115,116,349,350,L)*N;
										} else if (L-DblCalcDev <= 399) {
											return LinFmod(1,116,120,350,399,L)*N;
										} else if (L-DblCalcDev <= 400) {
											return LinFmod(1,120,121,399,400,L)*N;
										} else if (L-DblCalcDev <= 449) {
											return LinFmod(1,121,130,400,449,L)*N;
										} else if (L-DblCalcDev <= 450) {
											return LinFmod(1,130,131,449,450,L)*N;
										} else {
											return LinFmod(1,131,140,450,499,L)*N;
										}
									}
								} else {
									return CalcStat("PntMPICMR",L)*CalcStat("ItemProg",L,CalcStat("ProgBMorReg",L))*CalcStat("AdjItemProgMorReg",L,CalcStat("ProgBMorReg",L))*N;
								}
							} else if (SN > "INHEALPPRAT") {
								if (SN < "INHEALPRATPCAP") {
									if (SN < "INHEALPRATPA") {
										if (SN == "INHEALPRATP") {
											return CalcPercAB(CalcStat("InHealPRatPA",L),CalcStat("InHealPRatPB",L),CalcStat("InHealPRatPCap",L),N);
										} else {
											return 0;
										}
									} else if (SN > "INHEALPRATPA") {
										if (SN > "INHEALPRATPB") {
											if (SN == "INHEALPRATPC") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "INHEALPRATPB") {
											return CalcStat("BratLow",L);
										} else {
											return 0;
										}
									} else {
										return 50;
									}
								} else if (SN > "INHEALPRATPCAP") {
									if (SN < "INHEALT") {
										if (SN == "INHEALPRATPCAPR") {
											return CalcStat("InHealPRatPB",L)*CalcStat("InHealPRatPC",L);
										} else {
											return 0;
										}
									} else if (SN > "INHEALT") {
										if (SN > "INSTRMORALE") {
											if (SN == "INSTRPOWER") {
												return RoundDbl(CalcStat("InstrRawPower",L));
											} else {
												return 0;
											}
										} else if (SN == "INSTRMORALE") {
											return RoundDbl(CalcStat("InstrRawMorale",L));
										} else {
											return 0;
										}
									} else {
										return CalcStat("RatOffenceT",L,N);
									}
								} else {
									return 25;
								}
							} else {
								return CalcRatAB(CalcStat("InHealPRatPA",L),CalcStat("InHealPRatPB",L),CalcStat("InHealPRatPCapR",L),N);
							}
						} else if (SN > "INSTRRAWMORALE") {
							if (SN < "LMANCIENTWISDOMWILL") {
								if (SN < "ITEMPROG") {
									if (SN < "ITEMMORALEADJPROG") {
										if (SN == "INSTRRAWPOWER") {
											if (L-DblCalcDev <= 9) {
												return 0.95*L+12.6;
											} else if (L-DblCalcDev <= 18) {
												return 1.95*L+3;
											} else if (L-DblCalcDev <= 26) {
												return 2.95*L-15.55;
											} else if (L-DblCalcDev <= 35) {
												return 3.95*L-42.15;
											} else if (L-DblCalcDev <= 42) {
												return 4.95*L-77.7;
											} else if (L-DblCalcDev <= 45) {
												return 5.95*L-120.35;
											} else if (L-DblCalcDev <= 105) {
												return 6*L-124;
											} else if (L-DblCalcDev <= 114) {
												return ExpFmod(CalcStat("InstrRawPower",105),106,7.52,L);
											} else if (L-DblCalcDev <= 115) {
												return ExpFmod(CalcStat("InstrRawPower",114),115,4.13,L);
											} else if (L-DblCalcDev <= 119) {
												return ExpFmod(CalcStat("InstrRawPower",115),116,25,L);
											} else if (L-DblCalcDev <= 120) {
												return ExpFmod(CalcStat("InstrRawPower",119),120,9.25,L);
											} else if (L-DblCalcDev <= 121) {
												return ExpFmod(CalcStat("InstrRawPower",120),121,20,L);
											} else if (L-DblCalcDev <= 125) {
												return ExpFmod(CalcStat("InstrRawPower",121),122,5.498,L);
											} else if (L-DblCalcDev <= 126) {
												return ExpFmod(CalcStat("InstrRawPower",125),126,20,L);
											} else {
												return ExpFmod(CalcStat("InstrRawPower",126),127,5.5,L);
											}
										} else {
											return 0;
										}
									} else if (SN > "ITEMMORALEADJPROG") {
										if (SN > "ITEMMORALEPROG") {
											if (SN == "ITEMMORALESMPROG") {
												if (L-DblCalcDev <= 39) {
													return LinFmod(1,CalcStat("ItemProg",1,N),RoundDbl(N)*37,1,39,L);
												} else if (L-DblCalcDev <= 40) {
													return LinFmod(RoundDbl(N),37,37.5,39,40,L);
												} else if (L-DblCalcDev <= 50) {
													return LinFmod(RoundDbl(N),37.5,45,40,50,L);
												} else if (L-DblCalcDev <= 80) {
													return LinFmod(1,RoundDbl(N)*45,CalcStat("ItemProg",80,N),50,80,L);
												} else {
													return CalcStat("ItemProg",L,N);
												}
											} else {
												return 0;
											}
										} else if (SN == "ITEMMORALEPROG") {
											if (L-DblCalcDev <= 50) {
												return LinFmod(1,CalcStat("ItemProg",1,N),RoundDbl(N)*45,1,50,L);
											} else if (L-DblCalcDev <= 80) {
												return LinFmod(1,RoundDbl(N)*45,CalcStat("ItemProg",80,N),50,80,L);
											} else {
												return CalcStat("ItemProg",L,N);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 39) {
											return LinFmod(1,CalcStat("ItemProg",1,N),RoundDbl(N)*37,1,39,L);
										} else if (L-DblCalcDev <= 40) {
											return LinFmod(RoundDbl(N),37,12.5,39,40,L);
										} else if (L-DblCalcDev <= 50) {
											return LinFmod(RoundDbl(N),12.5,45,40,50,L);
										} else if (L-DblCalcDev <= 80) {
											return LinFmod(1,RoundDbl(N)*45,CalcStat("ItemProg",80,N),50,80,L);
										} else {
											return CalcStat("ItemProg",L,N);
										}
									}
								} else if (SN > "ITEMPROG") {
									if (SN < "ITEMVITALITYPROG") {
										if (SN == "ITEMVITALITYADJPROG") {
											if (L-DblCalcDev <= 39) {
												return LinFmod(1,CalcStat("ItemProg",1,N),RoundDbl(N)*37,1,39,L);
											} else if (L-DblCalcDev <= 40) {
												return LinFmod(RoundDbl(N),37,12.5,39,40,L);
											} else if (L-DblCalcDev <= 50) {
												return LinFmod(RoundDbl(N),12.5,30,40,50,L);
											} else if (L-DblCalcDev <= 80) {
												return LinFmod(1,RoundDbl(N)*30,CalcStat("ItemProg",80,N),50,80,L);
											} else {
												return CalcStat("ItemProg",L,N);
											}
										} else {
											return 0;
										}
									} else if (SN > "ITEMVITALITYPROG") {
										if (SN > "ITEMVITALITYSMPROG") {
											if (SN == "LMANCIENTWISDOMRAW") {
												if (L-DblCalcDev <= 105) {
													return 1.1*L;
												} else if (L-DblCalcDev <= 115) {
													return ExpFmod(CalcStat("LMAncientWisdomRaw",105),106,5.5,L);
												} else if (L-DblCalcDev <= 116) {
													return ExpFmod(CalcStat("LMAncientWisdomRaw",115),116,19.75,L);
												} else if (L-DblCalcDev <= 120) {
													return ExpFmod(CalcStat("LMAncientWisdomRaw",116),117,5.45,L);
												} else if (L-DblCalcDev <= 121) {
													return ExpFmod(CalcStat("LMAncientWisdomRaw",120),121,19.75,L);
												} else if (L-DblCalcDev <= 125) {
													return ExpFmod(CalcStat("LMAncientWisdomRaw",121),122,5.45,L);
												} else if (L-DblCalcDev <= 126) {
													return ExpFmod(CalcStat("LMAncientWisdomRaw",125),126,20.3,L);
												} else {
													return ExpFmod(CalcStat("LMAncientWisdomRaw",126),127,5.5,L);
												}
											} else {
												return 0;
											}
										} else if (SN == "ITEMVITALITYSMPROG") {
											if (L-DblCalcDev <= 39) {
												return LinFmod(1,CalcStat("ItemProg",1,N),RoundDbl(N)*22.62,1,39,L);
											} else if (L-DblCalcDev <= 40) {
												return LinFmod(RoundDbl(N),22.62,23.2,39,40,L);
											} else if (L-DblCalcDev <= 50) {
												return LinFmod(RoundDbl(N),23.2,30,40,50,L);
											} else if (L-DblCalcDev <= 80) {
												return LinFmod(1,RoundDbl(N)*30,CalcStat("ItemProg",80,N),50,80,L);
											} else {
												return CalcStat("ItemProg",L,N);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 50) {
											return LinFmod(1,CalcStat("ItemProg",1,N),RoundDbl(N)*30,1,50,L);
										} else if (L-DblCalcDev <= 80) {
											return LinFmod(1,RoundDbl(N)*30,CalcStat("ItemProg",80,N),50,80,L);
										} else {
											return CalcStat("ItemProg",L,N);
										}
									}
								} else {
									return CalcStat("StatProg",CalcStat("ILvlToLvl",L),N);
								}
							} else if (SN > "LMANCIENTWISDOMWILL") {
								if (SN < "LMSWSTAFFBUGPARRY") {
									if (SN < "LMHEARTYDIETCHOICE") {
										if (SN == "LMHEARTYDIETBASE") {
											if (L-DblCalcDev <= 50) {
												return RoundDbl((0.8982*L+0.605)*N);
											} else {
												return RoundDbl((4*L-154.5)*N);
											}
										} else {
											return 0;
										}
									} else if (SN > "LMHEARTYDIETCHOICE") {
										if (SN > "LMHEARTYDIETMORALE") {
											if (SN == "LMSWSTAFFBUGMORALE") {
												if (L-DblCalcDev <= 105) {
													return 6.64;
												} else {
													return ExpFmod(RoundDbl(CalcStat("LMSwStaffBugMorale",105)),106,5.5,L);
												}
											} else {
												return 0;
											}
										} else if (SN == "LMHEARTYDIETMORALE") {
											if (L-DblCalcDev <= 105) {
												return CalcStat("LmHeartyDietBase",L,CalcStat("LmHeartyDietChoice",N));
											} else if (L-DblCalcDev <= 115) {
												return ExpFmod(CalcStat("LmHeartyDietMorale",105,N),106,5.5,L);
											} else if (L-DblCalcDev <= 116) {
												return ExpFmod(CalcStat("LmHeartyDietMorale",115,N),116,20,L);
											} else {
												return ExpFmod(CalcStat("LmHeartyDietMorale",116,N),117,5.5,L);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return DataTableValue([2,3,4,5,6],L);
										}
									}
								} else if (SN > "LMSWSTAFFBUGPARRY") {
									if (SN < "LOREMASTERCDAGILITYTOCRITHIT") {
										if (SN > "LOE") {
											if (SN == "LOEPASSIVE") {
												if (L-DblCalcDev <= 115) {
													return 0;
												} else if (L-DblCalcDev <= 119) {
													return 20*L-2300;
												} else {
													return CalcStat("LoEPassive",119);
												}
											} else {
												return 0;
											}
										} else if (SN == "LOE") {
											return 2*N;
										} else {
											return 0;
										}
									} else if (SN > "LOREMASTERCDAGILITYTOCRITHIT") {
										if (SN > "LOREMASTERCDAGILITYTOEVADE") {
											if (SN == "LOREMASTERCDAGILITYTOPARRY") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "LOREMASTERCDAGILITYTOEVADE") {
											return 3;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									if (L-DblCalcDev <= 105) {
										return (2000/45)*L-0.5;
									} else {
										return LinFmod(RoundDbl(CalcStat("LMSwStaffBugParry",105)),2,4,106,115,L,-1);
									}
								}
							} else {
								return RoundDbl(CalcStat("LMAncientWisdomRaw",L));
							}
						} else {
							if (L-DblCalcDev <= 105) {
								return 4.04*L;
							} else if (L-DblCalcDev <= 115) {
								return ExpFmod(CalcStat("InstrRawMorale",105),106,5.485,L);
							} else if (L-DblCalcDev <= 116) {
								return ExpFmod(CalcStat("InstrRawMorale",115),116,20.1,L);
							} else if (L-DblCalcDev <= 120) {
								return ExpFmod(CalcStat("InstrRawMorale",116),117,5.49,L);
							} else if (L-DblCalcDev <= 121) {
								return ExpFmod(CalcStat("InstrRawMorale",120),121,20,L);
							} else if (L-DblCalcDev <= 125) {
								return ExpFmod(CalcStat("InstrRawMorale",121),122,5.49,L);
							} else if (L-DblCalcDev <= 126) {
								return ExpFmod(CalcStat("InstrRawMorale",125),126,20,L);
							} else {
								return ExpFmod(CalcStat("InstrRawMorale",126),127,5.5,L);
							}
						}
					} else {
						return 1;
					}
				} else if (SN > "LOREMASTERCDARMOURTOOFMIT") {
					if (SN < "MANRDPSVONENAME") {
						if (SN < "LOREMASTERCDFATETOTACMIT") {
							if (SN < "LOREMASTERCDBASENCMR") {
								if (SN < "LOREMASTERCDBASEFATE") {
									if (SN < "LOREMASTERCDARMOURTOTACMIT") {
										if (SN == "LOREMASTERCDARMOURTOPHYMIT") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "LOREMASTERCDARMOURTOTACMIT") {
										if (SN > "LOREMASTERCDARMOURTYPE") {
											if (SN == "LOREMASTERCDBASEAGILITY") {
												return CalcStat("ClassBaseMainF",L);
											} else {
												return 0;
											}
										} else if (SN == "LOREMASTERCDARMOURTYPE") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 0.2;
									}
								} else if (SN > "LOREMASTERCDBASEFATE") {
									if (SN < "LOREMASTERCDBASEICPR") {
										if (SN == "LOREMASTERCDBASEICMR") {
											return CalcStat("ClassBaseICMRL",L);
										} else {
											return 0;
										}
									} else if (SN > "LOREMASTERCDBASEICPR") {
										if (SN > "LOREMASTERCDBASEMIGHT") {
											if (SN == "LOREMASTERCDBASEMORALE") {
												if (L-DblCalcDev <= 120) {
													return CalcStat("ClassBaseMoraleL",L);
												} else {
													return CalcStat("ClassBaseMoraleL",120);
												}
											} else {
												return 0;
											}
										} else if (SN == "LOREMASTERCDBASEMIGHT") {
											return CalcStat("ClassBaseMainA",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseICPR",L);
									}
								} else {
									return CalcStat("ClassBaseMainJ",L);
								}
							} else if (SN > "LOREMASTERCDBASENCMR") {
								if (SN < "LOREMASTERCDFATETOCRITHIT") {
									if (SN < "LOREMASTERCDBASEPOWER") {
										if (SN == "LOREMASTERCDBASENCPR") {
											return CalcStat("ClassBaseNCPR",L);
										} else {
											return 0;
										}
									} else if (SN > "LOREMASTERCDBASEPOWER") {
										if (SN > "LOREMASTERCDBASEVITALITY") {
											if (SN == "LOREMASTERCDBASEWILL") {
												return CalcStat("ClassBaseMainH",L);
											} else {
												return 0;
											}
										} else if (SN == "LOREMASTERCDBASEVITALITY") {
											return CalcStat("ClassBaseMainC",L);
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 120) {
											return CalcStat("ClassBasePowerH",L);
										} else {
											return CalcStat("ClassBasePowerH",120);
										}
									}
								} else if (SN > "LOREMASTERCDFATETOCRITHIT") {
									if (SN < "LOREMASTERCDFATETOICPR") {
										if (SN == "LOREMASTERCDFATETOICMR") {
											return 1.5;
										} else {
											return 0;
										}
									} else if (SN > "LOREMASTERCDFATETOICPR") {
										if (SN > "LOREMASTERCDFATETONCPR") {
											if (SN == "LOREMASTERCDFATETORESIST") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "LOREMASTERCDFATETONCPR") {
											return 24;
										} else {
											return 0;
										}
									} else {
										return 1.71;
									}
								} else {
									return 2.5;
								}
							} else {
								return CalcStat("ClassBaseNCMRL",L);
							}
						} else if (SN > "LOREMASTERCDFATETOTACMIT") {
							if (SN < "LOREMASTERCDWILLTOEVADE") {
								if (SN < "LOREMASTERCDTACMASTOOUTHEAL") {
									if (SN < "LOREMASTERCDMIGHTTOBLOCK") {
										if (SN == "LOREMASTERCDHASPOWER") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "LOREMASTERCDMIGHTTOBLOCK") {
										if (SN > "LOREMASTERCDMIGHTTOPARRY") {
											if (SN == "LOREMASTERCDPHYMITTOOFMIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "LOREMASTERCDMIGHTTOPARRY") {
											return 2;
										} else {
											return 0;
										}
									} else {
										return 3;
									}
								} else if (SN > "LOREMASTERCDTACMASTOOUTHEAL") {
									if (SN < "LOREMASTERCDVITALITYTONCMR") {
										if (SN == "LOREMASTERCDVITALITYTOMORALE") {
											return 4;
										} else {
											return 0;
										}
									} else if (SN > "LOREMASTERCDVITALITYTONCMR") {
										if (SN > "LOREMASTERCDVITALITYTORESIST") {
											if (SN == "LOREMASTERCDVITALITYTOTACMIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "LOREMASTERCDVITALITYTORESIST") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 7.2;
									}
								} else {
									return 1;
								}
							} else if (SN > "LOREMASTERCDWILLTOEVADE") {
								if (SN < "LOREMASTERCDWILLTOTACMIT") {
									if (SN < "LOREMASTERCDWILLTOOUTHEAL") {
										if (SN == "LOREMASTERCDWILLTOFINESSE") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "LOREMASTERCDWILLTOOUTHEAL") {
										if (SN > "LOREMASTERCDWILLTORESIST") {
											if (SN == "LOREMASTERCDWILLTOTACMAS") {
												return 3;
											} else {
												return 0;
											}
										} else if (SN == "LOREMASTERCDWILLTORESIST") {
											return 2;
										} else {
											return 0;
										}
									} else {
										return 3;
									}
								} else if (SN > "LOREMASTERCDWILLTOTACMIT") {
									if (SN < "MAINRAW") {
										if (SN > "LVLTOILVL") {
											if (SN == "MAIN") {
												return FloorDbl(CalcStat("MainRaw",L,N));
											} else {
												return 0;
											}
										} else if (SN == "LVLTOILVL") {
											if (L-DblCalcDev <= 75) {
												return LinFmod(1,1,79,1,75,L)*N;
											} else if (L-DblCalcDev <= 76) {
												return LinFmod(1,79,80,75,76,L)*N;
											} else if (L-DblCalcDev <= 100) {
												return LinFmod(1,80,200,76,100,L)*N;
											} else if (L-DblCalcDev <= 101) {
												return LinFmod(1,200,205,100,101,L)*N;
											} else if (L-DblCalcDev <= 105) {
												return LinFmod(1,205,225,101,105,L)*N;
											} else if (L-DblCalcDev <= 106) {
												return LinFmod(1,225,300,105,106,L)*N;
											} else if (L-DblCalcDev <= 115) {
												return LinFmod(1,300,349,106,115,L)*N;
											} else if (L-DblCalcDev <= 116) {
												return LinFmod(1,349,350,115,116,L)*N;
											} else if (L-DblCalcDev <= 120) {
												return LinFmod(1,350,399,116,120,L)*N;
											} else if (L-DblCalcDev <= 121) {
												return LinFmod(1,399,400,120,121,L)*N;
											} else if (L-DblCalcDev <= 130) {
												return LinFmod(1,400,449,121,130,L)*N;
											} else if (L-DblCalcDev <= 131) {
												return LinFmod(1,449,450,130,131,L)*N;
											} else {
												return LinFmod(1,450,499,131,140,L)*N;
											}
										} else {
											return 0;
										}
									} else if (SN > "MAINRAW") {
										if (SN > "MAINT") {
											if (SN == "MAINTRAW") {
												return CalcStat("PntMPMain",L)*CalcStat("TraitProg",L,CalcStat("ProgBMain",L))*CalcStat("AdjTraitProgMain",L,CalcStat("ProgBMain",L))*N;
											} else {
												return 0;
											}
										} else if (SN == "MAINT") {
											return FloorDbl(CalcStat("MainTRaw",L,N));
										} else {
											return 0;
										}
									} else {
										return CalcStat("PntMPMain",L)*CalcStat("ItemProg",L,CalcStat("ProgBMain",L))*CalcStat("AdjItemProgMain",L,CalcStat("ProgBMain",L))*N;
									}
								} else {
									return 1;
								}
							} else {
								return 1;
							}
						} else {
							return 1;
						}
					} else if (SN > "MANRDPSVONENAME") {
						if (SN < "MINPROWESSEVADE") {
							if (SN < "MAXMPMOR") {
								if (SN < "MANRDPSVTWOPARRY") {
									if (SN < "MANRDPSVTWOBLOCK") {
										if (SN == "MANRDPSVONEWILL") {
											return CalcStat("RacialMain",L);
										} else {
											return 0;
										}
									} else if (SN > "MANRDPSVTWOBLOCK") {
										if (SN > "MANRDPSVTWOEVADE") {
											if (SN == "MANRDPSVTWONAME") {
												return "Balance of Man";
											} else {
												return 0;
											}
										} else if (SN == "MANRDPSVTWOEVADE") {
											return CalcStat("BalanceOfManAvoid",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("BalanceOfManAvoid",L);
									}
								} else if (SN > "MANRDPSVTWOPARRY") {
									if (SN < "MANRDTRAITINHEALP") {
										if (SN == "MANRDTRAITFATE") {
											return 15;
										} else {
											return 0;
										}
									} else if (SN > "MANRDTRAITINHEALP") {
										if (SN > "MANRDTRAITMIGHT") {
											if (SN == "MANRDTRAITWILL") {
												return -7;
											} else {
												return 0;
											}
										} else if (SN == "MANRDTRAITMIGHT") {
											return 15;
										} else {
											return 0;
										}
									} else {
										return 5;
									}
								} else {
									return CalcStat("BalanceOfManAvoid",L);
								}
							} else if (SN > "MAXMPMOR") {
								if (SN < "MINCOMPOSURETACMIT") {
									if (SN < "MIGHT") {
										if (SN == "MAXMPPOW") {
											if (L-DblCalcDev <= 5) {
												return 4*L+91;
											} else if (L-DblCalcDev <= 64) {
												return L+106;
											} else {
												return 2*L+42;
											}
										} else {
											return 0;
										}
									} else if (SN > "MIGHT") {
										if (SN > "MIGHTT") {
											if (SN == "MINCOMPOSURERESIST") {
												if (L-DblCalcDev <= 12) {
													return (8*L+1)*N;
												} else if (L-DblCalcDev <= 19) {
													return 12.17*L*N;
												} else if (L-DblCalcDev <= 26) {
													return (16.15*L+2)*N;
												} else if (L-DblCalcDev <= 33) {
													return (20.3*L-0.3)*N;
												} else if (L-DblCalcDev <= 40) {
													return (24.4*L-1.75)*N;
												} else if (L-DblCalcDev <= 47) {
													return (28.4*L+0.2)*N;
												} else if (L-DblCalcDev <= 105) {
													return (32.505*L-1.75)*N;
												} else if (L-DblCalcDev <= 115) {
													return LinFmod(RoundDbl(CalcStat("MinComposureResist",105)),2,4,106,115,L,-1)*N;
												} else if (L-DblCalcDev <= 116) {
													return ExpFmod(RoundDbl(CalcStat("MinComposureResist",115)),116,20,L)*N;
												} else {
													return ExpFmod(RoundDbl(CalcStat("MinComposureResist",116)),117,5.5,L)*N;
												}
											} else {
												return 0;
											}
										} else if (SN == "MIGHTT") {
											return CalcStat("MainT",L,N);
										} else {
											return 0;
										}
									} else {
										return CalcStat("Main",L,N);
									}
								} else if (SN > "MINCOMPOSURETACMIT") {
									if (SN < "MINFINESSE") {
										if (SN > "MINENDMORALE") {
											if (SN == "MINENDMORCHOICE") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return DataTableValue([2,2.4,3,3.4,4],L);
												}
											} else {
												return 0;
											}
										} else if (SN == "MINENDMORALE") {
											return CalcStat("Morale",L,CalcStat("MinEndMorChoice",N));
										} else {
											return 0;
										}
									} else if (SN > "MINFINESSE") {
										if (SN > "MINFINESSECHOICE") {
											if (SN == "MINPROWESSARMOUR") {
												if (L-DblCalcDev <= 105) {
													return RoundDbl(CalcStat("TraitsLowSeg",L,9.191));
												} else if (L-DblCalcDev <= 115) {
													return RoundDbl(LinFmod(CalcStat("MinProwessArmour",105),2,4,106,115,L,-1)*N);
												} else if (L-DblCalcDev <= 116) {
													return RoundDbl(ExpFmod(CalcStat("MinProwessArmour",115),116,20,L)*N);
												} else {
													return RoundDbl(ExpFmod(CalcStat("MinProwessArmour",116),117,5.5025,L)*N);
												}
											} else {
												return 0;
											}
										} else if (SN == "MINFINESSECHOICE") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return DataTableValue([0.4,0.8,1.2,1.6,2],L);
											}
										} else {
											return 0;
										}
									} else {
										return CalcStat("FinesseT",L,CalcStat("MinFinesseChoice",N));
									}
								} else {
									if (L-DblCalcDev <= 105) {
										return ((50/3)*L)*N;
									} else if (L-DblCalcDev <= 115) {
										return LinFmod(RoundDbl(CalcStat("MinComposureTacMit",105)),2,4,106,115,L,-1)*N;
									} else if (L-DblCalcDev <= 116) {
										return ExpFmod(RoundDbl(CalcStat("MinComposureTacMit",115)),116,20,L)*N;
									} else {
										return ExpFmod(RoundDbl(CalcStat("MinComposureTacMit",116)),117,5.4975,L)*N;
									}
								}
							} else {
								if (L-DblCalcDev <= 5) {
									return 8*L+141;
								} else if (L-DblCalcDev <= 14) {
									return 3*L+166;
								} else if (L-DblCalcDev <= 44) {
									return L+194;
								} else if (L-DblCalcDev <= 64) {
									return 2*L+150;
								} else if (L-DblCalcDev <= 85) {
									return 3*L+86;
								} else if (L-DblCalcDev <= 86) {
									return RoundDbl(ExpFmod(CalcStat("MaxMPMor",85),86,12,L));
								} else if (L-DblCalcDev <= 95) {
									return RoundDbl(ExpFmod(CalcStat("MaxMPMor",86),87,2.01,L));
								} else if (L-DblCalcDev <= 96) {
									return RoundDbl(ExpFmod(CalcStat("MaxMPMor",95),96,12,L));
								} else if (L-DblCalcDev <= 100) {
									return RoundDbl(ExpFmod(CalcStat("MaxMPMor",96),97,1.98,L));
								} else if (L-DblCalcDev <= 101) {
									return RoundDbl(ExpFmod(CalcStat("MaxMPMor",100),101,12,L));
								} else if (L-DblCalcDev <= 105) {
									return RoundDbl(ExpFmod(CalcStat("MaxMPMor",101),102,2,L));
								} else if (L-DblCalcDev <= 106) {
									return RoundDbl(ExpFmod(CalcStat("MaxMPMor",105),106,20,L));
								} else if (L-DblCalcDev <= 115) {
									return RoundDbl(ExpFmod(CalcStat("MaxMPMor",106),107,3.9885,L));
								} else if (L-DblCalcDev <= 116) {
									return RoundDbl(ExpFmod(CalcStat("MaxMPMor",115),116,10,L));
								} else {
									return RoundDbl(ExpFmod(CalcStat("MaxMPMor",116),117,3.975,L));
								}
							}
						} else if (SN > "MINPROWESSEVADE") {
							if (SN < "MINSTRELCDBASEFATE") {
								if (SN < "MINSTRELCDARMOURTOOFMIT") {
									if (SN < "MINSTRELCDAGILITYTOCRITHIT") {
										if (SN == "MINRESOLUTEBLOCK") {
											return CalcStat("BlockT",L,3.2);
										} else {
											return 0;
										}
									} else if (SN > "MINSTRELCDAGILITYTOCRITHIT") {
										if (SN > "MINSTRELCDAGILITYTOEVADE") {
											if (SN == "MINSTRELCDAGILITYTOPARRY") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "MINSTRELCDAGILITYTOEVADE") {
											return 3;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else if (SN > "MINSTRELCDARMOURTOOFMIT") {
									if (SN < "MINSTRELCDARMOURTOTACMIT") {
										if (SN == "MINSTRELCDARMOURTOPHYMIT") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "MINSTRELCDARMOURTOTACMIT") {
										if (SN > "MINSTRELCDARMOURTYPE") {
											if (SN == "MINSTRELCDBASEAGILITY") {
												return CalcStat("ClassBaseMainA",L);
											} else {
												return 0;
											}
										} else if (SN == "MINSTRELCDARMOURTYPE") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 0.2;
									}
								} else {
									return 0.2;
								}
							} else if (SN > "MINSTRELCDBASEFATE") {
								if (SN < "MINSTRELCDBASENCMR") {
									if (SN < "MINSTRELCDBASEICPR") {
										if (SN == "MINSTRELCDBASEICMR") {
											return CalcStat("ClassBaseICMRL",L);
										} else {
											return 0;
										}
									} else if (SN > "MINSTRELCDBASEICPR") {
										if (SN > "MINSTRELCDBASEMIGHT") {
											if (SN == "MINSTRELCDBASEMORALE") {
												if (L-DblCalcDev <= 120) {
													return CalcStat("ClassBaseMoraleL",L);
												} else {
													return CalcStat("ClassBaseMoraleL",120);
												}
											} else {
												return 0;
											}
										} else if (SN == "MINSTRELCDBASEMIGHT") {
											return CalcStat("ClassBaseMainF",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseICPR",L);
									}
								} else if (SN > "MINSTRELCDBASENCMR") {
									if (SN < "MINSTRELCDBASEVITALITY") {
										if (SN > "MINSTRELCDBASENCPR") {
											if (SN == "MINSTRELCDBASEPOWER") {
												if (L-DblCalcDev <= 120) {
													return CalcStat("ClassBasePowerH",L);
												} else {
													return CalcStat("ClassBasePowerH",120);
												}
											} else {
												return 0;
											}
										} else if (SN == "MINSTRELCDBASENCPR") {
											return CalcStat("ClassBaseNCPR",L);
										} else {
											return 0;
										}
									} else if (SN > "MINSTRELCDBASEVITALITY") {
										if (SN > "MINSTRELCDBASEWILL") {
											if (SN == "MINSTRELCDCANBLOCK") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "MINSTRELCDBASEWILL") {
											return CalcStat("ClassBaseMainJ",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseMainC",L);
									}
								} else {
									return CalcStat("ClassBaseNCMRL",L);
								}
							} else {
								return CalcStat("ClassBaseMainH",L);
							}
						} else {
							if (L-DblCalcDev <= 105) {
								return 20.2*L*N;
							} else if (L-DblCalcDev <= 115) {
								return LinFmod(RoundDbl(CalcStat("MinProwessEvade",105)),2,4,106,115,L,-1)*N;
							} else if (L-DblCalcDev <= 116) {
								return ExpFmod(RoundDbl(CalcStat("MinProwessEvade",115)),116,20,L)*N;
							} else {
								return ExpFmod(RoundDbl(CalcStat("MinProwessEvade",116)),117,5.501,L)*N;
							}
						}
					} else {
						return "Man of the Fourth Age";
					}
				} else {
					return 0.2;
				}
			} else {
				return CalcStat("RacialMain",L);
			}
		} else {
			if (L-DblCalcDev <= 64) {
				return 0;
			} else {
				return (L-55)*N;
			}
		}
	} else if (SN > "MINSTRELCDFATETOCRITHIT") {
		if (SN < "SCALERATMP") {
			if (SN < "PHYDMGPRATPB") {
				if (SN < "PARTBLOCKMITPRATPB") {
					if (SN < "MITLIGHTPRATPB") {
						if (SN < "MINSTRELCDWILLTOTACMIT") {
							if (SN < "MINSTRELCDTACMASTOOUTHEAL") {
								if (SN < "MINSTRELCDFATETOTACMIT") {
									if (SN < "MINSTRELCDFATETOICPR") {
										if (SN == "MINSTRELCDFATETOICMR") {
											return 1.5;
										} else {
											return 0;
										}
									} else if (SN > "MINSTRELCDFATETOICPR") {
										if (SN > "MINSTRELCDFATETONCPR") {
											if (SN == "MINSTRELCDFATETORESIST") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "MINSTRELCDFATETONCPR") {
											return 24;
										} else {
											return 0;
										}
									} else {
										return 1.71;
									}
								} else if (SN > "MINSTRELCDFATETOTACMIT") {
									if (SN < "MINSTRELCDMIGHTTOBLOCK") {
										if (SN == "MINSTRELCDHASPOWER") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "MINSTRELCDMIGHTTOBLOCK") {
										if (SN > "MINSTRELCDMIGHTTOPARRY") {
											if (SN == "MINSTRELCDPHYMITTOOFMIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "MINSTRELCDMIGHTTOPARRY") {
											return 2;
										} else {
											return 0;
										}
									} else {
										return 3;
									}
								} else {
									return 1;
								}
							} else if (SN > "MINSTRELCDTACMASTOOUTHEAL") {
								if (SN < "MINSTRELCDWILLTOEVADE") {
									if (SN < "MINSTRELCDVITALITYTONCMR") {
										if (SN == "MINSTRELCDVITALITYTOMORALE") {
											return 4;
										} else {
											return 0;
										}
									} else if (SN > "MINSTRELCDVITALITYTONCMR") {
										if (SN > "MINSTRELCDVITALITYTORESIST") {
											if (SN == "MINSTRELCDVITALITYTOTACMIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "MINSTRELCDVITALITYTORESIST") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 7.2;
									}
								} else if (SN > "MINSTRELCDWILLTOEVADE") {
									if (SN < "MINSTRELCDWILLTOOUTHEAL") {
										if (SN == "MINSTRELCDWILLTOFINESSE") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "MINSTRELCDWILLTOOUTHEAL") {
										if (SN > "MINSTRELCDWILLTORESIST") {
											if (SN == "MINSTRELCDWILLTOTACMAS") {
												return 3;
											} else {
												return 0;
											}
										} else if (SN == "MINSTRELCDWILLTORESIST") {
											return 2;
										} else {
											return 0;
										}
									} else {
										return 3;
									}
								} else {
									return 1;
								}
							} else {
								return 1;
							}
						} else if (SN > "MINSTRELCDWILLTOTACMIT") {
							if (SN < "MITHEAVYPPRAT") {
								if (SN < "MINTOTFINESSE") {
									if (SN < "MINTACMAS") {
										if (SN == "MINSTROFHHMAS") {
											return 1.2*4*L*N;
										} else {
											return 0;
										}
									} else if (SN > "MINTACMAS") {
										if (SN > "MINTACMASCHOICE") {
											if (SN == "MINTOTARMOUR") {
												if (L-DblCalcDev <= 105) {
													return RoundDbl(12.12*L*N);
												} else {
													return RoundDbl(LinFmod(CalcStat("MinTotArmour",105),2,4,106,115,L,-1)*N);
												}
											} else {
												return 0;
											}
										} else if (SN == "MINTACMASCHOICE") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return DataTableValue([0.4,0.8,1.2,1.6,2],L);
											}
										} else {
											return 0;
										}
									} else {
										return CalcStat("TacMasT",L,CalcStat("MinTacMasChoice",N));
									}
								} else if (SN > "MINTOTFINESSE") {
									if (SN < "MINTOTMAIN") {
										if (SN == "MINTOTINHEALP") {
											return 0.05*N;
										} else {
											return 0;
										}
									} else if (SN > "MINTOTMAIN") {
										if (SN > "MINTOTTACMIT") {
											if (SN == "MITHEAVYPBONUS") {
												return 0;
											} else {
												return 0;
											}
										} else if (SN == "MINTOTTACMIT") {
											if (L-DblCalcDev <= 105) {
												return 7.575*L*N;
											} else {
												return LinFmod(RoundDbl(CalcStat("MinTotTacMit",105)),2,4,106,115,L,-1)*N;
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 105) {
											return RoundDbl(0.9*L*N);
										} else {
											return RoundDbl(ExpFmod(CalcStat("MinTotMain",105),106,5.5,L)*N);
										}
									}
								} else {
									return (11.951937108*L+48.04765)*N;
								}
							} else if (SN > "MITHEAVYPPRAT") {
								if (SN < "MITHEAVYPRATPCAP") {
									if (SN < "MITHEAVYPRATPA") {
										if (SN == "MITHEAVYPRATP") {
											return CalcPercAB(CalcStat("MitHeavyPRatPA",L),CalcStat("MitHeavyPRatPB",L),CalcStat("MitHeavyPRatPCap",L),N);
										} else {
											return 0;
										}
									} else if (SN > "MITHEAVYPRATPA") {
										if (SN > "MITHEAVYPRATPB") {
											if (SN == "MITHEAVYPRATPC") {
												return 1.2;
											} else {
												return 0;
											}
										} else if (SN == "MITHEAVYPRATPB") {
											return CalcStat("BratMitHeavy",L);
										} else {
											return 0;
										}
									} else {
										return 110;
									}
								} else if (SN > "MITHEAVYPRATPCAP") {
									if (SN < "MITLIGHTPPRAT") {
										if (SN > "MITHEAVYPRATPCAPR") {
											if (SN == "MITLIGHTPBONUS") {
												return 0;
											} else {
												return 0;
											}
										} else if (SN == "MITHEAVYPRATPCAPR") {
											return CalcStat("MitHeavyPRatPB",L)*CalcStat("MitHeavyPRatPC",L);
										} else {
											return 0;
										}
									} else if (SN > "MITLIGHTPPRAT") {
										if (SN > "MITLIGHTPRATP") {
											if (SN == "MITLIGHTPRATPA") {
												return 65;
											} else {
												return 0;
											}
										} else if (SN == "MITLIGHTPRATP") {
											return CalcPercAB(CalcStat("MitLightPRatPA",L),CalcStat("MitLightPRatPB",L),CalcStat("MitLightPRatPCap",L),N);
										} else {
											return 0;
										}
									} else {
										return CalcRatAB(CalcStat("MitLightPRatPA",L),CalcStat("MitLightPRatPB",L),CalcStat("MitLightPRatPCapR",L),N);
									}
								} else {
									return 60;
								}
							} else {
								return CalcRatAB(CalcStat("MitHeavyPRatPA",L),CalcStat("MitHeavyPRatPB",L),CalcStat("MitHeavyPRatPCapR",L),N);
							}
						} else {
							return 1;
						}
					} else if (SN > "MITLIGHTPRATPB") {
						if (SN < "OUTHEALPRATP") {
							if (SN < "MITMEDIUMPRATPCAP") {
								if (SN < "MITMEDIUMPPRAT") {
									if (SN < "MITLIGHTPRATPCAP") {
										if (SN == "MITLIGHTPRATPC") {
											return 1.6;
										} else {
											return 0;
										}
									} else if (SN > "MITLIGHTPRATPCAP") {
										if (SN > "MITLIGHTPRATPCAPR") {
											if (SN == "MITMEDIUMPBONUS") {
												return 0;
											} else {
												return 0;
											}
										} else if (SN == "MITLIGHTPRATPCAPR") {
											return CalcStat("MitLightPRatPB",L)*CalcStat("MitLightPRatPC",L);
										} else {
											return 0;
										}
									} else {
										return 40;
									}
								} else if (SN > "MITMEDIUMPPRAT") {
									if (SN < "MITMEDIUMPRATPA") {
										if (SN == "MITMEDIUMPRATP") {
											return CalcPercAB(CalcStat("MitMediumPRatPA",L),CalcStat("MitMediumPRatPB",L),CalcStat("MitMediumPRatPCap",L),N);
										} else {
											return 0;
										}
									} else if (SN > "MITMEDIUMPRATPA") {
										if (SN > "MITMEDIUMPRATPB") {
											if (SN == "MITMEDIUMPRATPC") {
												return 10/7;
											} else {
												return 0;
											}
										} else if (SN == "MITMEDIUMPRATPB") {
											return CalcStat("BratMitMedium",L);
										} else {
											return 0;
										}
									} else {
										return 85;
									}
								} else {
									return CalcRatAB(CalcStat("MitMediumPRatPA",L),CalcStat("MitMediumPRatPB",L),CalcStat("MitMediumPRatPCapR",L),N);
								}
							} else if (SN > "MITMEDIUMPRATPCAP") {
								if (SN < "NCMR") {
									if (SN < "MORALE") {
										if (SN == "MITMEDIUMPRATPCAPR") {
											return CalcStat("MitMediumPRatPB",L)*CalcStat("MitMediumPRatPC",L);
										} else {
											return 0;
										}
									} else if (SN > "MORALE") {
										if (SN > "MORALESM") {
											if (SN == "MORALESTD") {
												return CalcStat("PntMPMorale",L)*CalcStat("ItemMoraleProg",L,CalcStat("ProgBMorale",L))*CalcStat("AdjItemProgMorale",L,CalcStat("ProgBMorale",L))*N;
											} else {
												return 0;
											}
										} else if (SN == "MORALESM") {
											return CalcStat("PntMPMorale",L)*CalcStat("ItemMoraleSmProg",L,CalcStat("ProgBMorale",L))*CalcStat("AdjItemProgMorale",L,CalcStat("ProgBMorale",L))*N;
										} else {
											return 0;
										}
									} else {
										return CalcStat("PntMPMorale",L)*CalcStat("ItemMoraleAdjProg",L,CalcStat("ProgBMorale",L))*CalcStat("AdjItemProgMorale",L,CalcStat("ProgBMorale",L))*N;
									}
								} else if (SN > "NCMR") {
									if (SN < "OUTHEAL") {
										if (SN == "NCPR") {
											return CalcStat("PntMPNCPR",L)*CalcStat("ItemProg",L,CalcStat("ProgBPowReg",L))*CalcStat("AdjItemProgPowReg",L,CalcStat("ProgBPowReg",L))*N;
										} else {
											return 0;
										}
									} else if (SN > "OUTHEAL") {
										if (SN > "OUTHEALPBONUS") {
											if (SN == "OUTHEALPPRAT") {
												return CalcRatAB(CalcStat("OutHealPRatPA",L),CalcStat("OutHealPRatPB",L),CalcStat("OutHealPRatPCapR",L),N);
											} else {
												return 0;
											}
										} else if (SN == "OUTHEALPBONUS") {
											return 0;
										} else {
											return 0;
										}
									} else {
										return CalcStat("RatOutHeal",L,N);
									}
								} else {
									return CalcStat("PntMPNCMR",L)*CalcStat("ItemProg",L,CalcStat("ProgBMorReg",L))*CalcStat("AdjItemProgMorReg",L,CalcStat("ProgBMorReg",L))*N;
								}
							} else {
								return 50;
							}
						} else if (SN > "OUTHEALPRATP") {
							if (SN < "PARRYPRATP") {
								if (SN < "OUTHEALPRATPCAPR") {
									if (SN < "OUTHEALPRATPB") {
										if (SN == "OUTHEALPRATPA") {
											return 140;
										} else {
											return 0;
										}
									} else if (SN > "OUTHEALPRATPB") {
										if (SN > "OUTHEALPRATPC") {
											if (SN == "OUTHEALPRATPCAP") {
												return 70;
											} else {
												return 0;
											}
										} else if (SN == "OUTHEALPRATPC") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return CalcStat("BratMedium",L);
									}
								} else if (SN > "OUTHEALPRATPCAPR") {
									if (SN < "PARRY") {
										if (SN == "OUTHEALT") {
											return CalcStat("RatOutHealT",L,N);
										} else {
											return 0;
										}
									} else if (SN > "PARRY") {
										if (SN > "PARRYPBONUS") {
											if (SN == "PARRYPPRAT") {
												return CalcStat("BPEPPRat",L,N);
											} else {
												return 0;
											}
										} else if (SN == "PARRYPBONUS") {
											return CalcStat("BPEPBonus",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("RatDefence",L,N);
									}
								} else {
									return CalcStat("OutHealPRatPB",L)*CalcStat("OutHealPRatPC",L);
								}
							} else if (SN > "PARRYPRATP") {
								if (SN < "PARRYPRATPCAPR") {
									if (SN < "PARRYPRATPB") {
										if (SN == "PARRYPRATPA") {
											return CalcStat("BPEPRatPA",L);
										} else {
											return 0;
										}
									} else if (SN > "PARRYPRATPB") {
										if (SN > "PARRYPRATPC") {
											if (SN == "PARRYPRATPCAP") {
												return CalcStat("BPEPRatPCap",L);
											} else {
												return 0;
											}
										} else if (SN == "PARRYPRATPC") {
											return CalcStat("BPEPRatPC",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("BPEPRatPB",L);
									}
								} else if (SN > "PARRYPRATPCAPR") {
									if (SN < "PARTBLOCKMITPPRAT") {
										if (SN > "PARRYT") {
											if (SN == "PARTBLOCKMITPBONUS") {
												return CalcStat("PartMitPBonus",L);
											} else {
												return 0;
											}
										} else if (SN == "PARRYT") {
											return CalcStat("RatDefenceT",L,N);
										} else {
											return 0;
										}
									} else if (SN > "PARTBLOCKMITPPRAT") {
										if (SN > "PARTBLOCKMITPRATP") {
											if (SN == "PARTBLOCKMITPRATPA") {
												return CalcStat("PartMitPRatPA",L);
											} else {
												return 0;
											}
										} else if (SN == "PARTBLOCKMITPRATP") {
											return CalcStat("PartMitPRatP",L,N);
										} else {
											return 0;
										}
									} else {
										return CalcStat("PartMitPPRat",L,N);
									}
								} else {
									return CalcStat("BPEPRatPCapR",L);
								}
							} else {
								return CalcStat("BPEPRatP",L,N);
							}
						} else {
							return CalcPercAB(CalcStat("OutHealPRatPA",L),CalcStat("OutHealPRatPB",L),CalcStat("OutHealPRatPCap",L),N);
						}
					} else {
						return CalcStat("BratMitLight",L);
					}
				} else if (SN > "PARTBLOCKMITPRATPB") {
					if (SN < "PARTMITPRATPC") {
						if (SN < "PARTEVADEMITPBONUS") {
							if (SN < "PARTBLOCKPRATPCAP") {
								if (SN < "PARTBLOCKPPRAT") {
									if (SN < "PARTBLOCKMITPRATPCAP") {
										if (SN == "PARTBLOCKMITPRATPC") {
											return CalcStat("PartMitPRatPC",L);
										} else {
											return 0;
										}
									} else if (SN > "PARTBLOCKMITPRATPCAP") {
										if (SN > "PARTBLOCKMITPRATPCAPR") {
											if (SN == "PARTBLOCKPBONUS") {
												return CalcStat("PartBPEPBonus",L);
											} else {
												return 0;
											}
										} else if (SN == "PARTBLOCKMITPRATPCAPR") {
											return CalcStat("PartMitPRatPCapR",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("PartMitPRatPCap",L);
									}
								} else if (SN > "PARTBLOCKPPRAT") {
									if (SN < "PARTBLOCKPRATPA") {
										if (SN == "PARTBLOCKPRATP") {
											return CalcStat("PartBPEPRatP",L,N);
										} else {
											return 0;
										}
									} else if (SN > "PARTBLOCKPRATPA") {
										if (SN > "PARTBLOCKPRATPB") {
											if (SN == "PARTBLOCKPRATPC") {
												return CalcStat("PartBPEPRatPC",L);
											} else {
												return 0;
											}
										} else if (SN == "PARTBLOCKPRATPB") {
											return CalcStat("PartBPEPRatPB",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("PartBPEPRatPA",L);
									}
								} else {
									return CalcStat("PartBPEPPRat",L,N);
								}
							} else if (SN > "PARTBLOCKPRATPCAP") {
								if (SN < "PARTBPEPRATPA") {
									if (SN < "PARTBPEPBONUS") {
										if (SN == "PARTBLOCKPRATPCAPR") {
											return CalcStat("PartBPEPRatPCapR",L);
										} else {
											return 0;
										}
									} else if (SN > "PARTBPEPBONUS") {
										if (SN > "PARTBPEPPRAT") {
											if (SN == "PARTBPEPRATP") {
												return CalcPercAB(CalcStat("PartBPEPRatPA",L),CalcStat("PartBPEPRatPB",L),CalcStat("PartBPEPRatPCap",L),N);
											} else {
												return 0;
											}
										} else if (SN == "PARTBPEPPRAT") {
											return CalcRatAB(CalcStat("PartBPEPRatPA",L),CalcStat("PartBPEPRatPB",L),CalcStat("PartBPEPRatPCapR",L),N);
										} else {
											return 0;
										}
									} else {
										return 0;
									}
								} else if (SN > "PARTBPEPRATPA") {
									if (SN < "PARTBPEPRATPC") {
										if (SN == "PARTBPEPRATPB") {
											return CalcStat("BratMedium",L);
										} else {
											return 0;
										}
									} else if (SN > "PARTBPEPRATPC") {
										if (SN > "PARTBPEPRATPCAP") {
											if (SN == "PARTBPEPRATPCAPR") {
												return CalcStat("PartBPEPRatPB",L)*CalcStat("PartBPEPRatPC",L);
											} else {
												return 0;
											}
										} else if (SN == "PARTBPEPRATPCAP") {
											return 35;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									return 70;
								}
							} else {
								return CalcStat("PartBPEPRatPCap",L);
							}
						} else if (SN > "PARTEVADEMITPBONUS") {
							if (SN < "PARTEVADEPRATP") {
								if (SN < "PARTEVADEMITPRATPC") {
									if (SN < "PARTEVADEMITPRATP") {
										if (SN == "PARTEVADEMITPPRAT") {
											return CalcStat("PartMitPPRat",L,N);
										} else {
											return 0;
										}
									} else if (SN > "PARTEVADEMITPRATP") {
										if (SN > "PARTEVADEMITPRATPA") {
											if (SN == "PARTEVADEMITPRATPB") {
												return CalcStat("PartMitPRatPB",L);
											} else {
												return 0;
											}
										} else if (SN == "PARTEVADEMITPRATPA") {
											return CalcStat("PartMitPRatPA",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("PartMitPRatP",L,N);
									}
								} else if (SN > "PARTEVADEMITPRATPC") {
									if (SN < "PARTEVADEMITPRATPCAPR") {
										if (SN == "PARTEVADEMITPRATPCAP") {
											return CalcStat("PartMitPRatPCap",L);
										} else {
											return 0;
										}
									} else if (SN > "PARTEVADEMITPRATPCAPR") {
										if (SN > "PARTEVADEPBONUS") {
											if (SN == "PARTEVADEPPRAT") {
												return CalcStat("PartBPEPPRat",L,N);
											} else {
												return 0;
											}
										} else if (SN == "PARTEVADEPBONUS") {
											return CalcStat("PartBPEPBonus",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("PartMitPRatPCapR",L);
									}
								} else {
									return CalcStat("PartMitPRatPC",L);
								}
							} else if (SN > "PARTEVADEPRATP") {
								if (SN < "PARTEVADEPRATPCAPR") {
									if (SN < "PARTEVADEPRATPB") {
										if (SN == "PARTEVADEPRATPA") {
											return CalcStat("PartBPEPRatPA",L);
										} else {
											return 0;
										}
									} else if (SN > "PARTEVADEPRATPB") {
										if (SN > "PARTEVADEPRATPC") {
											if (SN == "PARTEVADEPRATPCAP") {
												return CalcStat("PartBPEPRatPCap",L);
											} else {
												return 0;
											}
										} else if (SN == "PARTEVADEPRATPC") {
											return CalcStat("PartBPEPRatPC",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("PartBPEPRatPB",L);
									}
								} else if (SN > "PARTEVADEPRATPCAPR") {
									if (SN < "PARTMITPRATP") {
										if (SN > "PARTMITPBONUS") {
											if (SN == "PARTMITPPRAT") {
												return CalcRatAB(CalcStat("PartMitPRatPA",L),CalcStat("PartMitPRatPB",L),CalcStat("PartMitPRatPCapR",L),N);
											} else {
												return 0;
											}
										} else if (SN == "PARTMITPBONUS") {
											return 10;
										} else {
											return 0;
										}
									} else if (SN > "PARTMITPRATP") {
										if (SN > "PARTMITPRATPA") {
											if (SN == "PARTMITPRATPB") {
												return CalcStat("BratMedium",L);
											} else {
												return 0;
											}
										} else if (SN == "PARTMITPRATPA") {
											return 100;
										} else {
											return 0;
										}
									} else {
										return CalcPercAB(CalcStat("PartMitPRatPA",L),CalcStat("PartMitPRatPB",L),CalcStat("PartMitPRatPCap",L),N);
									}
								} else {
									return CalcStat("PartBPEPRatPCapR",L);
								}
							} else {
								return CalcStat("PartBPEPRatP",L,N);
							}
						} else {
							if (L-DblCalcDev <= 1) {
								return 35;
							} else {
								return CalcStat("PartMitPBonus",L);
							}
						}
					} else if (SN > "PARTMITPRATPC") {
						if (SN < "PERKMORALE2") {
							if (SN < "PARTPARRYMITPRATPCAPR") {
								if (SN < "PARTPARRYMITPRATP") {
									if (SN < "PARTMITPRATPCAPR") {
										if (SN == "PARTMITPRATPCAP") {
											return 50;
										} else {
											return 0;
										}
									} else if (SN > "PARTMITPRATPCAPR") {
										if (SN > "PARTPARRYMITPBONUS") {
											if (SN == "PARTPARRYMITPPRAT") {
												return CalcStat("PartMitPPRat",L,N);
											} else {
												return 0;
											}
										} else if (SN == "PARTPARRYMITPBONUS") {
											return CalcStat("PartMitPBonus",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("PartMitPRatPB",L)*CalcStat("PartMitPRatPC",L);
									}
								} else if (SN > "PARTPARRYMITPRATP") {
									if (SN < "PARTPARRYMITPRATPB") {
										if (SN == "PARTPARRYMITPRATPA") {
											return CalcStat("PartMitPRatPA",L);
										} else {
											return 0;
										}
									} else if (SN > "PARTPARRYMITPRATPB") {
										if (SN > "PARTPARRYMITPRATPC") {
											if (SN == "PARTPARRYMITPRATPCAP") {
												return CalcStat("PartMitPRatPCap",L);
											} else {
												return 0;
											}
										} else if (SN == "PARTPARRYMITPRATPC") {
											return CalcStat("PartMitPRatPC",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("PartMitPRatPB",L);
									}
								} else {
									return CalcStat("PartMitPRatP",L,N);
								}
							} else if (SN > "PARTPARRYMITPRATPCAPR") {
								if (SN < "PARTPARRYPRATPB") {
									if (SN < "PARTPARRYPPRAT") {
										if (SN == "PARTPARRYPBONUS") {
											return CalcStat("PartBPEPBonus",L);
										} else {
											return 0;
										}
									} else if (SN > "PARTPARRYPPRAT") {
										if (SN > "PARTPARRYPRATP") {
											if (SN == "PARTPARRYPRATPA") {
												return CalcStat("PartBPEPRatPA",L);
											} else {
												return 0;
											}
										} else if (SN == "PARTPARRYPRATP") {
											return CalcStat("PartBPEPRatP",L,N);
										} else {
											return 0;
										}
									} else {
										return CalcStat("PartBPEPPRat",L,N);
									}
								} else if (SN > "PARTPARRYPRATPB") {
									if (SN < "PARTPARRYPRATPCAP") {
										if (SN == "PARTPARRYPRATPC") {
											return CalcStat("PartBPEPRatPC",L);
										} else {
											return 0;
										}
									} else if (SN > "PARTPARRYPRATPCAP") {
										if (SN > "PARTPARRYPRATPCAPR") {
											if (SN == "PERKMORALE1") {
												return 149*N;
											} else {
												return 0;
											}
										} else if (SN == "PARTPARRYPRATPCAPR") {
											return CalcStat("PartBPEPRatPCapR",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("PartBPEPRatPCap",L);
									}
								} else {
									return CalcStat("PartBPEPRatPB",L);
								}
							} else {
								return CalcStat("PartMitPRatPCapR",L);
							}
						} else if (SN > "PERKMORALE2") {
							if (SN < "PERKPOWER2") {
								if (SN < "PERKPHYMIT1") {
									if (SN < "PERKMORALE4") {
										if (SN == "PERKMORALE3") {
											return 246*N;
										} else {
											return 0;
										}
									} else if (SN > "PERKMORALE4") {
										if (SN > "PERKNCMR") {
											if (SN == "PERKNCPR") {
												if (L-DblCalcDev <= 2) {
													return (50*L+125)*N;
												} else if (L-DblCalcDev <= 7) {
													return (50*L+110)*N;
												} else if (L-DblCalcDev <= 25) {
													return (50*L+95)*N;
												} else if (L-DblCalcDev <= 50) {
													return (50*L+80)*N;
												} else if (L-DblCalcDev <= 59) {
													return 2580*N;
												} else if (L-DblCalcDev <= 64) {
													return 2640*N;
												} else if (L-DblCalcDev <= 70) {
													return 2700*N;
												} else {
													return 2760*N;
												}
											} else {
												return 0;
											}
										} else if (SN == "PERKNCMR") {
											return (42*L+66)*N;
										} else {
											return 0;
										}
									} else {
										return 262*N;
									}
								} else if (SN > "PERKPHYMIT1") {
									if (SN < "PERKPHYMIT3") {
										if (SN == "PERKPHYMIT2") {
											return 3.03*L*N;
										} else {
											return 0;
										}
									} else if (SN > "PERKPHYMIT3") {
										if (SN > "PERKPHYMIT4") {
											if (SN == "PERKPOWER1") {
												return 95*N;
											} else {
												return 0;
											}
										} else if (SN == "PERKPHYMIT4") {
											return 6.06*L*N;
										} else {
											return 0;
										}
									} else {
										return 4.545*L*N;
									}
								} else {
									return 2.2725*L*N;
								}
							} else if (SN > "PERKPOWER2") {
								if (SN < "PERKTACMIT3") {
									if (SN < "PERKPOWER4") {
										if (SN == "PERKPOWER3") {
											return 146*N;
										} else {
											return 0;
										}
									} else if (SN > "PERKPOWER4") {
										if (SN > "PERKTACMIT1") {
											if (SN == "PERKTACMIT2") {
												return 3.03*L*N;
											} else {
												return 0;
											}
										} else if (SN == "PERKTACMIT1") {
											return 2.2725*L*N;
										} else {
											return 0;
										}
									} else {
										return 153*N;
									}
								} else if (SN > "PERKTACMIT3") {
									if (SN < "PHYDMGPPRAT") {
										if (SN > "PERKTACMIT4") {
											if (SN == "PHYDMGPBONUS") {
												return 0;
											} else {
												return 0;
											}
										} else if (SN == "PERKTACMIT4") {
											return 6.06*L*N;
										} else {
											return 0;
										}
									} else if (SN > "PHYDMGPPRAT") {
										if (SN > "PHYDMGPRATP") {
											if (SN == "PHYDMGPRATPA") {
												return 400;
											} else {
												return 0;
											}
										} else if (SN == "PHYDMGPRATP") {
											return CalcPercAB(CalcStat("PhyDmgPRatPA",L),CalcStat("PhyDmgPRatPB",L),CalcStat("PhyDmgPRatPCap",L),N);
										} else {
											return 0;
										}
									} else {
										return CalcRatAB(CalcStat("PhyDmgPRatPA",L),CalcStat("PhyDmgPRatPB",L),CalcStat("PhyDmgPRatPCapR",L),N);
									}
								} else {
									return 4.545*L*N;
								}
							} else {
								return 131*N;
							}
						} else {
							return 215*N;
						}
					} else {
						return 1;
					}
				} else {
					return CalcStat("PartMitPRatPB",L);
				}
			} else if (SN > "PHYDMGPRATPB") {
				if (SN < "RELMORALE") {
					if (SN < "PNTMPOFFENCE") {
						if (SN < "PHYMITLPRATPC") {
							if (SN < "PHYMITHPRATPA") {
								if (SN < "PHYMAST") {
									if (SN < "PHYDMGPRATPCAP") {
										if (SN == "PHYDMGPRATPC") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "PHYDMGPRATPCAP") {
										if (SN > "PHYDMGPRATPCAPR") {
											if (SN == "PHYMAS") {
												return CalcStat("RatMastery",L,N);
											} else {
												return 0;
											}
										} else if (SN == "PHYDMGPRATPCAPR") {
											return CalcStat("PhyDmgPRatPB",L)*CalcStat("PhyDmgPRatPC",L);
										} else {
											return 0;
										}
									} else {
										return 200;
									}
								} else if (SN > "PHYMAST") {
									if (SN < "PHYMITHPBONUS") {
										if (SN == "PHYMIT") {
											return CalcStat("RatMitigation",L,N);
										} else {
											return 0;
										}
									} else if (SN > "PHYMITHPBONUS") {
										if (SN > "PHYMITHPPRAT") {
											if (SN == "PHYMITHPRATP") {
												return CalcStat("MitHeavyPRatP",L,N);
											} else {
												return 0;
											}
										} else if (SN == "PHYMITHPPRAT") {
											return CalcStat("MitHeavyPPRat",L,N);
										} else {
											return 0;
										}
									} else {
										return CalcStat("MitHeavyPBonus",L);
									}
								} else {
									return CalcStat("RatMasteryT",L,N);
								}
							} else if (SN > "PHYMITHPRATPA") {
								if (SN < "PHYMITLPBONUS") {
									if (SN < "PHYMITHPRATPC") {
										if (SN == "PHYMITHPRATPB") {
											return CalcStat("MitHeavyPRatPB",L);
										} else {
											return 0;
										}
									} else if (SN > "PHYMITHPRATPC") {
										if (SN > "PHYMITHPRATPCAP") {
											if (SN == "PHYMITHPRATPCAPR") {
												return CalcStat("MitHeavyPRatPCapR",L);
											} else {
												return 0;
											}
										} else if (SN == "PHYMITHPRATPCAP") {
											return CalcStat("MitHeavyPRatPCap",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("MitHeavyPRatPC",L);
									}
								} else if (SN > "PHYMITLPBONUS") {
									if (SN < "PHYMITLPRATP") {
										if (SN == "PHYMITLPPRAT") {
											return CalcStat("MitLightPPRat",L,N);
										} else {
											return 0;
										}
									} else if (SN > "PHYMITLPRATP") {
										if (SN > "PHYMITLPRATPA") {
											if (SN == "PHYMITLPRATPB") {
												return CalcStat("MitLightPRatPB",L);
											} else {
												return 0;
											}
										} else if (SN == "PHYMITLPRATPA") {
											return CalcStat("MitLightPRatPA",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("MitLightPRatP",L,N);
									}
								} else {
									return CalcStat("MitLightPBonus",L);
								}
							} else {
								return CalcStat("MitHeavyPRatPA",L);
							}
						} else if (SN > "PHYMITLPRATPC") {
							if (SN < "PHYMITMPRATPCAPR") {
								if (SN < "PHYMITMPRATP") {
									if (SN < "PHYMITLPRATPCAPR") {
										if (SN == "PHYMITLPRATPCAP") {
											return CalcStat("MitLightPRatPCap",L);
										} else {
											return 0;
										}
									} else if (SN > "PHYMITLPRATPCAPR") {
										if (SN > "PHYMITMPBONUS") {
											if (SN == "PHYMITMPPRAT") {
												return CalcStat("MitMediumPPRat",L,N);
											} else {
												return 0;
											}
										} else if (SN == "PHYMITMPBONUS") {
											return CalcStat("MitMediumPBonus",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("MitLightPRatPCapR",L);
									}
								} else if (SN > "PHYMITMPRATP") {
									if (SN < "PHYMITMPRATPB") {
										if (SN == "PHYMITMPRATPA") {
											return CalcStat("MitMediumPRatPA",L);
										} else {
											return 0;
										}
									} else if (SN > "PHYMITMPRATPB") {
										if (SN > "PHYMITMPRATPC") {
											if (SN == "PHYMITMPRATPCAP") {
												return CalcStat("MitMediumPRatPCap",L);
											} else {
												return 0;
											}
										} else if (SN == "PHYMITMPRATPC") {
											return CalcStat("MitMediumPRatPC",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("MitMediumPRatPB",L);
									}
								} else {
									return CalcStat("MitMediumPRatP",L,N);
								}
							} else if (SN > "PHYMITMPRATPCAPR") {
								if (SN < "PNTMPMAIN") {
									if (SN < "PNTMPDEFENCE") {
										if (SN == "PHYMITT") {
											return CalcStat("RatMitigationT",L,N);
										} else {
											return 0;
										}
									} else if (SN > "PNTMPDEFENCE") {
										if (SN > "PNTMPICMR") {
											if (SN == "PNTMPICPR") {
												return 9750/13000;
											} else {
												return 0;
											}
										} else if (SN == "PNTMPICMR") {
											return 7800/13000;
										} else {
											return 0;
										}
									} else {
										return 351/13000;
									}
								} else if (SN > "PNTMPMAIN") {
									if (SN < "PNTMPMORALE") {
										if (SN > "PNTMPMASTERY") {
											if (SN == "PNTMPMITIGATION") {
												return 27/380;
											} else {
												return 0;
											}
										} else if (SN == "PNTMPMASTERY") {
											return 468/13000;
										} else {
											return 0;
										}
									} else if (SN > "PNTMPMORALE") {
										if (SN > "PNTMPNCMR") {
											if (SN == "PNTMPNCPR") {
												return 39000/13000;
											} else {
												return 0;
											}
										} else if (SN == "PNTMPNCMR") {
											return 78000/13000;
										} else {
											return 0;
										}
									} else {
										return 400/13000;
									}
								} else {
									return 351/13000;
								}
							} else {
								return CalcStat("MitMediumPRatPCapR",L);
							}
						} else {
							return CalcStat("MitLightPRatPC",L);
						}
					} else if (SN > "PNTMPOFFENCE") {
						if (SN < "RACIALVITALITY") {
							if (SN < "PROGBMITHEAVY") {
								if (SN < "PROGBHIGH") {
									if (SN < "PNTMPPOWER") {
										if (SN == "PNTMPOUTHEAL") {
											return 780/13000;
										} else {
											return 0;
										}
									} else if (SN > "PNTMPPOWER") {
										if (SN > "PNTMPVITALITY") {
											if (SN == "POWER") {
												return CalcStat("PntMPPower",L)*CalcStat("ItemProg",L,CalcStat("ProgBPower",L))*CalcStat("AdjItemProgPower",L,CalcStat("ProgBPower",L))*N;
											} else {
												return 0;
											}
										} else if (SN == "PNTMPVITALITY") {
											return 1625/13000;
										} else {
											return 0;
										}
									} else {
										return 650/13000;
									}
								} else if (SN > "PROGBHIGH") {
									if (SN < "PROGBMAIN") {
										if (SN == "PROGBLOW") {
											return 200;
										} else {
											return 0;
										}
									} else if (SN > "PROGBMAIN") {
										if (SN > "PROGBMASTERY") {
											if (SN == "PROGBMEDIUM") {
												return 400;
											} else {
												return 0;
											}
										} else if (SN == "PROGBMASTERY") {
											return 270;
										} else {
											return 0;
										}
									} else {
										return 40;
									}
								} else {
									return 500;
								}
							} else if (SN > "PROGBMITHEAVY") {
								if (SN < "PROGBMORREG") {
									if (SN < "PROGBMITLIGHT") {
										if (SN == "PROGBMITIGATION") {
											return CalcStat("ProgBMitMedium",L);
										} else {
											return 0;
										}
									} else if (SN > "PROGBMITLIGHT") {
										if (SN > "PROGBMITMEDIUM") {
											if (SN == "PROGBMORALE") {
												return 130;
											} else {
												return 0;
											}
										} else if (SN == "PROGBMITMEDIUM") {
											return 382/3;
										} else {
											return 0;
										}
									} else {
										return 280/3;
									}
								} else if (SN > "PROGBMORREG") {
									if (SN < "PROGBPOWREG") {
										if (SN == "PROGBPOWER") {
											return 20;
										} else {
											return 0;
										}
									} else if (SN > "PROGBPOWREG") {
										if (SN > "PROGBVITALITY") {
											if (SN == "RACIALMAIN") {
												return CalcStat("ScaleMain",L);
											} else {
												return 0;
											}
										} else if (SN == "PROGBVITALITY") {
											return 10;
										} else {
											return 0;
										}
									} else {
										return 20;
									}
								} else {
									return 10;
								}
							} else {
								return 174;
							}
						} else if (SN > "RACIALVITALITY") {
							if (SN < "RATOUTHEALT") {
								if (SN < "RATMITIGATION") {
									if (SN < "RATDEFENCET") {
										if (SN == "RATDEFENCE") {
											return CalcStat("PntMPDefence",L)*CalcStat("ItemProg",L,CalcStat("ProgBMedium",L))*CalcStat("AdjItemProgRatings",L,CalcStat("ProgBMedium",L))*N;
										} else {
											return 0;
										}
									} else if (SN > "RATDEFENCET") {
										if (SN > "RATMASTERY") {
											if (SN == "RATMASTERYT") {
												return CalcStat("PntMPMastery",L)*CalcStat("TraitProg",L,CalcStat("ProgBMastery",L))*CalcStat("AdjTraitProgRatings",L,CalcStat("ProgBMastery",L))*N;
											} else {
												return 0;
											}
										} else if (SN == "RATMASTERY") {
											return CalcStat("PntMPMastery",L)*CalcStat("ItemProg",L,CalcStat("ProgBMastery",L))*CalcStat("AdjItemProgRatings",L,CalcStat("ProgBMastery",L))*N;
										} else {
											return 0;
										}
									} else {
										return CalcStat("PntMPDefence",L)*CalcStat("TraitProg",L,CalcStat("ProgBMedium",L))*CalcStat("AdjTraitProgRatings",L,CalcStat("ProgBMedium",L))*N;
									}
								} else if (SN > "RATMITIGATION") {
									if (SN < "RATOFFENCE") {
										if (SN == "RATMITIGATIONT") {
											return CalcStat("PntMPMitigation",L)*CalcStat("TraitProg",L,CalcStat("ProgBMitigation",L))*CalcStat("AdjTraitProgRatings",L,CalcStat("ProgBMitigation",L))*N;
										} else {
											return 0;
										}
									} else if (SN > "RATOFFENCE") {
										if (SN > "RATOFFENCET") {
											if (SN == "RATOUTHEAL") {
												return CalcStat("PntMPOutHeal",L)*CalcStat("ItemProg",L,CalcStat("ProgBMedium",L))*CalcStat("AdjItemProgRatings",L,CalcStat("ProgBMedium",L))*N;
											} else {
												return 0;
											}
										} else if (SN == "RATOFFENCET") {
											return CalcStat("PntMPOffence",L)*CalcStat("TraitProg",L,CalcStat("ProgBLow",L))*CalcStat("AdjTraitProgRatings",L,CalcStat("ProgBLow",L))*N;
										} else {
											return 0;
										}
									} else {
										return CalcStat("PntMPOffence",L)*CalcStat("ItemProg",L,CalcStat("ProgBLow",L))*CalcStat("AdjItemProgRatings",L,CalcStat("ProgBLow",L))*N;
									}
								} else {
									return CalcStat("PntMPMitigation",L)*CalcStat("ItemProg",L,CalcStat("ProgBMitigation",L))*CalcStat("AdjItemProgRatings",L,CalcStat("ProgBMitigation",L))*N;
								}
							} else if (SN > "RATOUTHEALT") {
								if (SN < "RELEVADE") {
									if (SN < "RELBLOCK") {
										if (SN == "RELAGILITY") {
											return RoundDbl((0.5*L-10.25)*N);
										} else {
											return 0;
										}
									} else if (SN > "RELBLOCK") {
										if (SN > "RELCRITDEF") {
											if (SN == "RELCRITHIT") {
												return 8.08*L*N;
											} else {
												return 0;
											}
										} else if (SN == "RELCRITDEF") {
											return 8.08*L*N;
										} else {
											return 0;
										}
									} else {
										return 8.08*L*N;
									}
								} else if (SN > "RELEVADE") {
									if (SN < "RELICPR") {
										if (SN > "RELFATE") {
											if (SN == "RELICMR") {
												return (2.6*L-52)*N;
											} else {
												return 0;
											}
										} else if (SN == "RELFATE") {
											return RoundDbl((0.5*L-10.25)*N);
										} else {
											return 0;
										}
									} else if (SN > "RELICPR") {
										if (SN > "RELINHEAL") {
											if (SN == "RELMIGHT") {
												return RoundDbl((0.5*L-10.25)*N);
											} else {
												return 0;
											}
										} else if (SN == "RELINHEAL") {
											return 8.08*L*N;
										} else {
											return 0;
										}
									} else {
										return (2.4*L-45)*N;
									}
								} else {
									return 8.08*L*N;
								}
							} else {
								return CalcStat("PntMPOutHeal",L)*CalcStat("TraitProg",L,CalcStat("ProgBMedium",L))*CalcStat("AdjTraitProgRatings",L,CalcStat("ProgBMedium",L))*N;
							}
						} else {
							return CalcStat("ScaleVitality",L);
						}
					} else {
						return 663/13000;
					}
				} else if (SN > "RELMORALE") {
					if (SN < "RUNEKEEPERCDAGILITYTOPARRY") {
						if (SN < "REPMIGHTH") {
							if (SN < "REPAGILITYL") {
								if (SN < "RELTACMAS") {
									if (SN < "RELPHYMAS") {
										if (SN == "RELPARRY") {
											return 8.08*L*N;
										} else {
											return 0;
										}
									} else if (SN > "RELPHYMAS") {
										if (SN > "RELPHYMIT") {
											if (SN == "RELPOWER") {
												return (6.6667*L-223.6667)*N;
											} else {
												return 0;
											}
										} else if (SN == "RELPHYMIT") {
											return (2.29*L-1.35)*N;
										} else {
											return 0;
										}
									} else {
										return 8.08*L*N;
									}
								} else if (SN > "RELTACMAS") {
									if (SN < "RELVITALITY") {
										if (SN == "RELTACMIT") {
											return (2.29*L-1.35)*N;
										} else {
											return 0;
										}
									} else if (SN > "RELVITALITY") {
										if (SN > "RELWILL") {
											if (SN == "REPAGILITYH") {
												return CalcStat("RepMainH",L);
											} else {
												return 0;
											}
										} else if (SN == "RELWILL") {
											return RoundDbl((0.5*L-10.25)*N);
										} else {
											return 0;
										}
									} else {
										return RoundDbl((0.5*L-10.25)*N);
									}
								} else {
									return 8.08*L*N;
								}
							} else if (SN > "REPAGILITYL") {
								if (SN < "REPFINESSE") {
									if (SN < "REPCRITHIT") {
										if (SN == "REPCRITDEF") {
											if (L-DblCalcDev <= 50) {
												return LinFmod(1,900,1488,1,50,L);
											} else if (L-DblCalcDev <= 85) {
												return LinFmod(1,1488,1908,50,85,L);
											} else if (L-DblCalcDev <= 105) {
												return LinFmod(1,1908,2148,85,105,L);
											} else {
												return LinFmod(1,2148,2328,105,120,L);
											}
										} else {
											return 0;
										}
									} else if (SN > "REPCRITHIT") {
										if (SN > "REPFATEH") {
											if (SN == "REPFATEL") {
												return CalcStat("RepMainL",L);
											} else {
												return 0;
											}
										} else if (SN == "REPFATEH") {
											return CalcStat("RepMainH",L);
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 50) {
											return LinFmod(1,300,496,1,50,L);
										} else if (L-DblCalcDev <= 85) {
											return LinFmod(1,496,636,50,85,L);
										} else if (L-DblCalcDev <= 105) {
											return LinFmod(1,636,716,85,105,L);
										} else {
											return LinFmod(1,716,776,105,120,L);
										}
									}
								} else if (SN > "REPFINESSE") {
									if (SN < "REPMAINL") {
										if (SN == "REPMAINH") {
											return FloorDbl(CalcStat("RepMainRawH",L));
										} else {
											return 0;
										}
									} else if (SN > "REPMAINL") {
										if (SN > "REPMAINRAWH") {
											if (SN == "REPMAINRAWL") {
												if (L-DblCalcDev <= 50) {
													return LinFmod(1,53,102,1,50,L);
												} else if (L-DblCalcDev <= 85) {
													return LinFmod(1,102,137,50,85,L);
												} else if (L-DblCalcDev <= 105) {
													return LinFmod(1,137,157,85,105,L);
												} else {
													return LinFmod(1,157,172,105,120,L);
												}
											} else {
												return 0;
											}
										} else if (SN == "REPMAINRAWH") {
											if (L-DblCalcDev <= 50) {
												return LinFmod(1,80,153,1,50,L);
											} else if (L-DblCalcDev <= 85) {
												return LinFmod(1,153,206,50,85,L);
											} else if (L-DblCalcDev <= 105) {
												return LinFmod(1,206,236,85,105,L);
											} else {
												return LinFmod(1,236,258,105,120,L);
											}
										} else {
											return 0;
										}
									} else {
										return FloorDbl(CalcStat("RepMainRawL",L));
									}
								} else {
									if (L-DblCalcDev <= 50) {
										return LinFmod(1,322,557,1,50,L);
									} else if (L-DblCalcDev <= 85) {
										return LinFmod(1,557,749.9477,50,85,L);
									} else if (L-DblCalcDev <= 105) {
										return LinFmod(1,749.9477,859.1634,85,105,L);
									} else {
										return LinFmod(1,859.1634,939.2549,105,120,L);
									}
								}
							} else {
								return CalcStat("RepMainL",L);
							}
						} else if (SN > "REPMIGHTH") {
							if (SN < "RESISTPBONUS") {
								if (SN < "REPVITALITYH") {
									if (SN < "REPMORALE") {
										if (SN == "REPMIGHTL") {
											return CalcStat("RepMainL",L);
										} else {
											return 0;
										}
									} else if (SN > "REPMORALE") {
										if (SN > "REPPOWER") {
											if (SN == "REPTACMIT") {
												if (L-DblCalcDev <= 50) {
													return LinFmod(1,675,1116,1,50,L);
												} else if (L-DblCalcDev <= 85) {
													return LinFmod(1,1116,1431,50,85,L);
												} else if (L-DblCalcDev <= 105) {
													return LinFmod(1,1431,1611,85,105,L);
												} else {
													return LinFmod(1,1611,1746,105,120,L);
												}
											} else {
												return 0;
											}
										} else if (SN == "REPPOWER") {
											if (L-DblCalcDev <= 50) {
												return LinFmod(1,94,212,1,50,L);
											} else if (L-DblCalcDev <= 85) {
												return LinFmod(1,212,296,50,85,L);
											} else if (L-DblCalcDev <= 105) {
												return LinFmod(1,296,344,85,105,L);
											} else {
												return LinFmod(1,344,380,105,120,L);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 50) {
											return LinFmod(1,187,427,1,50,L);
										} else if (L-DblCalcDev <= 85) {
											return LinFmod(1,427,599,50,85,L);
										} else if (L-DblCalcDev <= 105) {
											return LinFmod(1,599,697,85,105,L);
										} else {
											return LinFmod(1,697,770,105,120,L);
										}
									}
								} else if (SN > "REPVITALITYH") {
									if (SN < "REPWILLH") {
										if (SN == "REPVITALITYL") {
											return CalcStat("RepMainL",L);
										} else {
											return 0;
										}
									} else if (SN > "REPWILLH") {
										if (SN > "REPWILLL") {
											if (SN == "RESIST") {
												return CalcStat("RatDefence",L,N);
											} else {
												return 0;
											}
										} else if (SN == "REPWILLL") {
											return CalcStat("RepMainL",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("RepMainH",L);
									}
								} else {
									return CalcStat("RepMainH",L);
								}
							} else if (SN > "RESISTPBONUS") {
								if (SN < "RESISTPRATPC") {
									if (SN < "RESISTPRATP") {
										if (SN == "RESISTPPRAT") {
											return CalcRatAB(CalcStat("ResistPRatPA",L),CalcStat("ResistPRatPB",L),CalcStat("ResistPRatPCapR",L),N);
										} else {
											return 0;
										}
									} else if (SN > "RESISTPRATP") {
										if (SN > "RESISTPRATPA") {
											if (SN == "RESISTPRATPB") {
												return CalcStat("BratLow",L);
											} else {
												return 0;
											}
										} else if (SN == "RESISTPRATPA") {
											return 100;
										} else {
											return 0;
										}
									} else {
										return CalcPercAB(CalcStat("ResistPRatPA",L),CalcStat("ResistPRatPB",L),CalcStat("ResistPRatPCap",L),N);
									}
								} else if (SN > "RESISTPRATPC") {
									if (SN < "RESISTT") {
										if (SN > "RESISTPRATPCAP") {
											if (SN == "RESISTPRATPCAPR") {
												return CalcStat("ResistPRatPB",L)*CalcStat("ResistPRatPC",L);
											} else {
												return 0;
											}
										} else if (SN == "RESISTPRATPCAP") {
											return 50;
										} else {
											return 0;
										}
									} else if (SN > "RESISTT") {
										if (SN > "RUNEKEEPERCDAGILITYTOCRITHIT") {
											if (SN == "RUNEKEEPERCDAGILITYTOEVADE") {
												return 3;
											} else {
												return 0;
											}
										} else if (SN == "RUNEKEEPERCDAGILITYTOCRITHIT") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return CalcStat("RatDefenceT",L,N);
									}
								} else {
									return 1;
								}
							} else {
								return 0;
							}
						} else {
							return CalcStat("RepMainH",L);
						}
					} else if (SN > "RUNEKEEPERCDAGILITYTOPARRY") {
						if (SN < "RUNEKEEPERCDFATETOTACMIT") {
							if (SN < "RUNEKEEPERCDBASEMORALE") {
								if (SN < "RUNEKEEPERCDBASEAGILITY") {
									if (SN < "RUNEKEEPERCDARMOURTOPHYMIT") {
										if (SN == "RUNEKEEPERCDARMOURTOOFMIT") {
											return 0.2;
										} else {
											return 0;
										}
									} else if (SN > "RUNEKEEPERCDARMOURTOPHYMIT") {
										if (SN > "RUNEKEEPERCDARMOURTOTACMIT") {
											if (SN == "RUNEKEEPERCDARMOURTYPE") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "RUNEKEEPERCDARMOURTOTACMIT") {
											return 0.2;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else if (SN > "RUNEKEEPERCDBASEAGILITY") {
									if (SN < "RUNEKEEPERCDBASEICMR") {
										if (SN == "RUNEKEEPERCDBASEFATE") {
											return CalcStat("ClassBaseMainK",L);
										} else {
											return 0;
										}
									} else if (SN > "RUNEKEEPERCDBASEICMR") {
										if (SN > "RUNEKEEPERCDBASEICPR") {
											if (SN == "RUNEKEEPERCDBASEMIGHT") {
												return CalcStat("ClassBaseMainB",L);
											} else {
												return 0;
											}
										} else if (SN == "RUNEKEEPERCDBASEICPR") {
											return CalcStat("ClassBaseICPR",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseICMRL",L);
									}
								} else {
									return CalcStat("ClassBaseMainG",L);
								}
							} else if (SN > "RUNEKEEPERCDBASEMORALE") {
								if (SN < "RUNEKEEPERCDBASEWILL") {
									if (SN < "RUNEKEEPERCDBASENCPR") {
										if (SN == "RUNEKEEPERCDBASENCMR") {
											return CalcStat("ClassBaseNCMRL",L);
										} else {
											return 0;
										}
									} else if (SN > "RUNEKEEPERCDBASENCPR") {
										if (SN > "RUNEKEEPERCDBASEPOWER") {
											if (SN == "RUNEKEEPERCDBASEVITALITY") {
												return CalcStat("ClassBaseMainD",L);
											} else {
												return 0;
											}
										} else if (SN == "RUNEKEEPERCDBASEPOWER") {
											if (L-DblCalcDev <= 120) {
												return CalcStat("ClassBasePowerH",L);
											} else {
												return CalcStat("ClassBasePowerH",120);
											}
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseNCPR",L);
									}
								} else if (SN > "RUNEKEEPERCDBASEWILL") {
									if (SN < "RUNEKEEPERCDFATETOICPR") {
										if (SN > "RUNEKEEPERCDFATETOCRITHIT") {
											if (SN == "RUNEKEEPERCDFATETOICMR") {
												return 1.5;
											} else {
												return 0;
											}
										} else if (SN == "RUNEKEEPERCDFATETOCRITHIT") {
											return 2.5;
										} else {
											return 0;
										}
									} else if (SN > "RUNEKEEPERCDFATETOICPR") {
										if (SN > "RUNEKEEPERCDFATETONCPR") {
											if (SN == "RUNEKEEPERCDFATETORESIST") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "RUNEKEEPERCDFATETONCPR") {
											return 24;
										} else {
											return 0;
										}
									} else {
										return 1.71;
									}
								} else {
									return CalcStat("ClassBaseMainI",L);
								}
							} else {
								if (L-DblCalcDev <= 120) {
									return CalcStat("ClassBaseMoraleL",L);
								} else {
									return CalcStat("ClassBaseMoraleL",120);
								}
							}
						} else if (SN > "RUNEKEEPERCDFATETOTACMIT") {
							if (SN < "RUNEKEEPERCDWILLTOEVADE") {
								if (SN < "RUNEKEEPERCDTACMASTOOUTHEAL") {
									if (SN < "RUNEKEEPERCDMIGHTTOBLOCK") {
										if (SN == "RUNEKEEPERCDHASPOWER") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "RUNEKEEPERCDMIGHTTOBLOCK") {
										if (SN > "RUNEKEEPERCDMIGHTTOPARRY") {
											if (SN == "RUNEKEEPERCDPHYMITTOOFMIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "RUNEKEEPERCDMIGHTTOPARRY") {
											return 2;
										} else {
											return 0;
										}
									} else {
										return 3;
									}
								} else if (SN > "RUNEKEEPERCDTACMASTOOUTHEAL") {
									if (SN < "RUNEKEEPERCDVITALITYTONCMR") {
										if (SN == "RUNEKEEPERCDVITALITYTOMORALE") {
											return 4;
										} else {
											return 0;
										}
									} else if (SN > "RUNEKEEPERCDVITALITYTONCMR") {
										if (SN > "RUNEKEEPERCDVITALITYTORESIST") {
											if (SN == "RUNEKEEPERCDVITALITYTOTACMIT") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "RUNEKEEPERCDVITALITYTORESIST") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 7.2;
									}
								} else {
									return 1;
								}
							} else if (SN > "RUNEKEEPERCDWILLTOEVADE") {
								if (SN < "RUNEKEEPERCDWILLTOTACMIT") {
									if (SN < "RUNEKEEPERCDWILLTOOUTHEAL") {
										if (SN == "RUNEKEEPERCDWILLTOFINESSE") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "RUNEKEEPERCDWILLTOOUTHEAL") {
										if (SN > "RUNEKEEPERCDWILLTORESIST") {
											if (SN == "RUNEKEEPERCDWILLTOTACMAS") {
												return 3;
											} else {
												return 0;
											}
										} else if (SN == "RUNEKEEPERCDWILLTORESIST") {
											return 2;
										} else {
											return 0;
										}
									} else {
										return 3;
									}
								} else if (SN > "RUNEKEEPERCDWILLTOTACMIT") {
									if (SN < "SCALEMAIN") {
										if (SN > "SCALEARMOUR") {
											if (SN == "SCALECRITHIT") {
												if (L-DblCalcDev <= 39) {
													return RoundDbl((CalcStat("ScaleRatMP",L)*2.395/3)*L+0.135);
												} else if (L-DblCalcDev <= 75) {
													return RoundDbl(LinFmod(1,94,660,39,75,L));
												} else if (L-DblCalcDev <= 84) {
													return 37*L-2115;
												} else if (L-DblCalcDev <= 94) {
													return 29*L-1432;
												} else if (L-DblCalcDev <= 100) {
													return RoundDbl(25.2*L-1074.4);
												} else if (L-DblCalcDev <= 104) {
													return 190*L-17554;
												} else if (L-DblCalcDev <= 115) {
													return 154*L-13776;
												} else if (L-DblCalcDev <= 120) {
													return RoundDbl(582.25*L-189076/3);
												} else if (L-DblCalcDev <= 129) {
													return 830*L-92755;
												} else {
													return 15147;
												}
											} else {
												return 0;
											}
										} else if (SN == "SCALEARMOUR") {
											if (L-DblCalcDev <= 75) {
												return RoundDbl(LinFmod(1,7,1745,1,91,L));
											} else if (L-DblCalcDev <= 84) {
												return 82*L-4714;
											} else if (L-DblCalcDev <= 94) {
												return 63*L-3101;
											} else if (L-DblCalcDev <= 99) {
												return 55*L-2346;
											} else if (L-DblCalcDev <= 104) {
												return 240*L-20844;
											} else if (L-DblCalcDev <= 114) {
												return 251*L-21998;
											} else if (L-DblCalcDev <= 119) {
												return 1016*L-109974;
											} else if (L-DblCalcDev <= 129) {
												return 1209*L-133133;
											} else {
												return 24032;
											}
										} else {
											return 0;
										}
									} else if (SN > "SCALEMAIN") {
										if (SN > "SCALEMAINPROG") {
											if (SN == "SCALEMASTERY") {
												if (L-DblCalcDev <= 39) {
													return RoundDbl((CalcStat("ScaleRatMP",L)*2.395/3)*L+0.135);
												} else if (L-DblCalcDev <= 75) {
													return RoundDbl(LinFmod(1,94,891,39,75,L));
												} else if (L-DblCalcDev <= 84) {
													return 51*L-2934;
												} else if (L-DblCalcDev <= 94) {
													return 39*L-1919;
												} else if (L-DblCalcDev <= 100) {
													return RoundDbl(34.2*L-1467.4);
												} else if (L-DblCalcDev <= 104) {
													return 256*L-23647;
												} else if (L-DblCalcDev <= 115) {
													return RoundDbl(207.9*L-18597.05);
												} else if (L-DblCalcDev <= 120) {
													return 786*L-85079;
												} else if (L-DblCalcDev <= 129) {
													return 1121*L-125279;
												} else {
													return 20448;
												}
											} else {
												return 0;
											}
										} else if (SN == "SCALEMAINPROG") {
											if (L-DblCalcDev <= 35) {
												return LinFmod(1,1,17.4,1,35,L);
											} else if (L-DblCalcDev <= 39) {
												return LinFmod(1,17.4,18.7,36,39,L);
											} else if (L-DblCalcDev <= 75) {
												return LinFmod(1,20.7,80,40,75,L);
											} else {
												return LinFmod(1,85,125,76,84,L);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 35) {
											return RoundDbl(LinFmod(1,1,17.4,1,35,L));
										} else if (L-DblCalcDev <= 39) {
											return RoundDbl(LinFmod(1,17.4,18.7,36,39,L));
										} else if (L-DblCalcDev <= 75) {
											return RoundDbl(LinFmod(1,20.7,80,40,75,L));
										} else if (L-DblCalcDev <= 84) {
											return 5*L-295;
										} else if (L-DblCalcDev <= 94) {
											return 3*L-127;
										} else if (L-DblCalcDev <= 100) {
											return 3*L-123;
										} else if (L-DblCalcDev <= 104) {
											return 13*L-1123;
										} else if (L-DblCalcDev <= 114) {
											return 14*L-1226;
										} else if (L-DblCalcDev <= 119) {
											return 69*L-7550;
										} else if (L-DblCalcDev <= 129) {
											return 83*L-9232;
										} else {
											return 1560;
										}
									}
								} else {
									return 1;
								}
							} else {
								return 1;
							}
						} else {
							return 1;
						}
					} else {
						return 2;
					}
				} else {
					return (6.6667*L-203.6667)*N;
				}
			} else {
				return CalcStat("BratMastery",L);
			}
		} else if (SN > "SCALERATMP") {
			if (SN < "VIRTLOYALTYARMOUR") {
				if (SN < "TITLOWPHYMIT") {
					if (SN < "TACMAST") {
						if (SN < "STOUTAXERDPSVONEVITALITY") {
							if (SN < "STDMORALERAWH") {
								if (SN < "STATPROG") {
									if (SN < "SCALEVITALITYPROG") {
										if (SN == "SCALEVITALITY") {
											if (L-DblCalcDev <= 120) {
												return RoundDbl((CalcStat("ScaleVitalityProg",L)/CalcStat("ScaleMainProg",L))*CalcStat("ScaleMain",L));
											} else if (L-DblCalcDev <= 125) {
												return 74*L-8229;
											} else if (L-DblCalcDev <= 129) {
												return 80*L-8901;
											} else {
												return 1500;
											}
										} else {
											return 0;
										}
									} else if (SN > "SCALEVITALITYPROG") {
										if (SN > "SHIELDBRAWLERBLOCK") {
											if (SN == "SHIELDBRAWLERBLOCKRAW") {
												if (L-DblCalcDev <= 105) {
													return 20.2*L;
												} else if (L-DblCalcDev <= 115) {
													return LinFmod(CalcStat("ShieldBrawlerBlockRaw",105),2,4,106,115,L,-1);
												} else if (L-DblCalcDev <= 116) {
													return ExpFmod(CalcStat("ShieldBrawlerBlockRaw",115),116,20.0025,L);
												} else if (L-DblCalcDev <= 120) {
													return ExpFmod(CalcStat("ShieldBrawlerBlockRaw",116),117,5.5004,L);
												} else if (L-DblCalcDev <= 121) {
													return ExpFmod(CalcStat("ShieldBrawlerBlockRaw",120),121,20.0025,L);
												} else if (L-DblCalcDev <= 125) {
													return ExpFmod(CalcStat("ShieldBrawlerBlockRaw",121),122,5.5004,L);
												} else if (L-DblCalcDev <= 126) {
													return ExpFmod(CalcStat("ShieldBrawlerBlockRaw",125),126,20.0025,L);
												} else {
													return ExpFmod(CalcStat("ShieldBrawlerBlockRaw",126),127,5.5004,L);
												}
											} else {
												return 0;
											}
										} else if (SN == "SHIELDBRAWLERBLOCK") {
											return RoundDbl(CalcStat("ShieldBrawlerBlockRaw",L));
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 35) {
											return LinFmod(1,1.2,15,1,35,L);
										} else if (L-DblCalcDev <= 39) {
											return LinFmod(1,15,16,36,39,L);
										} else if (L-DblCalcDev <= 75) {
											return LinFmod(1,17.6,67,40,75,L);
										} else {
											return LinFmod(1,71.3,104.6,76,84,L);
										}
									}
								} else if (SN > "STATPROG") {
									if (SN < "STDMORALEL") {
										if (SN == "STDMORALEH") {
											return RoundDbl(CalcStat("StdMoraleRawH",L));
										} else {
											return 0;
										}
									} else if (SN > "STDMORALEL") {
										if (SN > "STDMORALEM") {
											if (SN == "STDMORALERAW") {
												if (L-DblCalcDev <= 50) {
													return LinFmod(1,7.51,227.59,1,50,L);
												} else {
													return LinFmod(1,227.59,1327.5,50,105,L);
												}
											} else {
												return 0;
											}
										} else if (SN == "STDMORALEM") {
											return RoundDbl(CalcStat("StdMoraleRawM",L));
										} else {
											return 0;
										}
									} else {
										return RoundDbl(CalcStat("StdMoraleRawL",L));
									}
								} else {
									if (L-DblCalcDev <= 75) {
										return LinFmod(RoundDbl(N),1,75,1,75,L);
									} else if (L-DblCalcDev <= 76) {
										return LinFmod(1,RoundDbl(N)*75,CalcStat("StdProg",76,N),75,76,L);
									} else {
										return CalcStat("StdProg",L,N);
									}
								}
							} else if (SN > "STDMORALERAWH") {
								if (SN < "STDPOWERRAW") {
									if (SN < "STDMORALERAWM") {
										if (SN == "STDMORALERAWL") {
											if (L-DblCalcDev <= 105) {
												return CalcStat("StdMoraleRaw",L);
											} else if (L-DblCalcDev <= 106) {
												return ExpFmod(CalcStat("StdMoraleRawL",105),106,5.4995,L);
											} else if (L-DblCalcDev <= 115) {
												return ExpFmod(CalcStat("StdMoraleRawL",106),107,5.4995,L);
											} else if (L-DblCalcDev <= 116) {
												return ExpFmod(CalcStat("StdMoraleRawL",115),116,19.98,L);
											} else if (L-DblCalcDev <= 120) {
												return ExpFmod(CalcStat("StdMoraleRawL",116),117,5.505,L);
											} else if (L-DblCalcDev <= 121) {
												return ExpFmod(CalcStat("StdMoraleRawL",120),121,20,L);
											} else if (L-DblCalcDev <= 125) {
												return ExpFmod(CalcStat("StdMoraleRawL",121),122,5.5,L);
											} else if (L-DblCalcDev <= 126) {
												return ExpFmod(CalcStat("StdMoraleRawL",125),126,20,L);
											} else if (L-DblCalcDev <= 130) {
												return ExpFmod(CalcStat("StdMoraleRawL",126),127,5.5,L);
											} else {
												return CalcStat("StdMoraleRawL",130);
											}
										} else {
											return 0;
										}
									} else if (SN > "STDMORALERAWM") {
										if (SN > "STDPOWERH") {
											if (SN == "STDPOWERL") {
												return RoundDbl(CalcStat("StdPowerRawL",L));
											} else {
												return 0;
											}
										} else if (SN == "STDPOWERH") {
											return RoundDbl(CalcStat("StdPowerRawH",L));
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 105) {
											return 1.5*CalcStat("StdMoraleRaw",L);
										} else if (L-DblCalcDev <= 106) {
											return ExpFmod(CalcStat("StdMoraleRawM",105),106,5.535,L);
										} else if (L-DblCalcDev <= 110) {
											return ExpFmod(CalcStat("StdMoraleRawM",106),107,5.51,L);
										} else if (L-DblCalcDev <= 111) {
											return ExpFmod(CalcStat("StdMoraleRawM",110),111,5.488,L);
										} else if (L-DblCalcDev <= 115) {
											return ExpFmod(CalcStat("StdMoraleRawM",111),112,5.488,L);
										} else if (L-DblCalcDev <= 116) {
											return ExpFmod(CalcStat("StdMoraleRawM",115),116,20,L);
										} else if (L-DblCalcDev <= 120) {
											return ExpFmod(CalcStat("StdMoraleRawM",116),117,5.505,L);
										} else if (L-DblCalcDev <= 121) {
											return ExpFmod(CalcStat("StdMoraleRawM",120),121,20,L);
										} else if (L-DblCalcDev <= 125) {
											return ExpFmod(CalcStat("StdMoraleRawM",121),122,5.5025,L);
										} else if (L-DblCalcDev <= 126) {
											return ExpFmod(CalcStat("StdMoraleRawM",125),126,20,L);
										} else if (L-DblCalcDev <= 130) {
											return ExpFmod(CalcStat("StdMoraleRawM",126),127,5.5,L);
										} else {
											return CalcStat("StdMoraleRawM",130);
										}
									}
								} else if (SN > "STDPOWERRAW") {
									if (SN < "STDPOWERRAWL") {
										if (SN == "STDPOWERRAWH") {
											if (L-DblCalcDev <= 105) {
												return 2*CalcStat("StdPowerRaw",L);
											} else if (L-DblCalcDev <= 106) {
												return ExpFmod(CalcStat("StdPowerRawH",105),106,5.5,L);
											} else if (L-DblCalcDev <= 115) {
												return ExpFmod(CalcStat("StdPowerRawH",106),107,5.5009,L);
											} else if (L-DblCalcDev <= 116) {
												return ExpFmod(CalcStat("StdPowerRawH",115),116,20,L);
											} else if (L-DblCalcDev <= 120) {
												return ExpFmod(CalcStat("StdPowerRawH",116),117,5.5009,L);
											} else if (L-DblCalcDev <= 121) {
												return ExpFmod(CalcStat("StdPowerRawH",120),121,20,L);
											} else if (L-DblCalcDev <= 125) {
												return ExpFmod(CalcStat("StdPowerRawH",121),122,5.5009,L);
											} else if (L-DblCalcDev <= 126) {
												return ExpFmod(CalcStat("StdPowerRawH",125),126,20,L);
											} else if (L-DblCalcDev <= 130) {
												return ExpFmod(CalcStat("StdPowerRawH",126),127,5.5009,L);
											} else {
												return CalcStat("StdPowerRawH",130);
											}
										} else {
											return 0;
										}
									} else if (SN > "STDPOWERRAWL") {
										if (SN > "STDPROG") {
											if (SN == "STOUTAXERDPSVONENAME") {
												return "Unwritten Destiny";
											} else {
												return 0;
											}
										} else if (SN == "STDPROG") {
											if (L-DblCalcDev <= 75) {
												return LinFmod(N,1,75,1,75,L);
											} else if (L-DblCalcDev <= 76) {
												return LinFmod(1,N*75,RoundDbl(N*82.5,-2),75,76,L);
											} else if (L-DblCalcDev <= 100) {
												return LinFmod(1,RoundDbl(N*82.5,-2),N*150,76,100,L);
											} else if (L-DblCalcDev <= 101) {
												return LinFmod(N,150,165,100,101,L);
											} else if (L-DblCalcDev <= 105) {
												return LinFmod(N,165,225,101,105,L);
											} else if (L-DblCalcDev <= 106) {
												return LinFmod(N,225,270,105,106,L);
											} else if (L-DblCalcDev <= 115) {
												return LinFmod(N,270,450,106,115,L);
											} else if (L-DblCalcDev <= 116) {
												return LinFmod(N,450,495,115,116,L);
											} else if (L-DblCalcDev <= 120) {
												return LinFmod(N,495,1125,116,120,L);
											} else if (L-DblCalcDev <= 121) {
												return LinFmod(N,1125,1575,120,121,L);
											} else if (L-DblCalcDev <= 130) {
												return LinFmod(N,1575,3150,121,130,L);
											} else if (L-DblCalcDev <= 131) {
												return LinFmod(N,3150,3780,130,131,L);
											} else {
												return LinFmod(N,3780,6300,130,140,L);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 105) {
											return CalcStat("StdPowerRaw",L);
										} else if (L-DblCalcDev <= 106) {
											return ExpFmod(CalcStat("StdPowerRawL",105),106,5.42,L);
										} else if (L-DblCalcDev <= 115) {
											return ExpFmod(CalcStat("StdPowerRawL",106),107,5.515,L);
										} else if (L-DblCalcDev <= 116) {
											return ExpFmod(CalcStat("StdPowerRawL",115),116,20.1,L);
										} else if (L-DblCalcDev <= 120) {
											return ExpFmod(CalcStat("StdPowerRawL",116),117,5.515,L);
										} else if (L-DblCalcDev <= 121) {
											return ExpFmod(CalcStat("StdPowerRawL",120),121,20,L);
										} else if (L-DblCalcDev <= 125) {
											return ExpFmod(CalcStat("StdPowerRawL",121),122,5.515,L);
										} else if (L-DblCalcDev <= 126) {
											return ExpFmod(CalcStat("StdPowerRawL",125),126,19.98,L);
										} else if (L-DblCalcDev <= 130) {
											return ExpFmod(CalcStat("StdPowerRawL",126),127,5.5,L);
										} else {
											return CalcStat("StdPowerRawL",130);
										}
									}
								} else {
									if (L-DblCalcDev <= 50) {
										return LinFmod(1,3,91.0375,1,50,L);
									} else {
										return LinFmod(1,91.0375,421,50,105,L);
									}
								}
							} else {
								if (L-DblCalcDev <= 105) {
									return 2*CalcStat("StdMoraleRaw",L);
								} else if (L-DblCalcDev <= 106) {
									return ExpFmod(CalcStat("StdMoraleRawH",105),106,5.5,L);
								} else if (L-DblCalcDev <= 115) {
									return ExpFmod(CalcStat("StdMoraleRawH",106),107,5.4982,L);
								} else if (L-DblCalcDev <= 116) {
									return ExpFmod(CalcStat("StdMoraleRawH",115),116,20,L);
								} else if (L-DblCalcDev <= 120) {
									return ExpFmod(CalcStat("StdMoraleRawH",116),117,5.4982,L);
								} else if (L-DblCalcDev <= 121) {
									return ExpFmod(CalcStat("StdMoraleRawH",120),121,20,L);
								} else if (L-DblCalcDev <= 125) {
									return ExpFmod(CalcStat("StdMoraleRawH",121),122,5.4982,L);
								} else if (L-DblCalcDev <= 126) {
									return ExpFmod(CalcStat("StdMoraleRawH",125),126,20,L);
								} else if (L-DblCalcDev <= 130) {
									return ExpFmod(CalcStat("StdMoraleRawH",126),127,5.4982,L);
								} else {
									return CalcStat("StdMoraleRawH",130);
								}
							}
						} else if (SN > "STOUTAXERDPSVONEVITALITY") {
							if (SN < "T2PENMIT") {
								if (SN < "STOUTAXERDTRAITPHYMITP") {
									if (SN < "STOUTAXERDTRAITAGILITY") {
										if (SN == "STOUTAXERDPSVTWONAME") {
											return "";
										} else {
											return 0;
										}
									} else if (SN > "STOUTAXERDTRAITAGILITY") {
										if (SN > "STOUTAXERDTRAITFATE") {
											if (SN == "STOUTAXERDTRAITMIGHT") {
												return 15;
											} else {
												return 0;
											}
										} else if (SN == "STOUTAXERDTRAITFATE") {
											return -10;
										} else {
											return 0;
										}
									} else {
										return 5;
									}
								} else if (SN > "STOUTAXERDTRAITPHYMITP") {
									if (SN < "STOUTAXERDTRAITWILL") {
										if (SN == "STOUTAXERDTRAITVITALITY") {
											return 3;
										} else {
											return 0;
										}
									} else if (SN > "STOUTAXERDTRAITWILL") {
										if (SN > "T2PENARMOUR") {
											if (SN == "T2PENBPE") {
												if (L-DblCalcDev <= 115) {
													return (-40)*L;
												} else if (L-DblCalcDev <= 116) {
													return ExpFmod(CalcStat("T2penBPE",115),116,20,L);
												} else if (L-DblCalcDev <= 120) {
													return ExpFmod(CalcStat("T2penBPE",116),117,5.5,L);
												} else if (L-DblCalcDev <= 121) {
													return ExpFmod(CalcStat("T2penBPE",120),121,20,L);
												} else if (L-DblCalcDev <= 125) {
													return ExpFmod(CalcStat("T2penBPE",121),122,5.5,L);
												} else if (L-DblCalcDev <= 126) {
													return ExpFmod(CalcStat("T2penBPE",125),126,20,L);
												} else {
													return ExpFmod(CalcStat("T2penBPE",126),127,5.5,L);
												}
											} else {
												return 0;
											}
										} else if (SN == "T2PENARMOUR") {
											return CalcStat("T2penMit",L);
										} else {
											return 0;
										}
									} else {
										return 15;
									}
								} else {
									return 1;
								}
							} else if (SN > "T2PENMIT") {
								if (SN < "TACDMGPRATPA") {
									if (SN < "TACDMGPBONUS") {
										if (SN == "T2PENRESIST") {
											if (L-DblCalcDev <= 115) {
												return (-90)*L;
											} else if (L-DblCalcDev <= 116) {
												return ExpFmod(CalcStat("T2penResist",115),116,20,L);
											} else if (L-DblCalcDev <= 120) {
												return ExpFmod(CalcStat("T2penResist",116),117,5.5,L);
											} else if (L-DblCalcDev <= 121) {
												return ExpFmod(CalcStat("T2penResist",120),121,20,L);
											} else if (L-DblCalcDev <= 125) {
												return ExpFmod(CalcStat("T2penResist",121),122,5.5,L);
											} else if (L-DblCalcDev <= 126) {
												return ExpFmod(CalcStat("T2penResist",125),126,20,L);
											} else {
												return ExpFmod(CalcStat("T2penResist",126),127,5.5,L);
											}
										} else {
											return 0;
										}
									} else if (SN > "TACDMGPBONUS") {
										if (SN > "TACDMGPPRAT") {
											if (SN == "TACDMGPRATP") {
												return CalcPercAB(CalcStat("TacDmgPRatPA",L),CalcStat("TacDmgPRatPB",L),CalcStat("TacDmgPRatPCap",L),N);
											} else {
												return 0;
											}
										} else if (SN == "TACDMGPPRAT") {
											return CalcRatAB(CalcStat("TacDmgPRatPA",L),CalcStat("TacDmgPRatPB",L),CalcStat("TacDmgPRatPCapR",L),N);
										} else {
											return 0;
										}
									} else {
										return 0;
									}
								} else if (SN > "TACDMGPRATPA") {
									if (SN < "TACDMGPRATPCAP") {
										if (SN > "TACDMGPRATPB") {
											if (SN == "TACDMGPRATPC") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "TACDMGPRATPB") {
											return CalcStat("BratMastery",L);
										} else {
											return 0;
										}
									} else if (SN > "TACDMGPRATPCAP") {
										if (SN > "TACDMGPRATPCAPR") {
											if (SN == "TACMAS") {
												return CalcStat("RatMastery",L,N);
											} else {
												return 0;
											}
										} else if (SN == "TACDMGPRATPCAPR") {
											return CalcStat("TacDmgPRatPB",L)*CalcStat("TacDmgPRatPC",L);
										} else {
											return 0;
										}
									} else {
										return 200;
									}
								} else {
									return 400;
								}
							} else {
								if (L-DblCalcDev <= 115) {
									return FloorDbl(L*13.5)*-5;
								} else if (L-DblCalcDev <= 116) {
									return ExpFmod(CalcStat("T2penMit",115),116,20,L);
								} else if (L-DblCalcDev <= 120) {
									return ExpFmod(CalcStat("T2penMit",116),117,5.5,L);
								} else if (L-DblCalcDev <= 121) {
									return ExpFmod(CalcStat("T2penMit",120),121,20,L);
								} else if (L-DblCalcDev <= 125) {
									return ExpFmod(CalcStat("T2penMit",121),122,5.5,L);
								} else if (L-DblCalcDev <= 126) {
									return ExpFmod(CalcStat("T2penMit",125),126,20,L);
								} else {
									return ExpFmod(CalcStat("T2penMit",126),127,5.5,L);
								}
							}
						} else {
							return CalcStat("RacialVitality",L);
						}
					} else if (SN > "TACMAST") {
						if (SN < "TACMITMPRATP") {
							if (SN < "TACMITLPBONUS") {
								if (SN < "TACMITHPRATPA") {
									if (SN < "TACMITHPBONUS") {
										if (SN == "TACMIT") {
											return CalcStat("RatMitigation",L,N);
										} else {
											return 0;
										}
									} else if (SN > "TACMITHPBONUS") {
										if (SN > "TACMITHPPRAT") {
											if (SN == "TACMITHPRATP") {
												return CalcStat("MitHeavyPRatP",L,N);
											} else {
												return 0;
											}
										} else if (SN == "TACMITHPPRAT") {
											return CalcStat("MitHeavyPPRat",L,N);
										} else {
											return 0;
										}
									} else {
										return CalcStat("MitHeavyPBonus",L);
									}
								} else if (SN > "TACMITHPRATPA") {
									if (SN < "TACMITHPRATPC") {
										if (SN == "TACMITHPRATPB") {
											return CalcStat("MitHeavyPRatPB",L);
										} else {
											return 0;
										}
									} else if (SN > "TACMITHPRATPC") {
										if (SN > "TACMITHPRATPCAP") {
											if (SN == "TACMITHPRATPCAPR") {
												return CalcStat("MitHeavyPRatPCapR",L);
											} else {
												return 0;
											}
										} else if (SN == "TACMITHPRATPCAP") {
											return CalcStat("MitHeavyPRatPCap",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("MitHeavyPRatPC",L);
									}
								} else {
									return CalcStat("MitHeavyPRatPA",L);
								}
							} else if (SN > "TACMITLPBONUS") {
								if (SN < "TACMITLPRATPC") {
									if (SN < "TACMITLPRATP") {
										if (SN == "TACMITLPPRAT") {
											return CalcStat("MitLightPPRat",L,N);
										} else {
											return 0;
										}
									} else if (SN > "TACMITLPRATP") {
										if (SN > "TACMITLPRATPA") {
											if (SN == "TACMITLPRATPB") {
												return CalcStat("MitLightPRatPB",L);
											} else {
												return 0;
											}
										} else if (SN == "TACMITLPRATPA") {
											return CalcStat("MitLightPRatPA",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("MitLightPRatP",L,N);
									}
								} else if (SN > "TACMITLPRATPC") {
									if (SN < "TACMITLPRATPCAPR") {
										if (SN == "TACMITLPRATPCAP") {
											return CalcStat("MitLightPRatPCap",L);
										} else {
											return 0;
										}
									} else if (SN > "TACMITLPRATPCAPR") {
										if (SN > "TACMITMPBONUS") {
											if (SN == "TACMITMPPRAT") {
												return CalcStat("MitMediumPPRat",L,N);
											} else {
												return 0;
											}
										} else if (SN == "TACMITMPBONUS") {
											return CalcStat("MitMediumPBonus",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("MitLightPRatPCapR",L);
									}
								} else {
									return CalcStat("MitLightPRatPC",L);
								}
							} else {
								return CalcStat("MitLightPBonus",L);
							}
						} else if (SN > "TACMITMPRATP") {
							if (SN < "TITBPECHOICE") {
								if (SN < "TACMITMPRATPCAPR") {
									if (SN < "TACMITMPRATPB") {
										if (SN == "TACMITMPRATPA") {
											return CalcStat("MitMediumPRatPA",L);
										} else {
											return 0;
										}
									} else if (SN > "TACMITMPRATPB") {
										if (SN > "TACMITMPRATPC") {
											if (SN == "TACMITMPRATPCAP") {
												return CalcStat("MitMediumPRatPCap",L);
											} else {
												return 0;
											}
										} else if (SN == "TACMITMPRATPC") {
											return CalcStat("MitMediumPRatPC",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("MitMediumPRatPB",L);
									}
								} else if (SN > "TACMITMPRATPCAPR") {
									if (SN < "TITAGILITY") {
										if (SN == "TACMITT") {
											return CalcStat("RatMitigationT",L,N);
										} else {
											return 0;
										}
									} else if (SN > "TITAGILITY") {
										if (SN > "TITBLOCK") {
											if (SN == "TITBPE") {
												return CalcStat("RatDefence",CalcStat("TitBPEChoice",RomanRankDecode(C)));
											} else {
												return 0;
											}
										} else if (SN == "TITBLOCK") {
											return CalcStat("TitBPE",L,C);
										} else {
											return 0;
										}
									} else {
										return CalcStat("TitMain",L,C);
									}
								} else {
									return CalcStat("MitMediumPRatPCapR",L);
								}
							} else if (SN > "TITBPECHOICE") {
								if (SN < "TITEVADE") {
									if (SN < "TITCRITDEFCHOICE") {
										if (SN == "TITCRITDEF") {
											return CalcStat("CritDef",CalcStat("TitCritDefChoice",RomanRankDecode(C)));
										} else {
											return 0;
										}
									} else if (SN > "TITCRITDEFCHOICE") {
										if (SN > "TITCRITHIT") {
											if (SN == "TITCRITHITCHOICE") {
												return DataTableValue([75,95,115],L);
											} else {
												return 0;
											}
										} else if (SN == "TITCRITHIT") {
											return CalcStat("CritHit",CalcStat("TitCritHitChoice",RomanRankDecode(C)));
										} else {
											return 0;
										}
									} else {
										return DataTableValue([75,95,115],L);
									}
								} else if (SN > "TITEVADE") {
									if (SN < "TITFINESSECHOICE") {
										if (SN > "TITFATE") {
											if (SN == "TITFINESSE") {
												return CalcStat("Finesse",CalcStat("TitFinesseChoice",RomanRankDecode(C)),0.4);
											} else {
												return 0;
											}
										} else if (SN == "TITFATE") {
											return CalcStat("TitMain",L,C);
										} else {
											return 0;
										}
									} else if (SN > "TITFINESSECHOICE") {
										if (SN > "TITLOWMIT") {
											if (SN == "TITLOWMITCHOICE") {
												return DataTableValue([1,2,3],L);
											} else {
												return 0;
											}
										} else if (SN == "TITLOWMIT") {
											return 175.5*CalcStat("TitLowMitChoice",RomanRankDecode(C))+44.5;
										} else {
											return 0;
										}
									} else {
										return DataTableValue([75,95,115],L);
									}
								} else {
									return CalcStat("TitBPE",L,C);
								}
							} else {
								return DataTableValue([75,95,115],L);
							}
						} else {
							return CalcStat("MitMediumPRatP",L,N);
						}
					} else {
						return CalcStat("RatMasteryT",L,N);
					}
				} else if (SN > "TITLOWPHYMIT") {
					if (SN < "VIRTDETERMINATIONAGILITY") {
						if (SN < "TOMETOTALA") {
							if (SN < "TITPHYMAS") {
								if (SN < "TITMASTERYCHOICE") {
									if (SN < "TITMAIN") {
										if (SN == "TITLOWTACMIT") {
											return CalcStat("TitLowMit",L,C);
										} else {
											return 0;
										}
									} else if (SN > "TITMAIN") {
										if (SN > "TITMAINCHOICE") {
											if (SN == "TITMASTERY") {
												return FloorDbl(2.1*CalcStat("TitMasteryChoice",RomanRankDecode(C)))*5;
											} else {
												return 0;
											}
										} else if (SN == "TITMAINCHOICE") {
											return DataTableValue([75,95,115],L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("Main",CalcStat("TitMainChoice",RomanRankDecode(C)));
									}
								} else if (SN > "TITMASTERYCHOICE") {
									if (SN < "TITMITIGATION") {
										if (SN == "TITMIGHT") {
											return CalcStat("TitMain",L,C);
										} else {
											return 0;
										}
									} else if (SN > "TITMITIGATION") {
										if (SN > "TITMITIGATIONCHOICE") {
											if (SN == "TITPARRY") {
												return CalcStat("TitBPE",L,C);
											} else {
												return 0;
											}
										} else if (SN == "TITMITIGATIONCHOICE") {
											return DataTableValue([75,85,95],L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("RatMitigation",CalcStat("TitMitigationChoice",RomanRankDecode(C)));
									}
								} else {
									return DataTableValue([75,100,125],L);
								}
							} else if (SN > "TITPHYMAS") {
								if (SN < "TITVITALITYCHOICE") {
									if (SN < "TITTACMAS") {
										if (SN == "TITPHYMIT") {
											return CalcStat("TitMitigation",L,C);
										} else {
											return 0;
										}
									} else if (SN > "TITTACMAS") {
										if (SN > "TITTACMIT") {
											if (SN == "TITVITALITY") {
												return CalcStat("Vitality",CalcStat("TitVitalityChoice",RomanRankDecode(C)));
											} else {
												return 0;
											}
										} else if (SN == "TITTACMIT") {
											return CalcStat("TitMitigation",L,C);
										} else {
											return 0;
										}
									} else {
										return CalcStat("TitMastery",L,C);
									}
								} else if (SN > "TITVITALITYCHOICE") {
									if (SN < "TOMEMAIN") {
										if (SN == "TITWILL") {
											return CalcStat("TitMain",L,C);
										} else {
											return 0;
										}
									} else if (SN > "TOMEMAIN") {
										if (SN > "TOMEMAINA") {
											if (SN == "TOMETOTAL") {
												return CalcStat("TomeTotalA",RomanRankDecode(C));
											} else {
												return 0;
											}
										} else if (SN == "TOMEMAINA") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else if (L-DblCalcDev <= 6) {
												return 15;
											} else if (L-DblCalcDev <= 7) {
												return 30;
											} else {
												return 40;
											}
										} else {
											return 0;
										}
									} else {
										return CalcStat("TomeMainA",RomanRankDecode(C));
									}
								} else {
									return DataTableValue([75,95,115],L);
								}
							} else {
								return CalcStat("TitMastery",L,C);
							}
						} else if (SN > "TOMETOTALA") {
							if (SN < "VIRTCHARITYVITALITY") {
								if (SN < "TRAITPROG") {
									if (SN < "TPENBPE") {
										if (SN == "TPENARMOUR") {
											return CalcStat("TpenChoice",N)*(CalcStat("ArmourLowRaw",1,"MSh")/CalcStat("TraitProg",1,CalcStat("ProgBMitMedium",L)))*CalcStat("TraitProg",L,CalcStat("ProgBMitMedium",L))*CalcStat("AdjTraitProgRatings",L,CalcStat("ProgBMitMedium",L));
										} else {
											return 0;
										}
									} else if (SN > "TPENBPE") {
										if (SN > "TPENCHOICE") {
											if (SN == "TPENRESIST") {
												return CalcStat("TpenChoice",N)*CalcStat("ResistT",L,2);
											} else {
												return 0;
											}
										} else if (SN == "TPENCHOICE") {
											return DataTableValue([0,-1,-2],L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("TpenChoice",N)*CalcStat("RatDefenceT",L);
									}
								} else if (SN > "TRAITPROG") {
									if (SN < "TRAITVITALITYPROG") {
										if (SN == "TRAITSLOWSEG") {
											if (L-DblCalcDev <= 105) {
												return LinFmod(1,1,180,1,105,L)*N;
											} else {
												return 0;
											}
										} else {
											return 0;
										}
									} else if (SN > "TRAITVITALITYPROG") {
										if (SN > "VIRTCHARITYPHYMIT") {
											if (SN == "VIRTCHARITYRESIST") {
												return CalcStat("VSResistH",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTCHARITYPHYMIT") {
											return CalcStat("VSPhyMitM",L);
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 40) {
											return LinFmod(1,CalcStat("StatProg",1,N),RoundDbl(N)*27.5,1,40,L);
										} else if (L-DblCalcDev <= 50) {
											return LinFmod(1,RoundDbl(N)*27.5,CalcStat("StatProg",50,N),40,50,L);
										} else if (L-DblCalcDev <= 105) {
											return LinFmod(1,CalcStat("StatProg",50,N),CalcStat("StatProg",105,N),50,105,L);
										} else if (L-DblCalcDev <= 115) {
											return CalcStat("StatProg",L,N);
										} else if (L-DblCalcDev <= 120) {
											return LinFmod(1,CalcStat("StatProg",115,N),CalcStat("StatProg",120,N),115,120,L);
										} else {
											return CalcStat("StatProg",L,N);
										}
									}
								} else {
									if (L-DblCalcDev <= 105) {
										return LinFmod(1,CalcStat("StatProg",1,N),CalcStat("StatProg",105,N),1,105,L);
									} else {
										return CalcStat("StatProg",L,N);
									}
								}
							} else if (SN > "VIRTCHARITYVITALITY") {
								if (SN < "VIRTCOMPASSIONVPMORALE") {
									if (SN < "VIRTCOMPASSIONARMOUR") {
										if (SN == "VIRTCHARITYVPMORALE") {
											return CalcStat("VSVPMorale",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTCOMPASSIONARMOUR") {
										if (SN > "VIRTCOMPASSIONPHYMIT") {
											if (SN == "VIRTCOMPASSIONTACMIT") {
												return CalcStat("VSTacMitM",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTCOMPASSIONPHYMIT") {
											return CalcStat("VSPhyMitH",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSArmourL",L);
									}
								} else if (SN > "VIRTCOMPASSIONVPMORALE") {
									if (SN < "VIRTCONFIDENCEFINESSE") {
										if (SN > "VIRTCONFIDENCECRITHIT") {
											if (SN == "VIRTCONFIDENCEEVADE") {
												return CalcStat("VSEvadeL",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTCONFIDENCECRITHIT") {
											return CalcStat("VSCritHitH",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTCONFIDENCEFINESSE") {
										if (SN > "VIRTCONFIDENCEVPPHYMAS") {
											if (SN == "VIRTCONFIDENCEVPTACMAS") {
												return CalcStat("VSVPTacMas",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTCONFIDENCEVPPHYMAS") {
											return CalcStat("VSVPPhyMas",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSFinesseM",L);
									}
								} else {
									return CalcStat("VSVPMorale",L);
								}
							} else {
								return CalcStat("VSVitalityL",L);
							}
						} else {
							if (L-DblCalcDev <= 0) {
								return 0;
							} else {
								return CalcStat("TomeMainA",L)+CalcStat("TomeTotalA",L-1);
							}
						}
					} else if (SN > "VIRTDETERMINATIONAGILITY") {
						if (SN < "VIRTHONESTYCRITHIT") {
							if (SN < "VIRTEMPATHYCRITDEF") {
								if (SN < "VIRTDISCIPLINEINHEAL") {
									if (SN < "VIRTDETERMINATIONPHYMAS") {
										if (SN == "VIRTDETERMINATIONCRITHIT") {
											return CalcStat("VSCritHitL",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTDETERMINATIONPHYMAS") {
										if (SN > "VIRTDETERMINATIONVPPHYMAS") {
											if (SN == "VIRTDETERMINATIONVPTACMAS") {
												return CalcStat("VSVPTacMas",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTDETERMINATIONVPPHYMAS") {
											return CalcStat("VSVPPhyMas",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSPhyMasM",L);
									}
								} else if (SN > "VIRTDISCIPLINEINHEAL") {
									if (SN < "VIRTDISCIPLINERESIST") {
										if (SN == "VIRTDISCIPLINEPHYMIT") {
											return CalcStat("VSPhyMitL",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTDISCIPLINERESIST") {
										if (SN > "VIRTDISCIPLINEVPMORALE") {
											if (SN == "VIRTEMPATHYARMOUR") {
												return CalcStat("VSArmourH",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTDISCIPLINEVPMORALE") {
											return CalcStat("VSVPMorale",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSResistH",L);
									}
								} else {
									return CalcStat("VSInHealM",L);
								}
							} else if (SN > "VIRTEMPATHYCRITDEF") {
								if (SN < "VIRTFIDELITYVITALITY") {
									if (SN < "VIRTEMPATHYVPMORALE") {
										if (SN == "VIRTEMPATHYRESIST") {
											return CalcStat("VSResistL",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTEMPATHYVPMORALE") {
										if (SN > "VIRTFIDELITYPHYMIT") {
											if (SN == "VIRTFIDELITYTACMIT") {
												return CalcStat("VSTacMitH",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTFIDELITYPHYMIT") {
											return CalcStat("VSPhyMitL",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSVPMorale",L);
									}
								} else if (SN > "VIRTFIDELITYVITALITY") {
									if (SN < "VIRTFORTITUDEMORALE") {
										if (SN > "VIRTFIDELITYVPMORALE") {
											if (SN == "VIRTFORTITUDECRITDEF") {
												return CalcStat("VSCritDefM",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTFIDELITYVPMORALE") {
											return CalcStat("VSVPMorale",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTFORTITUDEMORALE") {
										if (SN > "VIRTFORTITUDERESIST") {
											if (SN == "VIRTFORTITUDEVPMORALE") {
												return CalcStat("VSVPMorale",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTFORTITUDERESIST") {
											return CalcStat("VSResistL",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSMoraleH",L);
									}
								} else {
									return CalcStat("VSVitalityM",L);
								}
							} else {
								return CalcStat("VSCritDefM",L);
							}
						} else if (SN > "VIRTHONESTYCRITHIT") {
							if (SN < "VIRTIDEALISMINHEAL") {
								if (SN < "VIRTHONOURCRITDEF") {
									if (SN < "VIRTHONESTYVPPHYMAS") {
										if (SN == "VIRTHONESTYTACMAS") {
											return CalcStat("VSTacMasH",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTHONESTYVPPHYMAS") {
										if (SN > "VIRTHONESTYVPTACMAS") {
											if (SN == "VIRTHONESTYWILL") {
												return CalcStat("VSWillM",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTHONESTYVPTACMAS") {
											return CalcStat("VSVPTacMas",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSVPPhyMas",L);
									}
								} else if (SN > "VIRTHONOURCRITDEF") {
									if (SN < "VIRTHONOURTACMIT") {
										if (SN == "VIRTHONOURMORALE") {
											return CalcStat("VSMoraleH",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTHONOURTACMIT") {
										if (SN > "VIRTHONOURVPMORALE") {
											if (SN == "VIRTIDEALISMFATE") {
												return CalcStat("VSFateH",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTHONOURVPMORALE") {
											return CalcStat("VSVPMorale",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSTacMitM",L);
									}
								} else {
									return CalcStat("VSCritDefL",L);
								}
							} else if (SN > "VIRTIDEALISMINHEAL") {
								if (SN < "VIRTINNOCENCETACMIT") {
									if (SN < "VIRTIDEALISMVPMORALE") {
										if (SN == "VIRTIDEALISMMORALE") {
											return CalcStat("VSMoraleL",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTIDEALISMVPMORALE") {
										if (SN > "VIRTINNOCENCEPHYMIT") {
											if (SN == "VIRTINNOCENCERESIST") {
												return CalcStat("VSResistM",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTINNOCENCEPHYMIT") {
											return CalcStat("VSPhyMitH",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSVPMorale",L);
									}
								} else if (SN > "VIRTINNOCENCETACMIT") {
									if (SN < "VIRTJUSTICEMORALE") {
										if (SN > "VIRTINNOCENCEVPMORALE") {
											if (SN == "VIRTJUSTICEICMR") {
												return CalcStat("VSICMRH",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTINNOCENCEVPMORALE") {
											return CalcStat("VSVPMorale",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTJUSTICEMORALE") {
										if (SN > "VIRTJUSTICETACMIT") {
											if (SN == "VIRTJUSTICEVPMORALE") {
												return CalcStat("VSVPMorale",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTJUSTICETACMIT") {
											return CalcStat("VSTacMitL",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSMoraleM",L);
									}
								} else {
									return CalcStat("VSTacMitL",L);
								}
							} else {
								return CalcStat("VSInHealM",L);
							}
						} else {
							return CalcStat("VSCritHitL",L);
						}
					} else {
						return CalcStat("VSAgilityH",L);
					}
				} else {
					return CalcStat("TitLowMit",L,C);
				}
			} else if (SN > "VIRTLOYALTYARMOUR") {
				if (SN < "VSMIGHTH") {
					if (SN < "VITALITYSM") {
						if (SN < "VIRTVALOURPHYMAS") {
							if (SN < "VIRTPATIENCEPOWER") {
								if (SN < "VIRTMERCYFATE") {
									if (SN < "VIRTLOYALTYVITALITY") {
										if (SN == "VIRTLOYALTYINHEAL") {
											return CalcStat("VSInHealL",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTLOYALTYVITALITY") {
										if (SN > "VIRTLOYALTYVPMORALE") {
											if (SN == "VIRTMERCYEVADE") {
												return CalcStat("VSEvadeH",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTLOYALTYVPMORALE") {
											return CalcStat("VSVPMorale",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSVitalityH",L);
									}
								} else if (SN > "VIRTMERCYFATE") {
									if (SN < "VIRTMERCYVPMORALE") {
										if (SN == "VIRTMERCYVITALITY") {
											return CalcStat("VSVitalityL",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTMERCYVPMORALE") {
										if (SN > "VIRTPATIENCECRITHIT") {
											if (SN == "VIRTPATIENCEEVADE") {
												return CalcStat("VSEvadeM",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTPATIENCECRITHIT") {
											return CalcStat("VSCritHitL",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSVPMorale",L);
									}
								} else {
									return CalcStat("VSFateM",L);
								}
							} else if (SN > "VIRTPATIENCEPOWER") {
								if (SN < "VIRTTOLERANCERESIST") {
									if (SN < "VIRTRNKCOST") {
										if (SN == "VIRTPATIENCEVPMORALE") {
											return CalcStat("VSVPMorale",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTRNKCOST") {
										if (SN > "VIRTRNKCOSTTOT") {
											if (SN == "VIRTTOLERANCEPHYMIT") {
												return CalcStat("VSPhyMitL",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTRNKCOSTTOT") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("VirtRnkCostTot",L-1)+CalcStat("VirtRnkCost",L);
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else if (L-DblCalcDev <= 10) {
											return 1000;
										} else {
											return RoundDbl(18*L+878,-2);
										}
									}
								} else if (SN > "VIRTTOLERANCERESIST") {
									if (SN < "VIRTTOLERANCEVPMORALE") {
										if (SN == "VIRTTOLERANCETACMIT") {
											return CalcStat("VSTacMitH",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTTOLERANCEVPMORALE") {
										if (SN > "VIRTVALOURCRITHIT") {
											if (SN == "VIRTVALOURFINESSE") {
												return CalcStat("VSFinesseM",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTVALOURCRITHIT") {
											return CalcStat("VSCritHitL",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSVPMorale",L);
									}
								} else {
									return CalcStat("VSResistM",L);
								}
							} else {
								return CalcStat("VSPowerH",L);
							}
						} else if (SN > "VIRTVALOURPHYMAS") {
							if (SN < "VIRTWITPHYMAS") {
								if (SN < "VIRTWISDOMVPPHYMAS") {
									if (SN < "VIRTVALOURVPTACMAS") {
										if (SN == "VIRTVALOURVPPHYMAS") {
											return CalcStat("VSVPPhyMas",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTVALOURVPTACMAS") {
										if (SN > "VIRTWISDOMFINESSE") {
											if (SN == "VIRTWISDOMTACMAS") {
												return CalcStat("VSTacMasM",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTWISDOMFINESSE") {
											return CalcStat("VSFinesseL",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSVPTacMas",L);
									}
								} else if (SN > "VIRTWISDOMVPPHYMAS") {
									if (SN < "VIRTWISDOMWILL") {
										if (SN == "VIRTWISDOMVPTACMAS") {
											return CalcStat("VSVPTacMas",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTWISDOMWILL") {
										if (SN > "VIRTWITCRITHIT") {
											if (SN == "VIRTWITFINESSE") {
												return CalcStat("VSFinesseH",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTWITCRITHIT") {
											return CalcStat("VSCritHitM",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSWillH",L);
									}
								} else {
									return CalcStat("VSVPPhyMas",L);
								}
							} else if (SN > "VIRTWITPHYMAS") {
								if (SN < "VIRTZEALMIGHT") {
									if (SN < "VIRTWITVPPHYMAS") {
										if (SN == "VIRTWITTACMAS") {
											return CalcStat("VSTacMasL",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTWITVPPHYMAS") {
										if (SN > "VIRTWITVPTACMAS") {
											if (SN == "VIRTZEALCRITHIT") {
												return CalcStat("VSCritHitL",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTWITVPTACMAS") {
											return CalcStat("VSVPTacMas",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSVPPhyMas",L);
									}
								} else if (SN > "VIRTZEALMIGHT") {
									if (SN < "VIRTZEALVPTACMAS") {
										if (SN > "VIRTZEALPHYMAS") {
											if (SN == "VIRTZEALVPPHYMAS") {
												return CalcStat("VSVPPhyMas",L);
											} else {
												return 0;
											}
										} else if (SN == "VIRTZEALPHYMAS") {
											return CalcStat("VSPhyMasM",L);
										} else {
											return 0;
										}
									} else if (SN > "VIRTZEALVPTACMAS") {
										if (SN > "VITALITY") {
											if (SN == "VITALITYRAW") {
												return CalcStat("PntMPVitality",L)*CalcStat("ItemVitalityAdjProg",L,CalcStat("ProgBVitality",L))*CalcStat("AdjItemProgVitality",L,CalcStat("ProgBVitality",L))*N;
											} else {
												return 0;
											}
										} else if (SN == "VITALITY") {
											return FloorDbl(CalcStat("VitalityRaw",L,N));
										} else {
											return 0;
										}
									} else {
										return CalcStat("VSVPTacMas",L);
									}
								} else {
									return CalcStat("VSMightH",L);
								}
							} else {
								return CalcStat("VSPhyMasL",L);
							}
						} else {
							return CalcStat("VSPhyMasH",L);
						}
					} else if (SN > "VITALITYSM") {
						if (SN < "VSCRITDEFH") {
							if (SN < "VMMORALEPSV") {
								if (SN < "VITALITYTRAW") {
									if (SN < "VITALITYSTD") {
										if (SN == "VITALITYSMRAW") {
											return CalcStat("PntMPVitality",L)*CalcStat("ItemVitalitySmProg",L,CalcStat("ProgBVitality",L))*CalcStat("AdjItemProgVitality",L,CalcStat("ProgBVitality",L))*N;
										} else {
											return 0;
										}
									} else if (SN > "VITALITYSTD") {
										if (SN > "VITALITYSTDRAW") {
											if (SN == "VITALITYT") {
												return FloorDbl(CalcStat("VitalityTRaw",L,N));
											} else {
												return 0;
											}
										} else if (SN == "VITALITYSTDRAW") {
											return CalcStat("PntMPVitality",L)*CalcStat("ItemVitalityProg",L,CalcStat("ProgBVitality",L))*CalcStat("AdjItemProgVitality",L,CalcStat("ProgBVitality",L))*N;
										} else {
											return 0;
										}
									} else {
										return FloorDbl(CalcStat("VitalityStdRaw",L,N));
									}
								} else if (SN > "VITALITYTRAW") {
									if (SN < "VMLOW") {
										if (SN == "VMHIGH") {
											return 2;
										} else {
											return 0;
										}
									} else if (SN > "VMLOW") {
										if (SN > "VMMASTERYPSV") {
											if (SN == "VMMEDIUM") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "VMMASTERYPSV") {
											return 0.2;
										} else {
											return 0;
										}
									} else {
										return 0.6;
									}
								} else {
									return CalcStat("PntMPVitality",L)*CalcStat("TraitVitalityProg",L,CalcStat("ProgBVitality",L))*CalcStat("AdjTraitProgVitality",L,CalcStat("ProgBVitality",L))*N;
								}
							} else if (SN > "VMMORALEPSV") {
								if (SN < "VSAGILITYL") {
									if (SN < "VRNKLVLCAP") {
										if (SN == "VRNKCAP") {
											return 65;
										} else {
											return 0;
										}
									} else if (SN > "VRNKLVLCAP") {
										if (SN > "VRNKTOILVL") {
											if (SN == "VSAGILITYH") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return CalcStat("Agility",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VRNKTOILVL") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else if (L-DblCalcDev <= 38) {
												return LinFmod(1,4,78,1,38,L)*N;
											} else if (L-DblCalcDev <= 48) {
												return LinFmod(1,78,178,38,48,L)*N;
											} else if (L-DblCalcDev <= 49) {
												return LinFmod(1,178,190,48,49,L)*N;
											} else if (L-DblCalcDev <= 50) {
												return LinFmod(1,190,210,49,50,L)*N;
											} else if (L-DblCalcDev <= 51) {
												return LinFmod(1,210,222,50,51,L)*N;
											} else if (L-DblCalcDev <= 52) {
												return LinFmod(1,222,236,51,52,L)*N;
											} else if (L-DblCalcDev <= 53) {
												return LinFmod(1,236,260,52,53,L)*N;
											} else if (L-DblCalcDev <= 55) {
												return LinFmod(1,260,292,53,55,L)*N;
											} else if (L-DblCalcDev <= 68) {
												return LinFmod(1,292,396,55,68,L)*N;
											} else if (L-DblCalcDev <= 69) {
												return LinFmod(1,396,401,68,69,L)*N;
											} else if (L-DblCalcDev <= 70) {
												return LinFmod(1,401,461,69,70,L)*N;
											} else {
												return LinFmod(1,461,706,70,119,L)*N;
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 4) {
											return 2;
										} else if (L-DblCalcDev <= 110) {
											return FloorDbl(L/2);
										} else {
											return L-55;
										}
									}
								} else if (SN > "VSAGILITYL") {
									if (SN < "VSARMOURH") {
										if (SN == "VSAGILITYM") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("Agility",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "VSARMOURH") {
										if (SN > "VSARMOURL") {
											if (SN == "VSARMOURM") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return RoundDbl(CalcStat("ArmourLowRaw",CalcStat("VRnkToILvl",L),"LG")*CalcStat("VMMedium",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VSARMOURL") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return RoundDbl(CalcStat("ArmourLowRaw",CalcStat("VRnkToILvl",L),"LG")*CalcStat("VMLow",L));
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return RoundDbl(CalcStat("ArmourLowRaw",CalcStat("VRnkToILvl",L),"LG")*CalcStat("VMHigh",L));
										}
									}
								} else {
									if (L-DblCalcDev <= 0) {
										return 0;
									} else {
										return CalcStat("Agility",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
									}
								}
							} else {
								return 0.3;
							}
						} else if (SN > "VSCRITDEFH") {
							if (SN < "VSFATEL") {
								if (SN < "VSCRITHITM") {
									if (SN < "VSCRITDEFM") {
										if (SN == "VSCRITDEFL") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("CritDef",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "VSCRITDEFM") {
										if (SN > "VSCRITHITH") {
											if (SN == "VSCRITHITL") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return CalcStat("CritHit",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VSCRITHITH") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("CritHit",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return CalcStat("CritDef",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
										}
									}
								} else if (SN > "VSCRITHITM") {
									if (SN < "VSEVADEL") {
										if (SN == "VSEVADEH") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("Evade",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "VSEVADEL") {
										if (SN > "VSEVADEM") {
											if (SN == "VSFATEH") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return CalcStat("Fate",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VSEVADEM") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("Evade",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return CalcStat("Evade",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
										}
									}
								} else {
									if (L-DblCalcDev <= 0) {
										return 0;
									} else {
										return CalcStat("CritHit",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
									}
								}
							} else if (SN > "VSFATEL") {
								if (SN < "VSICMRH") {
									if (SN < "VSFINESSEH") {
										if (SN == "VSFATEM") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("Fate",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "VSFINESSEH") {
										if (SN > "VSFINESSEL") {
											if (SN == "VSFINESSEM") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return CalcStat("Finesse",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VSFINESSEL") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("Finesse",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return CalcStat("Finesse",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
										}
									}
								} else if (SN > "VSICMRH") {
									if (SN < "VSINHEALH") {
										if (SN > "VSICMRL") {
											if (SN == "VSICMRM") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return CalcStat("ICMR",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VSICMRL") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("ICMR",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "VSINHEALH") {
										if (SN > "VSINHEALL") {
											if (SN == "VSINHEALM") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return CalcStat("InHeal",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VSINHEALL") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("InHeal",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return CalcStat("InHeal",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
										}
									}
								} else {
									if (L-DblCalcDev <= 0) {
										return 0;
									} else {
										return CalcStat("ICMR",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
									}
								}
							} else {
								if (L-DblCalcDev <= 0) {
									return 0;
								} else {
									return CalcStat("Fate",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
								}
							}
						} else {
							if (L-DblCalcDev <= 0) {
								return 0;
							} else {
								return CalcStat("CritDef",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
							}
						}
					} else {
						return FloorDbl(CalcStat("VitalitySmRaw",L,N));
					}
				} else if (SN > "VSMIGHTH") {
					if (SN < "WARDENCDBASEAGILITY") {
						if (SN < "VSTACMASM") {
							if (SN < "VSPHYMITL") {
								if (SN < "VSMORALEM") {
									if (SN < "VSMIGHTM") {
										if (SN == "VSMIGHTL") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("Might",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "VSMIGHTM") {
										if (SN > "VSMORALEH") {
											if (SN == "VSMORALEL") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return CalcStat("MoraleSm",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VSMORALEH") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("MoraleSm",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return CalcStat("Might",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
										}
									}
								} else if (SN > "VSMORALEM") {
									if (SN < "VSPHYMASL") {
										if (SN == "VSPHYMASH") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("PhyMas",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "VSPHYMASL") {
										if (SN > "VSPHYMASM") {
											if (SN == "VSPHYMITH") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return CalcStat("PhyMit",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VSPHYMASM") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("PhyMas",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return CalcStat("PhyMas",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
										}
									}
								} else {
									if (L-DblCalcDev <= 0) {
										return 0;
									} else {
										return CalcStat("MoraleSm",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
									}
								}
							} else if (SN > "VSPHYMITL") {
								if (SN < "VSRESISTH") {
									if (SN < "VSPOWERH") {
										if (SN == "VSPHYMITM") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("PhyMit",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "VSPOWERH") {
										if (SN > "VSPOWERL") {
											if (SN == "VSPOWERM") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return CalcStat("Power",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VSPOWERL") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("Power",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return CalcStat("Power",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
										}
									}
								} else if (SN > "VSRESISTH") {
									if (SN < "VSRESISTM") {
										if (SN == "VSRESISTL") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("Resist",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "VSRESISTM") {
										if (SN > "VSTACMASH") {
											if (SN == "VSTACMASL") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return CalcStat("TacMas",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VSTACMASH") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("TacMas",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return CalcStat("Resist",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
										}
									}
								} else {
									if (L-DblCalcDev <= 0) {
										return 0;
									} else {
										return CalcStat("Resist",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
									}
								}
							} else {
								if (L-DblCalcDev <= 0) {
									return 0;
								} else {
									return CalcStat("PhyMit",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
								}
							}
						} else if (SN > "VSTACMASM") {
							if (SN < "VSWILLH") {
								if (SN < "VSVITALITYL") {
									if (SN < "VSTACMITL") {
										if (SN == "VSTACMITH") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("TacMit",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "VSTACMITL") {
										if (SN > "VSTACMITM") {
											if (SN == "VSVITALITYH") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return CalcStat("VitalitySm",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VSTACMITM") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("TacMit",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return CalcStat("TacMit",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
										}
									}
								} else if (SN > "VSVITALITYL") {
									if (SN < "VSVPMORALE") {
										if (SN == "VSVITALITYM") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("VitalitySm",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "VSVPMORALE") {
										if (SN > "VSVPPHYMAS") {
											if (SN == "VSVPTACMAS") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return CalcStat("TacMas",CalcStat("VRnkToILvl",L),CalcStat("VMMasteryPsv",L));
												}
											} else {
												return 0;
											}
										} else if (SN == "VSVPPHYMAS") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("PhyMas",CalcStat("VRnkToILvl",L),CalcStat("VMMasteryPsv",L));
											}
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return CalcStat("MoraleStd",CalcStat("VRnkToILvl",L),CalcStat("VMMoralePsv",L));
										}
									}
								} else {
									if (L-DblCalcDev <= 0) {
										return 0;
									} else {
										return CalcStat("VitalitySm",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
									}
								}
							} else if (SN > "VSWILLH") {
								if (SN < "WARDENCDAGILITYTOPARRY") {
									if (SN < "VSWILLM") {
										if (SN == "VSWILLL") {
											if (L-DblCalcDev <= 0) {
												return 0;
											} else {
												return CalcStat("Will",CalcStat("VRnkToILvl",L),CalcStat("VMLow",L));
											}
										} else {
											return 0;
										}
									} else if (SN > "VSWILLM") {
										if (SN > "WARDENCDAGILITYTOCRITHIT") {
											if (SN == "WARDENCDAGILITYTOEVADE") {
												return 3;
											} else {
												return 0;
											}
										} else if (SN == "WARDENCDAGILITYTOCRITHIT") {
											return 1;
										} else {
											return 0;
										}
									} else {
										if (L-DblCalcDev <= 0) {
											return 0;
										} else {
											return CalcStat("Will",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
										}
									}
								} else if (SN > "WARDENCDAGILITYTOPARRY") {
									if (SN < "WARDENCDARMOURTOPHYMIT") {
										if (SN > "WARDENCDAGILITYTOPHYMAS") {
											if (SN == "WARDENCDARMOURTOOFMIT") {
												return 0.2;
											} else {
												return 0;
											}
										} else if (SN == "WARDENCDAGILITYTOPHYMAS") {
											return 3;
										} else {
											return 0;
										}
									} else if (SN > "WARDENCDARMOURTOPHYMIT") {
										if (SN > "WARDENCDARMOURTOTACMIT") {
											if (SN == "WARDENCDARMOURTYPE") {
												return 2;
											} else {
												return 0;
											}
										} else if (SN == "WARDENCDARMOURTOTACMIT") {
											return 0.2;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									return 2;
								}
							} else {
								if (L-DblCalcDev <= 0) {
									return 0;
								} else {
									return CalcStat("Will",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
								}
							}
						} else {
							if (L-DblCalcDev <= 0) {
								return 0;
							} else {
								return CalcStat("TacMas",CalcStat("VRnkToILvl",L),CalcStat("VMMedium",L));
							}
						}
					} else if (SN > "WARDENCDBASEAGILITY") {
						if (SN < "WARDENCDMIGHTTOPARRY") {
							if (SN < "WARDENCDBASEWILL") {
								if (SN < "WARDENCDBASEMORALE") {
									if (SN < "WARDENCDBASEICMR") {
										if (SN == "WARDENCDBASEFATE") {
											return CalcStat("ClassBaseMainF",L);
										} else {
											return 0;
										}
									} else if (SN > "WARDENCDBASEICMR") {
										if (SN > "WARDENCDBASEICPR") {
											if (SN == "WARDENCDBASEMIGHT") {
												return CalcStat("ClassBaseMainH",L);
											} else {
												return 0;
											}
										} else if (SN == "WARDENCDBASEICPR") {
											return CalcStat("ClassBaseICPR",L);
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseICMRH",L);
									}
								} else if (SN > "WARDENCDBASEMORALE") {
									if (SN < "WARDENCDBASENCPR") {
										if (SN == "WARDENCDBASENCMR") {
											return CalcStat("ClassBaseNCMRH",L);
										} else {
											return 0;
										}
									} else if (SN > "WARDENCDBASENCPR") {
										if (SN > "WARDENCDBASEPOWER") {
											if (SN == "WARDENCDBASEVITALITY") {
												return CalcStat("ClassBaseMainC",L);
											} else {
												return 0;
											}
										} else if (SN == "WARDENCDBASEPOWER") {
											if (L-DblCalcDev <= 120) {
												return CalcStat("ClassBasePowerL",L);
											} else {
												return CalcStat("ClassBasePowerL",120);
											}
										} else {
											return 0;
										}
									} else {
										return CalcStat("ClassBaseNCPR",L);
									}
								} else {
									if (L-DblCalcDev <= 120) {
										return CalcStat("ClassBaseMoraleHb",L);
									} else {
										return CalcStat("ClassBaseMoraleHb",120);
									}
								}
							} else if (SN > "WARDENCDBASEWILL") {
								if (SN < "WARDENCDFATETOICPR") {
									if (SN < "WARDENCDFATETOCRITHIT") {
										if (SN == "WARDENCDCANBLOCK") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "WARDENCDFATETOCRITHIT") {
										if (SN > "WARDENCDFATETOFINESSE") {
											if (SN == "WARDENCDFATETOICMR") {
												return 1.5;
											} else {
												return 0;
											}
										} else if (SN == "WARDENCDFATETOFINESSE") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 2.5;
									}
								} else if (SN > "WARDENCDFATETOICPR") {
									if (SN < "WARDENCDFATETOTACMIT") {
										if (SN > "WARDENCDFATETONCPR") {
											if (SN == "WARDENCDFATETORESIST") {
												return 1;
											} else {
												return 0;
											}
										} else if (SN == "WARDENCDFATETONCPR") {
											return 24;
										} else {
											return 0;
										}
									} else if (SN > "WARDENCDFATETOTACMIT") {
										if (SN > "WARDENCDHASPOWER") {
											if (SN == "WARDENCDMIGHTTOBLOCK") {
												return 3;
											} else {
												return 0;
											}
										} else if (SN == "WARDENCDHASPOWER") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else {
									return 1.71;
								}
							} else {
								return CalcStat("ClassBaseMainA",L);
							}
						} else if (SN > "WARDENCDMIGHTTOPARRY") {
							if (SN < "WARDINGLOREPHYMIT") {
								if (SN < "WARDENCDVITALITYTONCMR") {
									if (SN < "WARDENCDPHYMITTOOFMIT") {
										if (SN == "WARDENCDMIGHTTOPHYMAS") {
											return 2;
										} else {
											return 0;
										}
									} else if (SN > "WARDENCDPHYMITTOOFMIT") {
										if (SN > "WARDENCDTACMASTOOUTHEAL") {
											if (SN == "WARDENCDVITALITYTOMORALE") {
												return 5;
											} else {
												return 0;
											}
										} else if (SN == "WARDENCDTACMASTOOUTHEAL") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 1;
									}
								} else if (SN > "WARDENCDVITALITYTONCMR") {
									if (SN < "WARDENCDWILLTORESIST") {
										if (SN == "WARDENCDVITALITYTORESIST") {
											return 1;
										} else {
											return 0;
										}
									} else if (SN > "WARDENCDWILLTORESIST") {
										if (SN > "WARDENCDWILLTOTACMIT") {
											if (SN == "WARDINGLOREMIT") {
												if (L-DblCalcDev <= 105) {
													return 1.6*CalcStat("PntMPMitigation",L)*CalcStat("ItemProg",L,CalcStat("ProgBMitigation",L));
												} else if (L-DblCalcDev <= 119) {
													return CalcStat("RatMitigationT",L,1.2);
												} else if (L-DblCalcDev <= 120) {
													return CalcStat("RatMitigationT",L,1.6);
												} else if (L-DblCalcDev <= 129) {
													return CalcStat("RatMitigationT",L,1.2);
												} else {
													return CalcStat("RatMitigationT",L,1.6);
												}
											} else {
												return 0;
											}
										} else if (SN == "WARDENCDWILLTOTACMIT") {
											return 1;
										} else {
											return 0;
										}
									} else {
										return 2;
									}
								} else {
									return 7.2;
								}
							} else if (SN > "WARDINGLOREPHYMIT") {
								if (SN < "WRDCRITDEFRAW") {
									if (SN < "WILL") {
										if (SN == "WARDINGLORETACMIT") {
											return CalcStat("WardingLoreMit",L);
										} else {
											return 0;
										}
									} else if (SN > "WILL") {
										if (SN > "WILLT") {
											if (SN == "WRDCRITDEF") {
												return RoundDbl(CalcStat("WrdCritDefRaw",L));
											} else {
												return 0;
											}
										} else if (SN == "WILLT") {
											return CalcStat("MainT",L,N);
										} else {
											return 0;
										}
									} else {
										return CalcStat("Main",L,N);
									}
								} else if (SN > "WRDCRITDEFRAW") {
									if (SN < "WRDCRITPROTCRITDEFP") {
										if (SN > "WRDCRITPROTBASE") {
											if (SN == "WRDCRITPROTCHOICE") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else if (L-DblCalcDev <= 120) {
													return DataTableValue([1,2,3,4,7,2],L);
												} else {
													return 0;
												}
											} else {
												return 0;
											}
										} else if (SN == "WRDCRITPROTBASE") {
											return 0.01*N;
										} else {
											return 0;
										}
									} else if (SN > "WRDCRITPROTCRITDEFP") {
										if (SN > "WRDPHYMAS") {
											if (SN == "WRDPHYMASCHOICE") {
												if (L-DblCalcDev <= 0) {
													return 0;
												} else {
													return DataTableValue([0.4,0.8,1.2,1.6,2],L);
												}
											} else {
												return 0;
											}
										} else if (SN == "WRDPHYMAS") {
											return CalcStat("PhyMasT",L,CalcStat("WrdPhyMasChoice",N));
										} else {
											return 0;
										}
									} else {
										return CalcStat("WrdCritProtBase",L,CalcStat("WrdCritProtChoice",N));
									}
								} else {
									if (L-DblCalcDev <= 105) {
										return 20.2*L;
									} else if (L-DblCalcDev <= 115) {
										return LinFmod(CalcStat("WrdCritDefRaw",105),2,4,106,115,L,-1);
									} else if (L-DblCalcDev <= 116) {
										return ExpFmod(CalcStat("WrdCritDefRaw",115),116,20.0025,L);
									} else if (L-DblCalcDev <= 120) {
										return ExpFmod(CalcStat("WrdCritDefRaw",116),117,5.5004,L);
									} else if (L-DblCalcDev <= 121) {
										return ExpFmod(CalcStat("WrdCritDefRaw",120),121,20.0025,L);
									} else if (L-DblCalcDev <= 125) {
										return ExpFmod(CalcStat("WrdCritDefRaw",121),122,5.5004,L);
									} else if (L-DblCalcDev <= 126) {
										return ExpFmod(CalcStat("WrdCritDefRaw",125),126,20.0025,L);
									} else {
										return ExpFmod(CalcStat("WrdCritDefRaw",126),127,5.5004,L);
									}
								}
							} else {
								return CalcStat("WardingLoreMit",L);
							}
						} else {
							return 2;
						}
					} else {
						return CalcStat("ClassBaseMainJ",L);
					}
				} else {
					if (L-DblCalcDev <= 0) {
						return 0;
					} else {
						return CalcStat("Might",CalcStat("VRnkToILvl",L),CalcStat("VMHigh",L));
					}
				}
			} else {
				return CalcStat("VSArmourM",L);
			}
		} else {
			if (L-DblCalcDev <= 21) {
				return 1;
			} else if (L-DblCalcDev <= 33) {
				return 2;
			} else {
				return 3;
			}
		}
	} else {
		return 2.5;
	}
}

// Support functions for CalcStat. These consist of implementations of more complex calculation types, decode methods for parameter "C" and rounding/min/max/compare functions for floating point numbers.

// ****************** Calculation Type support functions ******************

// DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
// DataTableValue: Takes a value from an array table.

function DataTableValue(vDataArray, lIndex)
{
	return (lIndex <= 1 ? vDataArray[0] : (lIndex >= vDataArray.length ? vDataArray[vDataArray.length-1] : vDataArray[lIndex-1]));
}

// EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
// ExpFmod: Exponential function based on percentage.
// Common percentage values are around ~5.5% for between levels and ~20% jumps between level segments.

function ExpFmod(dVal, dLstart, dPlvl, dLvl)
{
	return (dLvl-dLstart+1 <= DblCalcDev ? dVal : dVal*Math.pow(1+dPlvl/100,dLvl-dLstart+1));
}

// PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
// CalcPercAB: Calculates the percentage out of a rating based on the AB formula.

function CalcPercAB(dA, dB, dPCap, dR)
{
	if (dR <= DblCalcDev)
		return 0;
	else {
		var dResult = dA/(1+dB/dR);
		return (dResult >= dPCap-DblCalcDev ? dPCap : dResult);
	}
}

// RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
// CalcRatAB: Calculates the rating out of a percentage based on the AB formula.

function CalcRatAB(dA, dB, dCapR, dP)
{
	if (dP <= DblCalcDev)
		return 0;
	else {
		var dResult = dB/(dA/dP-1);
		return (dResult >= dCapR-DblCalcDev ? dCapR : dResult);
	}
}

// TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
// LinFmod: Linear line function between 2 points with some optional modifications.
// Connects point (dLstart,dVal*dFstart) with (dLend,dVal*dFend).
// Usually used with dVal=1 and dFstart/dFend containing unrelated points or dVal=# and dFstart/dFend containing multiplier factors.
// Modification for in-between points on the line: rounding.

function LinFmod(dVal, dFstart, dFend, dLstart, dLend, dLvl, vDec)
{
	if (dLstart-DblCalcDev <= dLvl && dLvl <= dLstart+DblCalcDev)
		return dVal*dFstart;
	else if (dLend-DblCalcDev <= dLvl && dLvl <= dLend+DblCalcDev)
		return dVal*dFend;
	else if (typeof vDec === "undefined")
		return dVal*(dFstart*(dLend-dLvl)+(dLvl-dLstart)*dFend)/(dLend-dLstart);
	else if (-DblCalcDev <= vDec && vDec <= DblCalcDev)
		return Math.floor(dVal*(dFstart*(dLend-dLvl)+(dLvl-dLstart)*dFend)/(dLend-dLstart)+0.5+DblCalcDev);
	else
		return Math.floor((dVal*(dFstart*(dLend-dLvl)+(dLvl-dLstart)*dFend)/(dLend-dLstart))*Math.pow(10,vDec)+0.5+DblCalcDev)/Math.pow(10,vDec);
}

// ****************** Parameter "C" decode support functions ******************

// ArmCodeIndex: returns a specified index from an Armour Code.
// sACode string:
// 1st position: H=heavy, M=medium, L=light
// 2nd position: H=head, S=shoulders, CL=cloak/back, C=chest, G=gloves, L=leggings, B=boots, Sh=shield
// 3rd position: W=white/common, Y=yellow/uncommon, P=purple/rare, T=teal/blue/incomparable, G=gold/legendary/epic
// Note: no such thing exists as a heavy, medium or light cloak, so no H/M/L in cloak codes (cloaks go automatically in the M class since U23, although historically this was L)

function ArmCodeIndex(sACode, iI)
{
	var armourcode = sACode.trim().toUpperCase();

	// get positional codes and make some corrections
	var sArmClass = armourcode.substr(0,1);
	var sArmType = armourcode.substr(1,1);
	var sArmCol = armourcode.substr(2,1);
	if (sArmType == "S" && sArmCol == "H") {
		sArmType = "SH";
		sArmCol = armourcode.substr(3,1);
	} else if (sArmClass == "C" && sArmType == "L") {
		sArmClass = "M";
		sArmType = "CL";
	} else
		sArmType = " "+sArmType;
	
	switch (iI) {
		case 1:
			var ind = "HML".indexOf(sArmClass);
			return (ind == -1 ? 0 : ind+1);
		case 2:
			var ind = " H SCL C G L BSH".indexOf(sArmType);
			return (ind == -1 ? 0 : (ind/2)+1);
		case 3:
			var ind = "WYPTG".indexOf(sArmCol);
			return (ind == -1 ? 0 : ind+1);
		default:
			return 0;
	}
}

// RomanRankDecode: converts a string with a Roman number in characters, to an integer number.
// used for Legendary Item Title calculation.

var RomanRankChars = ["M","CM","D","CD","C","XC","L","XL","X","IX","V","IV","I"];
var RomanRankValues = [1000,900,500,400,100,90,50,40,10,9,5,4,1];

function RomanRankDecode(sNumber)
{
	if (typeof sNumber === "string") {
		var sn = sNumber.trim().toUpperCase();
		if (sn.length > 0)
			for (ind = 0, len = RomanRankChars.length; ind < len; ind++)
				if (sn.indexOf(RomanRankChars[ind]) == 0)
					return RomanRankValues[ind]+RomanRankDecode(sn.slice(RomanRankChars[ind].length));
	}
	return 0;
}

// ****************** Misc. floating point support functions ******************

// Misc. functions for floating point: rounding etc.
// For roundings: vDec is number of decimals.

function RoundDbl(dNum, vDec)
{
	if (typeof vDec === "undefined")
		return Math.floor(dNum+0.5+DblCalcDev);
	else
		return ((-DblCalcDev <= vDec && vDec <= DblCalcDev) ? Math.floor(dNum+0.5+DblCalcDev) : Math.floor(dNum*Math.pow(10,vDec)+0.5+DblCalcDev)/Math.pow(10,vDec));
}

function FloorDbl(dNum, vDec)
{
	if (typeof vDec === "undefined")
		return Math.floor(dNum+DblCalcDev);
	else
		return ((-DblCalcDev <= vDec && vDec <= DblCalcDev) ? Math.floor(dNum+DblCalcDev) : Math.floor(dNum*Math.pow(10,vDec)+DblCalcDev)/Math.pow(10,vDec));
}
